process VTP_chart =
     { integer NUL_CODE, LIN_CODE, TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A; }
     ( ? 
     )
   (| (| P_statechart_V3{} % may be replaced by:  P_statechart_V2{} %
       | CONTEXT{NUL_CODE, LIN_CODE}
       | SCREEN{TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A}
       | BACK{}
       |)/ IP_currentState, IQ1_currentState, IQ2_currentState, V2, V1, C2, C1, HVISU, H_0, a, b , i, m, n  |)
   where 
     event HE;
   use CONTEXT_LIB, SCREEN_LIB; 
     
     
process P_statechart_V1 =  %  First version %
   ( ? event HE;
       event a, b, i, j, m, n;
     ! integer IP_currentState;
       integer IQ1_currentState;
       integer IQ2_currentState;
   )
   (| (| case P_currentState in
           {#Q}: (| P_nextState ::= (#R when a) default (#S when b) |)
           {#R}: (| P_nextState ::= #S when b |)
           {#S}: (| P_nextState ::= #Q when a |)
         end
       | P_nextState ::= defaultvalue P_currentState
       | P_currentState := P_nextState $ init #Q
       | P_currentState ^= HE
       |)
    | clk_Q_chart := when (P_currentState = #Q)
    | start_Q_chart := when (P_nextState = #Q) when (P_currentState /= #Q)
    | Q1_State ^= Q2_State ^= clk_Q_chart ^+ start_Q_chart
    | (| case Q1_State in
           {#U}: (| Q1_newState ::= #V when i |)
           {#V}: (| Q1_newState ::= #U when j |)
         end
       | Q1_newState ::= defaultvalue Q1_State
       | Q1_newState ^= Q1_State
       | Q1_nextState := (#U when start_Q_chart) default Q1_newState
       | Q1_State := Q1_nextState $ init #U
       | Q1_currentState := Q1_State when clk_Q_chart
       |)
    | (| case Q2_State in
           {#X}: (| Q2_newState ::= #Y when m |)
           {#Y}: (| Q2_newState ::= #Z when n |)
           {#Z}: (| Q2_newState ::= #X when j |)
         end
       | Q2_newState ::= defaultvalue Q2_State
       | Q2_newState ^= Q2_State
       | Q2_nextState := (#X when start_Q_chart) default Q2_newState
       | Q2_State := Q2_nextState $ init #X
       | Q2_currentState := Q2_State when clk_Q_chart
       | IP_currentState := integer(P_currentState)
       | IQ1_currentState := integer(Q1_currentState)
       | IQ2_currentState := integer(Q2_currentState)
       |)
    |)
   where     
     type P_states = enum (Q, R, S);
     type Q1_states = enum (U, V);
     type Q2_states = enum (X, Y, Z);
     P_states P_currentState;
     Q1_states Q1_currentState;
     Q2_states Q2_currentState;
     shared P_states P_nextState;
     event clk_Q_chart, start_Q_chart;
     Q1_states Q1_State, Q1_nextState;
     shared Q1_states Q1_newState;
     
     Q2_states Q2_State, Q2_nextState;
     shared Q2_states Q2_newState;
   end;

   process P_statechart_V2 =  %  V2 with statevar %
   ( ? event HE;
       event a, b, i, j, m, n;
     ! integer IP_currentState;
       integer IQ1_currentState;
       integer IQ2_currentState;
   )
   (| (| P_currentState := P_State? when HE
       | case P_currentState in
           {#Q}: (| P_State ::= (#R when a) default (#S when b) |)
           {#R}: (| P_State ::= #S when b |)
           {#S}: (| P_State ::= #Q when a
                  | start_Q_chart := a
                  |)
         end
       |)
    | clk_Q_chart := when (P_currentState = #Q)
    | (| Q1_currentState := Q1_State? when clk_Q_chart
       | Q1_State ::= #U when start_Q_chart
       | case Q1_State? when clk_Q_chart % Q1_currentState% in
           {#U}: (| Q1_State ::= #V when i |)
           {#V}: (| Q1_State ::= #U when j |)
         end
       |)
    | (| Q2_currentState := Q2_State? when clk_Q_chart
       | Q2_State ::= #X when start_Q_chart
       | case Q2_currentState in
           {#X}: (| Q2_State ::= #Y when m |)
           {#Y}: (| Q2_State ::= #Z when n |)
           {#Z}: (| Q2_State ::= #X when j |)
         end
       |)
   
    | IP_currentState := integer(P_currentState)
    | IQ1_currentState := integer(Q1_currentState)
    | IQ2_currentState := integer(Q2_currentState)
    |)
   where
     type P_states = enum (Q, R, S);
     type Q1_states = enum (U, V);
     type Q2_states = enum (X, Y, Z);
     statevar P_states P_State init #Q;
     statevar Q1_states Q1_State init #U;
     statevar Q2_states Q2_State init #X;
     event clk_Q_chart, start_Q_chart;
     P_states P_currentState;
     Q1_states Q1_currentState;
     Q2_states Q2_currentState;
   end;
     
 automaton  P_statechart_V3 =
   ( ? event HE;
       event a, b, i, j, m, n;
     ! integer IP_currentState, IQ1_currentState, IQ2_currentState;
   )
  (| (| (| Automaton_Initial_State(Q)
         | Automaton_Transition (Q, R, a, 1)
         | Automaton_Transition (Q, S, b)
         | Automaton_Transition (R, S, b)
         | Automaton_Transition (S, Q, a)
         |)
      | IP_currentState := (0 when Automaton_IsIn(Q))  default (1 when Automaton_IsIn(R)) default ( 2 when Automaton_IsIn(S) )  default -1
      | IP_currentState ^= Automaton_Clock ()
      |)
   | InQ := when Automaton_IsIn(Q) when HE
   | Q1_chart(InQ) 
   | Q2_chart(InQ)
   |)
  where 
    event InQ;
    label Q, R, S;
    automaton Q1_chart =
       ( ? event Tick;
         ! integer IQ1_currentState;
       )
       (| (| Automaton_Initial_State(U)
           | Automaton_Transition (U, V, i)
           | Automaton_Transition (V, U, j)
           |)
        | IQ1_currentState := (0 when Automaton_IsIn(U)) default ( 1 when Automaton_IsIn(V))  default -1
        | IQ1_currentState ^=  Automaton_Clock ()
        |)
       where
         label U, V;
    end;
    automaton Q2_chart =
       ( ? event Tick;
         ! integer IQ2_currentState;
       )
       (| (| Automaton_Initial_State(X)
           | Automaton_Transition (X, Y, m)
           | Automaton_Transition (Y, Z, n)
           | Automaton_Transition (Z, X, j)            
           |)
        | IQ2_currentState := (0 when Automaton_IsIn(X)) default (1 when Automaton_IsIn(Y)) default (2 when Automaton_IsIn(Z)) default -1
        | IQ2_currentState ^=  Automaton_Clock ()
        |)
       where
         label X, Y, Z;
    end;
end;
     

   process BACK =
        ( ? integer IP_currentState; 
            integer IQ1_currentState;
            integer IQ2_currentState;
          ! event HVISU; 
            boolean C1; 
            boolean C2;
            boolean C3;
            integer V1; 
            integer V2;
            integer V3;
        )
      (| HVISU := IP_currentState ^+ IQ1_currentState + IQ2_currentState
       | C1 := ^IP_currentState
       | C2 := ^IQ1_currentState
       | C3 := ^IQ2_currentState
       | V1 := IP_currentState
       | V2 := IQ1_currentState
       | V3 := IQ2_currentState
       |)
   ; 
   process CONTEXT =
        { integer NUL_CODE, LIN_CODE; }
        ( ? 
          ! event HE; event H_0; 
            event a, b, i, j, m ,n;
        )
     (| (| HE := when CTICK | CTICK := RTICK() |  H_0 := HE |)
      | (| H := HE | SCAN{} |) where event H; end
      |)
     where 
       boolean CTICK;
       process RTICK = ( ! boolean CTICK; );
       process SCAN =
           ( ? event H;
             ! event a, b, i, j, m ,n;
           )
         (| CA := GETCSIG(H, RCA()) | a := when CA
          | CB := GETCSIG(H, RCB()) | b := when CB
          | CI := GETCSIG(H, RCI()) | i := when CI
          | CJ := GETCSIG(H, RCJ()) | j := when CJ
          | CM := GETCSIG(H, RCM()) | m := when CM
          | CN := GETCSIG(H, RCN()) | n := when CN
          |)
         where 
         boolean CA, CB, CI, CJ, CM, CN;
         process GETCSIG =
              ( ? event H; 
                  boolean C_ON;
                ! boolean _ON_;
              )
            (| H ^= C_ON | _ON_ := C_ON |)
         ; 
         process RCA = ( ! boolean CA; ); 
         process RCB = ( ! boolean CB; );
         process RCI = ( ! boolean CI; );         
         process RCJ = ( ! boolean CJ; );
         process RCM = ( ! boolean CM; );
         process RCN = ( ! boolean CN; );
         end ; 
      end ; 
     
   process SCREEN =
        { integer TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A; }
        ( ? event H_0; 
            event HVISU; 
            boolean C1; 
            boolean C2; 
            boolean C3; 
            integer V1; 
            integer V2;
            integer V3;
        )
     (| 
       (| WP_STATE(SCREEN, V1 when C1)
        | (| HE := HVISU | INITSCREEN{} |) where event HE; end
        | WQ1_STATE(SCREEN, V2 when C2)
        | WQ2_STATE(SCREEN, V3 when C3)
        |)/ SCREEN
     |)
     where 
       integer X, Z_V1, SCREEN, Z_V2;
       process WP_STATE=(? integer SCREEN, V;!);
       process WQ1_STATE=(? integer SCREEN, V;!);
       process WQ2_STATE=(? integer SCREEN, V;!);
     end ; 
     boolean C1, C2, C3; 
     integer IP_currentState, IQ1_currentState, IQ2_currentState;
     event a, b ,i, j, m, n;
     integer V1, V2, V3; 
     event H_0, HVISU;
   end
; 
