
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import SignalLibraries.Java.graphical.*;

public class SimuVTP_chart extends SimuC
{
    public static final int BUTTON_HEIGHT = 80;
    public static final int CANVAS_HEIGHT = 350;
    public static final int CANVAS_WIDTH = 200; 

    private String TP_STATE[] = {"Q", "R", "S"};
    private String TQ1_STATE[] = {"U", "V"};
    private String TQ2_STATE[] = {"X", "Y", "Z"};

    private int Frame, p1, p12, p11, pm, p113, ps, pq1, pq2, px;

    // QUIT, TICK
    private int ButQuit, ButTick;  

    // inputs
    private int butClockA, butClockB,  butClockI, butClockJ, butClockM, butClockN;
    private MYListener al, bl, il, jl, ml, nl; 

    // outputs
    private int ButP, ButQ1, ButQ2;
    private int lab3, lab4, lab5;

    private int  widgdisplay; // canvas
    private paceMakerListener lpm;

    private void mkGraphicalWindows()
    {
        int vsep = BUTTON_HEIGHT/16;

        Frame = gw.createFrame(CANVAS_WIDTH, CANVAS_HEIGHT);
        p1 =  gw.createPanel(Frame, Direction.horiz);

	// LEFT PANEL (inputs)
        p11 = gw.createPanel(p1, Direction.vertic);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vsep);
	al = new MYListener();
        butClockA = gw.mkButtonWithoutAction(p113);
	gw.setActionTo(butClockA, al);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vsep);
	bl = new MYListener();
        butClockB = gw.mkButtonWithoutAction(p113);
	gw.setActionTo(butClockB, bl);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vsep);
	il = new MYListener();
        butClockI = gw.mkButtonWithoutAction(p113);
	gw.setActionTo(butClockI, il);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vsep);
	jl = new MYListener();
        butClockJ = gw.mkButtonWithoutAction(p113);
	gw.setActionTo(butClockJ, jl);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vsep);
	ml = new MYListener();
        butClockM = gw.mkButtonWithoutAction(p113);
	gw.setActionTo(butClockM, ml);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vsep);
	nl = new MYListener();
        butClockN = gw.mkButtonWithoutAction(p113);
	gw.setActionTo(butClockN, nl);

	// RIGHT PANEL (outputs)
	p12 = gw.createPanel(p1, Direction.vertic);
	px = gw.createPanelBorder(p12,Direction.horiz, vsep);

	// P State
	ps = gw.createPanelBorder(p12,Direction.horiz, vsep);
        lab3 = gw.createLabel(ps);
	ButP = gw.mkButtonWithoutAction(ps);

	// Q1 State
	pq1 = gw.createPanelBorder(p12,Direction.horiz, vsep);
        lab4 = gw.createLabel(pq1);
	ButQ1 = gw.mkButtonWithoutAction(pq1);

	// Q2 State
	pq2 = gw.createPanelBorder(p12,Direction.horiz, vsep);
        lab5 = gw.createLabel(pq2); 
	ButQ2 = gw.mkButtonWithoutAction(pq2);

	// TICK/QUIT.
	int panel  = gw.createPanelBorder(Frame, Direction.horiz, 2);
	pm = gw.createPanelBorder(panel,Direction.horiz, 0); 
	lpm = new paceMakerListener();
        ButTick = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButTick, lpm);
        ButQuit = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButQuit, lpm);
    }

    public boolean RTICK () 
    {
	boolean b ;
	b = lpm.rtick();
	if (!b && RSTOP()) WSTOP(0);
	return b;
    }
    public boolean RSTOP () { return lpm.rstop(); }
    public void WSTOP(int code) { gw.quitAppli(); }
    public int GET_DISPLAY () { return widgdisplay;}

    public boolean RCA () { return al.read();}
    public boolean RCB () { return bl.read();}
    public boolean RCI () { return il.read();}
    public boolean RCJ () { return jl.read();}
    public boolean RCM () { return ml.read();}
    public boolean RCN () { return nl.read();}

    private int WP_STATE_previous =-1, WQ1_STATE_previous=-1, WQ2_STATE_previous=-1; 
    public void WP_STATE(int screen, int code)
    {
	if (WP_STATE_previous != code)
	    {
		String x = TP_STATE[code];
		gw.putButtonLabel(ButP,x);
		WP_STATE_previous = code;
	    }
    }

    public void WQ1_STATE(int screen, int code)
    {
	if (WQ1_STATE_previous != code)
	    {	String x = TQ1_STATE[code];
		gw.putButtonLabel(ButQ1,x);
		WQ1_STATE_previous = code;
	    }
    }


    public void WQ2_STATE(int screen, int code)
    {
	if (WQ2_STATE_previous != code) 
	    {
		String x = TQ2_STATE[code];
		gw.putButtonLabel(ButQ2,x);
		WQ2_STATE_previous = code;
	    }
    }

    public void running()
    {
	initSimu();
	while(true) iterateSignal();
    }

    public SimuVTP_chart()
    {
	mkGraphicalWindows();
	running();
    }
}

class paceMakerListener implements ActionListener
{
    private boolean vstop, vtick;
    
    public paceMakerListener () 
    {
	vstop = false; 
	vtick = false;
    }
    
    // Warning : The names are declared in button.txt file.
    public void actionPerformed(ActionEvent e)
    {
	String str;
	str = e.getActionCommand();
	if (str.equals("QUIT")) { vstop = true; }
	else if (str.equals("TICK")) { vtick = true; }
    }
    public boolean rtick() { boolean x;	x = vtick; vtick = false; return x; }
    public boolean rstop() { boolean x; x = vstop; vstop = false; return x; }
}

class MYListener implements ActionListener
{
    private boolean val;
 
    public MYListener () { val =  false; }
    public void actionPerformed(ActionEvent e) { val = true; }
    public boolean read() { boolean x; x = val; val = false; return x; }
};


