
/*
This file has been generated by Polychrony version 4.22
*/
#include "PETERSON_types.h"
#include "PETERSON_externals.h"
#include "PETERSON_body.h"

/*
  ==> parameters and indexes 
*/
/*
  ==> input signals     
*/
static boolean R1, R2, L1, L2, C_ZX, L183_C_ZX, C_CLK_145, C_CLK_204;
/*
  ==> output signals    
*/
static boolean A1, A2;
static boolean CS1, CS2;
/*
  ==> local signals     
*/
static boolean X, ZX, L44_X, L45_ZX, D1, D2, P, ZP, L204_extended_X, L210_extended_ZX, L214_extended_X, L220_extended_ZX, C_CLK_170, L233_extended_C_CLK_170, 
               C_CLK_172, L239_extended_C_CLK_172, C_CLK_174, L245_extended_C_CLK_174, C_ZP, CLK_63, L279_extended_CLK_63, L285_extended_D2, L290_extended_FF_D2
               , L293_extended_ZP, L298_extended_FF_ZP, L301_extended_D1, L306_extended_FF_D1, C_C, C_CLK_381, C_CLK_385, C_A2, C_CLK_391, C_A1, C_CLK_403, 
               C_CS2;

EXTERN boolean PETERSON_initialize()
{
    ZX = pk_false;
    L45_ZX = pk_false;
    D1 = pk_false;
    D2 = pk_false;
    ZP = pk_false;
    CS1 = pk_false;
    CS2 = pk_false;
    PETERSON_step_initialize();
    return pk_true;
}

static void PETERSON_step_initialize()
{
    X = pk_false;
    L44_X = pk_false;
    C_CLK_170 = pk_false;
    C_CLK_172 = pk_false;
    C_CLK_174 = pk_false;
    CLK_63 = pk_false;
}

EXTERN boolean PETERSON_step()
{
    if (!r_PETERSON_C_ZX(&C_ZX)) return pk_false;
    if (!r_PETERSON_L183_C_ZX(&L183_C_ZX)) return pk_false;
    if (!r_PETERSON_C_CLK_145(&C_CLK_145)) return pk_false;
    if (!r_PETERSON_C_CLK_204(&C_CLK_204)) return pk_false;
    if (C_ZX)
        {
        X = !ZX;
        C_CLK_170 = X || ZX;
        C_CLK_172 = !X && ZX;
        if (X)
            {
            if (!r_PETERSON_R1(&R1)) return pk_false;
            }
        if (ZX)
            {
            if (!r_PETERSON_L1(&L1)) return pk_false;
            }
        }
    L204_extended_X = (C_ZX ? X : pk_false);
    L210_extended_ZX = (C_ZX ? ZX : pk_false);
    L233_extended_C_CLK_170 = (C_ZX ? C_CLK_170 : pk_false);
    L239_extended_C_CLK_172 = (C_ZX ? C_CLK_172 : pk_false);
    if (L183_C_ZX)
        {
        L44_X = !L45_ZX;
        C_CLK_174 = !L44_X && L45_ZX;
        if (L44_X)
            {
            if (!r_PETERSON_R2(&R2)) return pk_false;
            }
        if (L45_ZX)
            {
            if (!r_PETERSON_L2(&L2)) return pk_false;
            }
        }
    L214_extended_X = (L183_C_ZX ? L44_X : pk_false);
    L220_extended_ZX = (L183_C_ZX ? L45_ZX : pk_false);
    L245_extended_C_CLK_174 = (L183_C_ZX ? C_CLK_174 : pk_false);
    C_ZP = (L214_extended_X || L233_extended_C_CLK_170) || L220_extended_ZX;
    if (C_ZP)
        {
        CLK_63 = !D1 && !D2;
        if (L204_extended_X) D1 = pk_true; else if (L239_extended_C_CLK_172) D1 = pk_false; else ; 
        if (L214_extended_X) D2 = pk_true; else if (L245_extended_C_CLK_174) D2 = pk_false; else ; 
        }
    L279_extended_CLK_63 = (C_ZP ? CLK_63 : pk_false);
    L285_extended_D2 = (C_ZP ? D2 : pk_false);
    L290_extended_FF_D2 = (C_ZP ? !D2 : pk_false);
    L293_extended_ZP = (C_ZP ? ZP : pk_false);
    L298_extended_FF_ZP = (C_ZP ? !ZP : pk_false);
    L301_extended_D1 = (C_ZP ? D1 : pk_false);
    L306_extended_FF_D1 = (C_ZP ? !D1 : pk_false);
    C_C = (L204_extended_X && L214_extended_X) && L279_extended_CLK_63;
    C_CLK_381 = C_C && L293_extended_ZP;
    C_CLK_385 = (C_C && L298_extended_FF_ZP) || (L214_extended_X && L306_extended_FF_D1);
    C_A2 = C_CLK_385 || (L210_extended_ZX && L285_extended_D2);
    C_CLK_391 = C_CLK_381 || (L204_extended_X && L290_extended_FF_D2);
    C_A1 = C_CLK_391 || (L220_extended_ZX && L301_extended_D1);
    C_CLK_403 = (C_CLK_391 || C_CLK_385) || L210_extended_ZX;
    C_CS2 = C_CLK_403 || L220_extended_ZX;
    if ((((C_CLK_381 || C_CLK_204) || C_ZX) || L183_C_ZX) != (C_CLK_145)) polychrony_exception(" Exception for: ( ((C_CLK_381 || C_CLK_204) || C_ZX) ||     L183_C_ZX, C_CLK_145 )" );
    if (((C_CLK_204 || L210_extended_ZX) || C_A1) != (C_CLK_204)) polychrony_exception(" Exception for: ( (C_CLK_204 || L210_extended_ZX) || C_A1, C_CLK_204     )" );
    if (C_CS2)
        {
        if (C_A1) CS1 = pk_true; else if (L210_extended_ZX) CS1 = pk_false; else ; 
        if (C_A2) CS2 = pk_true; else if (L220_extended_ZX) CS2 = pk_false; else ; 
        w_PETERSON_CS1(CS1);
        w_PETERSON_CS2(CS2);
        }
    if (C_ZP)
        {
        if (C_A1) P = pk_false; else if (C_A2) P = pk_true; else P = ZP; 
        }
    if (C_A2)
        {
        w_PETERSON_A2(pk_true);
        }
    if (C_A1)
        {
        w_PETERSON_A1(pk_true);
        }
    PETERSON_step_finalize();
    return pk_true;
}

EXTERN boolean PETERSON_step_finalize()
{
    if (C_ZX)
        {
        ZX = X;
        }
    if (L183_C_ZX)
        {
        L45_ZX = L44_X;
        }
    if (C_ZP)
        {
        ZP = P;
        }
    PETERSON_step_initialize();
    return pk_true;
}

