/*
   Authors: Loïc Besnard, François Fabre, Thierry Gautier.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SSME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SSME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SSME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SSME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
*/

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenDot
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenDot
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_dot_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptAlwaysCode
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptAlwaysCode
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_force_subopt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptDelayMultiplexing
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptDelayMultiplexing
(JNIEnv * env, jobject obj, jboolean b)
{
	setJNIEnv(env);
	OM->set_run_delayMultiplexing_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptDelayOptimizing
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptDelayOptimizing
(JNIEnv * env, jobject obj, jboolean b)
{
	setJNIEnv(env);
	OM->set_run_delayOptimizing_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptSubstitute
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptSubstitute
  (JNIEnv * env, jobject obj, jint value)
{
	setJNIEnv(env);
	OM->set_run_signalSubstitution_opt(value);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptExclusiveClock
 * Signature: (ZI)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptExclusiveClock
  (JNIEnv * env, jobject obj, jboolean b, jint vlevel)
{
  setJNIEnv(env);
  OM->set_gen_exclusiveClock_opt(b,vlevel);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptTestFunctionality
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptTestFunctionality
(JNIEnv * env, jobject obj, jboolean b)
{
	setJNIEnv(env);
	OM->set_wiz_testFunctionality_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptClustering
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptClustering
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_clustering_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptUnification
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptUnification
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_signalUnification_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCBody
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCBody
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_c_body_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCMain
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCMain
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_c_main_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCIO
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCIO
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_c_io_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCModules
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCModules
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_c_modules_opt(b, pk_false); /* DO NOT GENERATE TRA */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCPPBody
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCPPBody
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_cpp_body_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCPPMain
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCPPMain
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_cpp_main_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCPPIO
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCPPIO
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_cpp_io_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenCPPModules
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenCPPModules
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_cpp_modules_opt(b, pk_false);  /* DO NOT GENERATE TRA */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenJava
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenJava
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_java_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenJavaBody
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenJavaBody
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_java_body_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenJavaMain
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenJavaMain
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_java_main_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenThreads
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenThreads
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_threads_subopt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenJavaIO
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenJavaIO
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_java_io_opt(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenJavaModules
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenJavaModules
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  OM->set_export_java_modules_opt(b, pk_false); /* DO NOT GENERATE TRA */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenList
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenList
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_Signal_list_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenTrace
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenTrace
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_trace_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenFlatTrace
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenFlatTrace
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  /* PLG: mess not implemented */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenz3z
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenz3z
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_z3z_opt(pk_false);  /* DO NOT GENERATE TRA */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenSyndex
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenSyndex
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_syndex_opt(pk_false);  /* DO NOT GENERATE TRA */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptSeparateBooleansOthers
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptSeparateBooleansOthers
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_booleanSeparation_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptSeparateStatesOthers
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptSeparateStatesOthers
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_stateSeparation_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptUserPartitioning
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptUserPartitioning
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_tagBasedSeparation_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptVerbose
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptVerbose
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_verbose_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptStat
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptStat
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_stat_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptWarn
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptWarn
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_warn_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptDebug
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptDebug
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_debug_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptCrew
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptCrew
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_ctrl2event_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptSolvingDepth
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptSolvingDepth
(JNIEnv * env, jobject obj, jint val)
{
	setJNIEnv(env);
	OM->set_solvingDepth_opt(val);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenBF
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenBF
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_make_bool_opt(pk_true);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenSBF
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenSBF
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_make_sequential_opt(pk_true);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenFBF
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenFBF
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_make_flat_opt(pk_true);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptRetiming
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptRetiming
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_retiming_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptAbstraction
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptAbstraction
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_run_abstraction_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptKernel
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptKernel
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_kernel_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptProfiling
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptProfiling
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_profiling_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptCheck
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptCheck
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_check_subopt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenLustre
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenLustre
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_lustre_opt(pk_false);  /* DO NOT GENERATE TRA */
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptGenDistrib
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptGenDistrib
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_export_distrib_subopt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptSME
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptSME
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_gen_sme_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptSynoptic
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptSynoptic
  (JNIEnv * env, jobject obj, jboolean b)
{
//	setJNIEnv(env);
//	OM->setopt_synoptic(b);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptTraceabilityMode
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptTraceabilityMode
(JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_gen_cosimuTable_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptHeader
 * Signature: (Z)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_setOptHeader
  (JNIEnv * env, jobject obj, jboolean b)
{
  setJNIEnv(env);
  if (b)
    OM->setON_gen_header_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    compile
 * Signature: (JLjava/lang/String;)I
 */
JNIEXPORT jint JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_compile
(JNIEnv * env, jobject obj, jlong srcTree, jlong vgraph, jstring options, jstring curDir)
{
  ptrepstr defaultDir;

  setJNIEnv(env);
  defaultDir = string2repstr(jstring2CString(curDir, env));
  if (sysMake_strPath_repstr_repstr(defaultDir, STreeModelModule_getNameStr((ntrees) srcTree), &defaultDir))
    return BC->SignalBatchCompilerGUIPop(defaultDir, (ptDCG_basic) vgraph, jstring2CString(options,env));
  return -1;
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    getOptHeader
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_getOptHeader
  (JNIEnv *, jobject )
{
  return  (jboolean) OM->req_gen_header_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    getOptTraceabilityMode
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_getOptTraceabilityMode
  (JNIEnv *, jobject)
{
  return (jboolean) OM->req_gen_cosimuTable_opt();
}
/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptVerbose
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_getOptVerbose
  (JNIEnv *, jobject)
{
  return (jboolean) OM->req_verbose_opt();
}
/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptStat
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_getOptStat
  (JNIEnv *, jobject)
{
  return (jboolean) OM->req_stat_opt();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptWarn
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_getOptWarn
  (JNIEnv *, jobject)
{
  return (jboolean) OM->req_warn_opt();
}


/*
 * Class:     fr_irisa_espresso_ssme_polychrony_PKOptionManager
 * Method:    setOptDebug
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_fr_inria_tea_ssme_polychrony_PKOptionManager_getOptDebug
  (JNIEnv *, jobject)
{
  return (jboolean) OM->req_debug_opt();
}

