/*
   Authors: Loïc Besnard, François Fabre, Thierry Gautier.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - EPL License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony SSME Platform (website: http://www.irisa.fr/espresso/polychrony).

   Polychrony SSME Platform is free software; you can redistribute it and/or modify it under
   the terms of the EPL as published by the Eclipse Foundation.

   Polychrony SSME Platform are distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the Eclipse Public License - v 1.0 for more details.

   You should have received a copy of the Eclipse Public License - v 1.0
   along with Polychrony SSME Platform; see the file COPYING. If not, consult the url
   http://www.eclipse.org/org/documents/epl-v10.php, or write to the Eclipse Foundation, Inc.
   102 Centrepointe Drive. Ottawa, Ontario,Canada, K2G 6B1.
*/

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    n_addDeclarationToInterface
 * Signature: (III)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_n_1addDeclarationToInterface(JNIEnv * env, jobject obj, jlong modelNode, jlong declNode, jint where)
{
	STree_addDeclarationToInterface((ntrees) modelNode, (ntrees) declNode, (int)where);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addDeclarationToList
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addDeclarationToList(JNIEnv * env, jobject obj, jlong listNode, jlong declNode)
{
	return (jlong) STree_addDeclarationToList((ntrees) listNode, (ntrees) declNode);  
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addEmptyInterface
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addEmptyInterface(JNIEnv * env, jobject obj, jlong node)
{
	return (jlong) STree_addEmptyInterface((ntrees) node);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addEndDeclarationToList
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addEndDeclarationToList(JNIEnv * env, jobject obj, jlong listNode, jlong declNode)
{
	return (jlong) STree_addEndDeclarationToList((ntrees) listNode, (ntrees) declNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addExpressionOfProcessToaModel
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addExpressionOfProcessToaModel(JNIEnv * env, jobject obj, jlong modelNode, jlong procExprNode)
{
	STree_addExpressionOfProcessToaModel((ntrees) modelNode, (ntrees) procExprNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addExprToComposition_Post
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addExprToComposition_1Post(JNIEnv * env, jobject obj, jlong compListNode, jlong procExprNode)
{
	ntrees * list = (ntrees *) compListNode;
	STree_addExprToComposition_Post(list, (ntrees) procExprNode);
	return (jlong) (*list);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addExprToComposition_Pre
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addExprToComposition_1Pre(JNIEnv * env, jobject obj, jlong compListNode, jlong procExprNode)
{
	ntrees * list = (ntrees *) compListNode;
	STree_addExprToComposition_Pre(list, (ntrees) procExprNode);
	return (jlong) (*list);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addFlowDeclaration
 * Signature: (III)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addFlowDeclaration(JNIEnv * env, jobject obj, jlong declListNode, jlong typeNode, jlong declNode)
{
	STree_addFlowDeclaration((ntrees) declListNode, (ntrees) typeNode, (ntrees) declNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addLabelsInModel
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addLabelsInModel(JNIEnv * env, jobject obj, jlong idListNode, jlong modelNode)
{
	STree_addLabelsInModel((ntrees) idListNode, (ntrees) modelNode);  	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addLocalBlock
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addLocalBlock(JNIEnv * env, jobject obj, jlong modelNode)
{
	return (jlong) STree_addLocalBlock((ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addLocalDeclaration
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addLocalDeclaration(JNIEnv * env, jobject obj, jlong modelNode, jlong declNode)
{
	STree_addLocalDeclaration((ntrees) modelNode, (ntrees) declNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addPragma
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addPragma(JNIEnv * env, jobject obj, jlong modelNode, jlong pragmaNode)
{
	STree_addPragma((ntrees) modelNode, (ntrees) pragmaNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addProcessDeclaration
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addProcessDeclaration(JNIEnv * env, jobject obj, jlong modelNode, jlong modelDeclNode)
{
	STree_addProcessDeclaration((ntrees) modelNode, (ntrees) modelDeclNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addSpecification
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addSpecification(JNIEnv * env, jobject obj, jlong modelNode, jlong specNode)
{
	STree_addSpecification((ntrees) modelNode, (ntrees) specNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addSynchroTree
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addSynchroTree(JNIEnv * env, jobject obj, jlong listNode, jlong exprNode)
{
	return (jlong) STree_addSynchro((ntrees) listNode, (ntrees) exprNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    addTypeToTypes
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_addTypeToTypes(JNIEnv * env, jobject obj, jlong typeDeclListNode, jlong typeDeclNode)
{
	return (jlong) STree_addTypeToTypes((ntrees) typeDeclListNode, (ntrees) typeDeclNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    copy
 * Signature: (IZ)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_copy(JNIEnv * env, jobject obj, jlong node, jboolean copyAttr)
{
	return (jlong) STree_copy((ntrees) node, (boolean) copyAttr);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    deleteParameters
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_deleteParameters(JNIEnv * env, jobject obj, jlong modelNode)
{
	STree_deleteParameters((ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    duplicateInterfaceWithoutSpec
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_duplicateInterfaceWithoutSpec(JNIEnv * env, jobject obj, jlong modelNode)
{
	return (jlong) STree_duplicateInterfaceWithoutSpec((ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    importDeclarations
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_importDeclarations(JNIEnv * env, jobject obj, jlong modelNodeDst, jlong modelNodeSrc)
{
	STree_importDeclarations((ntrees) modelNodeDst, (ntrees) modelNodeSrc);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    importDeclsFromTo
 * Signature: (III)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_importDeclsFromTo(JNIEnv * env, jobject obj, jlong idListNode, jlong modelNodeSrc, jlong modelNodeDst)
{
	STree_importDeclsFromTo((ntrees) idListNode, (ntrees) modelNodeSrc, (ntrees) modelNodeDst);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    maskSignals
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_maskSignals(JNIEnv * env, jobject obj, jlong modelNode, jlong signalListNode)
{
	STree_maskSignals((ntrees) modelNode, (ntrees) signalListNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mergeDeclarations
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mergeDeclarations(JNIEnv * env, jobject obj, jlong modelNodeDst, jlong modelNodeSrc)
{
	STree_mergeDeclarations((ntrees) modelNodeDst, (ntrees) modelNodeSrc);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mergeExprProc
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mergeExprProc(JNIEnv * env, jobject obj, jlong modelNodeDst, jlong modelNodeSrc)
{
	STree_mergeExprProc((ntrees) modelNodeDst, (ntrees) modelNodeSrc);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mergeLocalDecl
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mergeLocalDecl(JNIEnv * env, jobject obj, jlong declListNodeDst, jlong declListNodeSrc)
{
	STree_mergeLocalDecl((ntrees) declListNodeDst, (ntrees) declListNodeSrc);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mergeProcesses
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mergeProcesses(JNIEnv * env, jobject obj, jlong modelNodeDst, jlong modelNodeSrc)
{
	STree_mergeProcesses((ntrees) modelNodeDst, (ntrees) modelNodeSrc);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkAtomNilTree
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkAtomNilTree(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkAtomNilTree();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkCompleteModelCall
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkCompleteModelCall(JNIEnv * env, jobject obj, jlong modelNode)
{
	return (jlong) STree_mkCompleteModelCall((ntrees) modelNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkConfinedExpression
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkConfinedExpression(JNIEnv * env, jobject obj, jlong exprNode, jlong declNode)
{
	return (jlong) STree_mkConfinedExpression((ntrees) exprNode, (ntrees) declNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkConstantDeclaration
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkConstantDeclaration(JNIEnv * env, jobject obj, jlong cstListNode, jlong typeNode)
{
	return (jlong) STree_mkConstantDeclaration((ntrees) cstListNode, (ntrees) typeNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkDclType
 * Signature: (III)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkDclType(JNIEnv * env, jobject obj, jlong name, jlong description, jlong vinit)
{
	return (jlong) STree_mkDclType((ntrees) name, (ntrees) description, (ntrees) vinit);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkDependenceTree
 * Signature: (III)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkDependenceTree(JNIEnv * env, jobject obj, jlong fromNode, jlong toNode, jlong clockNode)
{
	return (jlong) STree_mkDependenceTree((ntrees) fromNode, (ntrees) toNode, (ntrees) clockNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkEmptyBody
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkEmptyBody(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkEmptyBody();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkEmptyConfinedExpr
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkEmptyConfinedExpr(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkEmptyConfinedExpr();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkEmptyString
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkEmptyString(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkEmptyString();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkEmptyTree
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkEmptyTree(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkEmptyTree();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    n_mkEquation
 * Signature: (III)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_n_1mkEquation(JNIEnv * env, jobject obj, jlong codeOp, jlong leftExprNode, jlong rightExprNode)
{
	return (jlong) STree_mkEquation((noperators) codeOp, (ntrees) leftExprNode, (ntrees) rightExprNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    n_mkExternalImplLanguage
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_n_1mkExternalImplLanguage(JNIEnv * env, jobject obj, jint langCode)
{
	return (jlong) STree_mkExternalImplLanguage((int) langCode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkExternalString
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkExternalString(JNIEnv * env, jobject obj, jlong valueNode)
{
	return (jlong) STree_mkExternalString((ntrees) valueNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkImplicitSignalDeclaration
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkImplicitSignalDeclaration(JNIEnv * env, jobject obj, jstring name)
{
	return (jlong) STree_mkImplicitSignalDeclaration(jstring2str(name, env));
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkInterface
 * Signature: (IIII)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkInterface(JNIEnv * env, jobject obj, jlong paramNode, jlong insNode, jlong outsNode, jlong specNode)
{
	return (jlong) STree_mkInterface((ntrees) paramNode, (ntrees) insNode, (ntrees) outsNode, (ntrees) specNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkLocalDeclaration
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkLocalDeclaration(JNIEnv * env, jobject obj, jlong modelNode)
{
	return (jlong) STree_mkLocalDeclaration((ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkModelCall
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkModelCall(JNIEnv * env, jobject obj, jstring name)
{
	return (jlong) STree_mkModelCall(jstring2str(name, env));
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkModule
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkModule(JNIEnv * env, jobject obj, jlong nameNode)
{
  return (jlong) STree_mkSkeletonModule((ntrees) nameNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkNOTIMPLEMENTED
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkNOTIMPLEMENTED(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkNOTIMPLEMENTED();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkNullaryTree
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkNullaryTree(JNIEnv * env, jobject obj, jint codeOp)
{
	return (jlong) STree_mkNullaryTree((noperators) codeOp);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkPragma
 * Signature: (Ljava/lang/String;ILjava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkPragma(JNIEnv * env, jobject obj, jstring name, jlong objList, jstring enonce)
{
	return (jlong) STree_mkPragma(jstring2str(name, env), (ntrees) objList, repstr2PragmaStatement(jstring2str(enonce, env)));
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkPragmasList
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkPragmasList(JNIEnv * env, jobject obj, jlong modelNode)
{
	return (jlong) STree_mkPragmasList((ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkProcess
 * Signature: (III)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkProcess(JNIEnv * env, jobject obj, jlong nameNode, jlong interfaceNode, jlong descNode)
{
	return (jlong) STree_mkProcess((ntrees) nameNode, (ntrees) interfaceNode, (ntrees) descNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkReferenceToModel
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkReferenceToModel(JNIEnv * env, jobject obj, jlong modelIdNode)
{
	return (jlong) STree_mkReferenceToModel((ptident) modelIdNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkReferenceToModelWithParameter
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkReferenceToModelWithParameter(JNIEnv * env, jobject obj, jlong parListNode, jlong modelNode)
{
	return (jlong) STree_mkReferenceToModelWithParameter((ntrees) parListNode, (ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkSelectedPragma
 * Signature: (ILjava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkSelectedPragma(JNIEnv * env, jobject obj, jlong pragListNode, jstring name)
{
	ntrees * enonce = NULL;
	if (STree_mkSelectedPragma((ntrees) pragListNode, jstring2str(name, env), enonce))
		return (jlong) (*enonce);
	else
		return (jlong) ERROR_NODE;
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkSignalDeclaration
 * Signature: (III)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkSignalDeclaration(JNIEnv * env, jobject obj, jlong nameNode, jlong typeNode, jlong initNode)
{
	return (jlong) STree_mkSignalDeclaration((ntrees) nameNode, (ntrees) typeNode, (ntrees) initNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    n_mkSkeletonExternProcess
 * Signature: (III)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_n_1mkSkeletonExternProcess(JNIEnv * env, jobject obj, jlong modelIdNode, jlong langNode, jlong opCode)
{
	return (jlong) STree_mkSkeletonExternProcess((ptident) modelIdNode, (ntrees) langNode, (noperators) opCode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkSkeletonInterface
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkSkeletonInterface(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkSkeletonInterface();
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    n_mkSkeletonModel
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_n_1mkSkeletonModel(JNIEnv * env, jobject obj, jlong id, jlong codeOp)
{
	return (jlong) STree_mkSkeletonModel((ptident) id, (noperators) codeOp);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkStringFromStr
 * Signature: (Ljava/lang/String;)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkStringFromStr(JNIEnv * env, jobject obj, jstring str)
{
	return (jlong) STree_mkStringFromStr(jstring2str(str, env));	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkSynchroIni
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkSynchroIni(JNIEnv * env, jobject obj, jlong sigNameNode)
{
	return (jlong) STree_mkSynchroIni((ntrees) sigNameNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    mkUndefinedExternalValue
 * Signature: ()I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_mkUndefinedExternalValue(JNIEnv * env, jobject obj)
{
	return (jlong) STree_mkUndefinedExternalValue();	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    moveAttribute
 * Signature: (III)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_moveAttribute(JNIEnv * env, jobject obj, jlong nodeSrc, jlong nodeDst, jint rank)
{
  STree_moveAttribute((ntrees) nodeSrc, (ntrees) nodeDst, (short) rank);
}
  
/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    removeDeclsFrom
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_removeDeclsFrom(JNIEnv * env, jobject obj, jlong idListNode, jlong modelNode)
{
	STree_removeDeclsFrom((ntrees) idListNode, (ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    removeNilTree
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_removeNilTree(JNIEnv * env, jobject obj, jlong modelNode)
{
	return (jlong) STree_removeNilTree((ntrees) modelNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    replaceInputsOutputs
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_replaceInputsOutputs(JNIEnv * env, jobject obj, jlong modelNode, jlong inOutNode)
{
	STree_replaceInputsOutputs((ntrees) modelNode, (ntrees) inOutNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    replaceInputsOutputsModel
 * Signature: (IIZ)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_replaceInputsOutputsModel(JNIEnv * env, jobject obj, jlong modelNode, jlong sigListNode, jboolean asInput)
{
	STree_replaceInputsOutputsModel((ntrees) modelNode, (ntrees) sigListNode, (boolean) asInput);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    replaceInterface
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_replaceInterface(JNIEnv * env, jobject obj, jlong modelNode, jlong interfaceNode)
{
	STree_replaceInterface((ntrees) modelNode, (ntrees) interfaceNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    replaceLocalDecl
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_replaceLocalDecl(JNIEnv * env, jobject obj, jlong modelNode, jlong declListNode)
{
	STree_replaceLocalDecl((ntrees) modelNode, (ntrees) declListNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    replaceSon
 * Signature: (III)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_replaceSon(JNIEnv * env, jobject obj, jlong node1, jlong node2, jint rank)
{
	STree_replaceSon((ntrees) node1, (ntrees) node2, (int) rank);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setBody
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setBody(JNIEnv * env, jobject obj, jlong modelNode, jlong bodyNode)
{
	STree_setBody((ntrees) modelNode, (ntrees) bodyNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setDescription
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setDescription(JNIEnv * env, jobject obj, jlong modelNode, jlong descNode)
{
	STree_setDescription((ntrees) modelNode, (ntrees) descNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setExternalGraph
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setExternalGraph(JNIEnv * env, jobject obj, jlong modelNode, jlong egNode)
{
	STree_setExternalGraph((ntrees) modelNode, (ntrees) egNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setLocalDeclarations
 * Signature: (II)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setLocalDeclarations(JNIEnv * env, jobject obj, jlong modelNode, jlong declListNode)
{
	return (jlong) STree_setLocalDeclarations((ntrees) modelNode, (ntrees) declListNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setNameModel
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setNameModel(JNIEnv * env, jobject obj, jlong modelNode, jlong nameNode)
{
	STree_setNameModel((ntrees) modelNode, (ptident) nameNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setParameters
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setParameters(JNIEnv * env, jobject obj, jlong modelNode, jlong paramNode)
{
	STree_setParameters((ntrees) modelNode, (ntrees) paramNode);
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    setPragmas
 * Signature: (II)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_setPragmas(JNIEnv * env, jobject obj, jlong modelNode, jlong pragmasNode)
{
	STree_setPragmas((ntrees) modelNode, (ntrees) pragmasNode);	
}

/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    updateModule
 * Signature: (I)I
 */
JNIEXPORT jlong JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_updateModule(JNIEnv * env, jobject obj, jlong moduleNode)
{
	return (jlong) STree_updateModule((ntrees) moduleNode);	
}
/*
 * Class:     fr_irisa_espresso_ssme_polychrony_SignalTreeBuilting
 * Method:    moveModelsFrom
 * Signature: (JJ)V
 */
JNIEXPORT void JNICALL Java_fr_inria_tea_ssme_polychrony_SignalTreeBuilting_moveModelsFrom
(JNIEnv *env, jobject obj, jlong p, jlong b)
{
  STree_moveModelsFrom( (ntrees) p, (ntrees) b);
}
