/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/** 
    @return "true" if the node node must be generated, "false" otherwise.
    @param node (in) can be annotated by one of the attribute  : GencodeMark, substituteGenCodeMark
 */
virtual boolean /*cGenerator::*/mustBeGenerated( ptINode node );

/** 
    @return "true" if the opernad signal (vsig) must be generated, "false" otherwise.
    @param node (in) can be annotated by one of the attribute  : GencodeMark, substituteGenCodeMark
 */
virtual boolean /*cGenerator::*/mustBeGenerated( ptexpcal vsig );

/**
   It generates the contextual prefix (genPrefix()) before the identifier of a reference to the identifier if bref (printidentref()).
 */
void /*cGenerator::*/printPrefixedIdentRef( ptident id ,boolean bref ,boolean bfield );

/**
   It generates the contextual prefix (genPrefix()) before the name of an assumed identifier (s) (printident()).
 */
void /*cGenerator::*/printPrefixedSignalIdentifier( ptexpcal s );

/**
   @return "true" if expg and expd are the same variable (ie x = x or x = x[]) when the current operation is a sequential definition (next), "false" oherwise.
   The current operation is managed by a attribute member of the class (contextOp).

   Example: T := (T$ init [1,2,3]) next K:A \n
   If T and T$ are in the same memory (by optimisation), it is not necessary to generate the copy of T in T.
 */
boolean /*cGenerator::*/IsOptimizedSequentialDefinition( ptexpcal expg ,ptexpcal expd );

/**
   It finalizes a statement with n back indentations.
 */
void /*cGenerator::*/endStatement( int n ,boolean addSemiColon );

/**
   @return "true" if the node i defines a constant signal, "false" otherwise.
   @param i (in) a node.
   @param expd (out) the expression of the constant.
 */
virtual boolean /*cGenerator::*/isNodeAtInitialClock( ptINode i ,ptexpcal* expd );

/**
   For C, it is generated by a expg :=(COND ? expd : FALSE) in genexpressionLeft_tt().
 */
virtual boolean /*cGenerator::*/genLeft_tt( ptinsth h ,ptexpcal expg ,ptexpcal expd );

/** Code generation for an equation (not a delay), such that X:=E.
    It realizes a switch depending on the operator of E. 
    It calls one of the following methods: 
    - genCounterModulo() for X := E1 count M
    - genAssignDefaultCell(), for X := (E1 default E2) cell C
    - genAssignDefault(),  for X := (E1 default E2)
    - genAssignCell(),  for X := E1 cell C
    - genAssignSynchronous(),  for X := f(E1,....,E2) f is a synchronous operator.

    @param node (in) assumed to be an equation.
 */
virtual void /*cGenerator::*/genEquNode( ptINode node );

/** 
    Code generation for an equation of a counter modulo.
 */
virtual void /*cGenerator::*/genCounterModulo( ptexpcal expg ,ptexpcal vmodulo );

/**
   It generates the assignment expg := expd when the operator of expd is an vectorial definition such that
   { i from 1 to n, j ..., k...}:expression (see Signal Grammar for more details).
  
   @param expg (in) left expression of the assignment
   @param expd (in) right expression of the assignment ;  the operator of expd must be "opensvec".
   @param ajustdim (in) when it is "true", the first dimension of expd is ignored (this case happends only for the generation of the initialisations of delays).
 */
virtual void /*cGenerator::*/genAssignVectSet( ptexpcal expg ,ptexpcal expd ,boolean ajustdim );

/**
   @param expg (in) left part of a definition.
   @param expd (in) right part of a definition, assumed to be a list of vectorial definitions
   - sequential enumeration given by an iterative enumeration (see genAssignVectSet())
   - sequential enumeration given by elements (see genAssignVectElem()).
   @param ajustDim (in) when it is "true", the first dimension of expd is ignored 
   (this case happends only for the generation of the initialisations of delays).
 */
virtual void /*cGenerator::*/genListVectorElem( ptexpcal expg ,ptexpcal expd ,boolean ajustDim );

/** 
    It generates the assignment expg := expg where expg denotes a multiplication operation on matrix/vectors.
 */
virtual void /*cGenerator::*/genMatrixMult( ptexpcal expg ,ptexpcal expd );

/** It generates the assignment expg := expg where expg denotes a matrix transposition expression.
  */
virtual void /*cGenerator::*/genMatrixTransposition( ptexpcal expg ,ptexpcal expd );

/** It generates the assignment expg := expd for expd a synchronous expression.
    It calls one of the following methods when IsOptimizedSequentialDefinition() is not applied, depending on the operator of expd:
    - genListVectorElem()  for a list of vectorial definitions
    - genConcatenate() for a concatenation.
    - genMatrixMult() for a multiplication of matrix/vectors.
    - genMatrixTransposition() for a transposition of matrix.
    - genEnumVector()   for a definition of an index (E1..E2 step E3).
    - genRepeat() for a repetition expression ( E1 |* E2 )
    - genNext()  for a next operation (E1 next E2), used mainly for redefinition of elements of arrays.
    - genAssign() otherwise.
   
    @param expg (in) left expression of the assignment.
    @param expd (in) right expression of the assignment.
 */
virtual void /*cGenerator::*/genAssignSynchronous( ptexpcal expg ,ptexpcal expd );

/**
   When expg 
   - is a list (U1,..., Un), vdef is a list <<I1,... In>> , it call genVectorCartesianProduct() for each element (Uk, Ik)
   - otherwise, it generates expg[ vexprIndex ] = e, where e is the associated index with vdef. This index is known using the 
   IteratorAttribute attribute; it is set in genLoopForList()).
 */
virtual void /*cGenerator::*/genVectorCartesianProduct( ptexpcal expg ,ptexpcal vdef ,ptexpcal vexprIndex );

/**
   Code generation expg:=expd for expd a cartesian product expression (<<I1,... In>> operator).
   <<I1,... In>> defines a tuple of n vectors (II1,....IIn). These vectors II1,....IIn are such that
   the tuples obtained by their elements of same index describe successively the successive values of the elements
   I1,...,In in embedded loops such that the most external one enumerates the values of I1 and the most internal one enumerates the
   values of In.
   
   It calls 
   - genLoopForList() for the opening of the loops.
   - genDefIndex()
   - genVectorCartesianProduct()

   \code
   Example: (I,J):= <<0..4, 0..2>> produces the following (pseudo) code
   for L = 0, 4;
   for U = 0, 2;
   { 
   I[ 3L + U] = L;
   J[ 3L + U] = U;
   }
   \endcode
 */
virtual void /*cGenerator::*/genCartesianProduct( ptexpcal expg ,ptexpcal expd );

/**  
     Code generation expg:=expd for expd an expression E1 next E2, used mainly for redefinition of elements of arrays.
     It generates expg:= E1 followed by expg:= E2.
 */
virtual void /*cGenerator::*/genNext( ptexpcal expg ,ptexpcal expd );

/**  
     Code generation expg:=expd for expd an repetition expression E1 |* E2 (E1 repeated E2 times).
     e1 is recopied e2 times.
 */
virtual void /*cGenerator::*/genRepeat( ptexpcal expg ,ptexpcal expd );

/**
   Code generation expg:=expd for expd an expression E1..E2 step E3 (definition of an index).
 */
virtual void /*cGenerator::*/genEnumVector( ptexpcal expg ,ptexpcal expd );

/**
   It generates expg := expd  for expd a synchronous expression of type String. It is generalized for
   duplication of string variable of structures: expg.e1....eN = expd.f1.....fm where 
   e1,...,en is a reference to a field of expg (lfields)
   f1,...,fm is a reference to a field of expd (lfieldsdef)
   For C code, 
   It generates  expg:=expd for strcopy( x.e1....eN, y.f1.....fm).
   It calls genFieldsList() for field generation.

 */
virtual void /*cGenerator::*/genAssignString( ptexpcal expg ,ptexpcal lfields ,ptexpcal expd ,ptexpcal lfieldsdef );

/** 
    It generates the assignment expg := expd  for expd a synchronous expression of type "string" (or array of string)
    @return "true" if operation is done, "false" otherwise.
    @param expg (in) left expression of the assignment.
    @param expd (in) right expression of the assignment; synchronous expression.
 */
virtual boolean /*cGenerator::*/isGenAssignString( ptexpcal expg ,ptexpcal expd );

/**
   It generates the expansion of the lpart:= rpart in lpart.e1....eN = rpart.f1.....fm  for each field of lpart 
   for a signal of structure type, where
   - e1....eN are given by lfields (optional) 
   - f1.....fm are given by lfieldsdef (optional).
   - t is the the type of lpart.e1....eN.
   It calls genAssignString() for the string type.
 */
virtual void /*cGenerator::*/genFieldsTupleStruct( ptexpcal lpart ,ptexpcal lpartAdded ,TypeType t ,ptexpcal rpart ,ptexpcal rpartAdded );

/** 
    It generates the assignment le := re  for re a list of expressions (Tuple)
    @param le (in) left expression of the assignment.
    @param re (in) right expression of the assignment; 
    @return "true" if re is a list of expression, "false" otherwise.
 */
virtual boolean /*cGenerator::*/genTupleStruct( ptexpcal le ,ptexpcal re );

/** 
    It generates the assignment le := re  for re a list of expressions (Tuple)
    @param le (in) left expression of the assignment.
    @param re (in) right expression of the assignment;
    @param n (in) number of array-blocks opened for the extension of the operators.
    @return "true" if re is a list of expression, "false" otherwise.
 */
virtual boolean /*cGenerator::*/genArrayTupleStruct( ptexpcal le ,ptexpcal re ,int n );

/** 
    It generates the assignment expg := expd  for expd a synchronous expression.
    
    @param expg (in) left expression of the assignment.
    @param expd (in) right expression of the assignment; synchronous expression except opelevec, opensvec, opconc operators.
 */
virtual void /*cGenerator::*/genAssign( ptexpcal expg ,ptexpcal expd );

/**
   It generates the assignment expg := vselect : expr. ( example  x := [E1,E2] : expression ).
   
   @param expg (in) left expression of the assignment.
   @param vselect (in) a indices-defined coordinate points of expg array.
   @param expr (in) expression assigned to the vselect element of expg.
 */
virtual void /*cGenerator::*/genAssignVectElem( ptexpcal expg ,ptexpcal vselect ,ptexpcal expr );

/** 
    It generates the assignment expg := expd for expd an expression such that [E1,E2]:expression.
   
    @param expg (in) left expression of the assignment.
    @param expd (in) right expression of the assignment; 
    @param ajustDim (in) at pk_true, it specifies that the first dimension of expd must be ignored (used for initialization of delays).
 */
virtual void /*cGenerator::*/genAssignVectElem( ptexpcal expg ,ptexpcal expd ,boolean ajustDim );

/**
   It generates the assignment expg[i1,...,in] := expd where the indexes are given by embedded loops (parc).

   @param expg (in) left expression of the assignment.
   @param parc (in) set of (index, lowerBound, upperbound, step).
   @param expd (in) right expression of the assignment; 
 */
virtual void /*cGenerator::*/genAssignElemParc( ptexpcal expg ,ptexpcal parc ,ptexpcal expd );

/**
   It generates the conditional assgigment : if (h) expg := expd.
   
   @param h (in) a clock that defines the condition if is not the current clock (given by currentClock member of the cGenerator class)
   @param expg (in) left expression of the assignment.
   @param expd (in) right expression of the assignment; must be a synchronous one.
 */
virtual void /*cGenerator::*/genConditionalAssign( ptinsth h ,ptexpcal expg ,ptexpcal expd ,boolean bfirst );

/** 
    It generates the conditional assgigment : if (clockExp) expg := expd.
   
    @param clockExp (in) a boolean expression defining the condition.
    @param expg (in) left expression of the assignment.
    @param expd (in) right expression of the assignment; must be a synchronous one.
 */
virtual void /*cGenerator::*/genConditionalAssign( ptexpcal clockExp ,ptexpcal expg ,ptexpcal expd ,boolean bfirst );

/**
   It generates a cell expression ( expg := expd at h )
  
   @param h (in)  the modification clock of expg.
   @param expg (in) left expression.
   @param expd (in) right expression; when expg is a node of a delay tree, a "else" statement is generated 
   to take into account the specific management of dynamic expressions.
 */
virtual void /*cGenerator::*/genAssignCell( ptinsth h ,ptexpcal expg ,ptexpcal expd );

/** 
    It generates the assignment expg := hexp for hexp a sub-term of a default expression.
   
    @param expg (in) left expression of the assignment.
    @param hexp (in) right expression ; when or default expression.
 */
virtual boolean /*cGenerator::*/gencascademele( ptexpcal expg ,ptexpcal hexp );

/** 
    It generates the assignment expg := expd for expd a default expression.
 
    @param expg (in) left expression of the assignment.
    @param expd (in) right expression ; default expression.
 */
virtual void /*cGenerator::*/genAssignDefault( ptexpcal expg ,ptexpcal expd );

/**
   It generates the assignment expg := expd for expd ::= "default_expression" cell h.
   @param expg (in) left expression of the assignment.
   @param expd (in) right expression defined by (E1 default E2 ...default En) cell C
 */
virtual void /*cGenerator::*/genAssignDefaultCell( ptexpcal expg ,ptexpcal expd );

/**
   It generates the assignment of exp to its equivalents.
   Specific to the management of the nodes of delay trees (a signal can be a root of several trees of delays).
   @param exp (in) a signal.
 */
virtual void /*cGenerator::*/genAssignEquivalence( ptexpcal exp );

/**
   It generates signal expressions of a list linputs as input parameters of an external call.
   @return bfirst when linputs is empty, "false" otherwise.
   @param linputs (in) a combed signal expression.
   @param bfirst (in) specified,  when it is pk_true (resp. pk_false) that a list-separator must not (resp. must) be generated first.
 */
virtual boolean /*cGenerator::*/genInputsExternalNode( ptexpcal linputs ,boolean bfirst );

/**
   It generates the signals expressions of the list loutputs as output parameters of an external call.
   @param bfirst (in) specified, when it is pk_true (resp. pk_false) that a list-separator must not (resp. must) be generated first.
   @param loutputs (in) combed signal expression.
 */
virtual void /*cGenerator::*/genOutputsExternalNode( ptexpcal loutputs ,boolean bfirst );

/**
   It generates the signal (expEff) for a read.
 */
virtual void /*cGenerator::*/genReadEnvSignal( ptexpcal expEff );

/**
   It generates the code of a read environment.
   The form of the call is :
   \code
   if (!r_<processName>_<ident1)> (ident2)) return pk_false;
   \endcode
   where ident1(resp. ident2) denotes the identifier of the signal exp (resp. expEff).
   @param exp (in) a signal.
   @param expEff (in) a signal.
   @param processName (in) an identifier.
 */
virtual void /*cGenerator::*/genCodeReadEnv( ptexpcal exp ,ptident processName ,ptexpcal expEff );

/**
   It generates the call to the read function of the signal expEff at a clock (h). 
   It manages also the equivalence induced by the delay trees.

   @param exp (in) signal.
   @param expEff (in) signal.
   @param processName (in) an identifier.
   @param h (in) clock of the read node.

   \see genCodeReadEnv()
 */
virtual void /*cGenerator::*/genReadEnv( ptexpcal exp ,ptident processName ,ptexpcal expEff ,ptinsth h );

/**
   It generates the reading of exp for separated compiling. It generates 
   the assignment ident1 = ident2 where ident1 denotes the identifier of exp, and ident2 is 
   defined by _ident1_ (name of the formal parameter of the entry point).

   (parameter h is unused, but kept).
 */
virtual void /*cGenerator::*/genReadEnvSeparate( ptexpcal exp ,ptinsth h );

/**
   It generates the writing of an output signal (exp).
 */
virtual void /*cGenerator::*/genWriteEnvSignal( ptexpcal exp );

/**
   It generates the call to the write function of the signal expEff at a clock (h).
   The form of the call is:  w_<processName_<ident1)> (ident2)), where 
   ident1(resp. ident2) denotes the identifier of the signal exp (resp. expEff).
 */
virtual void /*cGenerator::*/genWriteEnv( ptexpcal exp ,ptident processName ,ptexpcal expEff ,ptinsth h );

/**
   It generates the writing of a signal (exp) at a clock (h) for separated compiling. 
   It generates the assignment ident1 = ident2 where ident2 denotes the identifier of exp, and ident1 is 
   defined by _ident1_ (name of the formal parameter of the entry point).
 */
virtual void /*cGenerator::*/genWriteEnvSeparate( ptexpcal exp ,ptinsth h );

/**
   It generates the name, or a reference to when refTo is "true, of the signal exp.
 */
virtual void /*cGenerator::*/genOutputSignal( ptexpcal exp ,boolean refTo );

/**
   It generates the instructions for the predefined "affine_sample" node.
   For B: = Affine_sample{phase,period_d} (C) where B is a boolean clock, it manages the counter (N) assigned to
   the clock B. The generated code is \n
   if (N==0) { B=true; N=period_d-1; } else { B= false; N=N -1; }
 */
virtual void /*cGenerator::*/cgenSampleNode( ptexpcal params ,ptexpcal ins ,ptexpcal outs );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*cGenerator::*/genRendezVousNode( ptident nom ,ptexpcal lparams ,ptexpcal linputs ,ptexpcal loutputs );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*cGenerator::*/genStatus( ptINode aNode );

/**
   @return "true" if the node node denotes an intrinsic function node, "false" otherwise.
   It generates the code (and return pk_true value) for the following cases:
   - the conversion pragma (PRAGMA_CONVERSION)
   - the exception operator (\\); it generates the code (genPragmaCode()) associated with it in the internal table (tableOpCode).
   - the indice functions (see genIntrinsicfuncIndices())
   - the catesian product (<<I1,... In>> operator) (see genCartesianProduct())
   - the assertion model; it generates the code (genPragmaCode()) associated with it in the internal table (tableOpCode).
   - the affine sample node (see cgenSampleNode())
   
   The  internal table (tableOpCode) is filled by $SignalLib_C/CodeGenerator.defs file.
 */
virtual boolean /*cGenerator::*/genNodeIntrinsicFunc( ptINode node );

/**
  @return "true" if there is no generated code, "false" otherwise.
  It generates some code when BboxOrGbox is defined and the implementation language referenced in 
  vlanguage is C ( or another language than C++, it generates some code but an error is detected and signaled). 
  
  For C, it generates a reference to the data area given by the BboxOrGbox pragma (getClassAndObjectExternalCall()).

  The code generated here must be coherent with the code generated for separated compiling.
 */
virtual boolean /*cGenerator::*/genExternalSignalNodeCallAsProcedureCall( ptpragma BboxOrGbox ,ntrees vlanguage );

/**
  @return "true" if there is no generated code, "false" otherwise.
  It generates some code when BboxOrGbox is defined (getClassAndObjectExternalCall()) 
  and the implementation language referenced in vlanguage is C++: for C++, it generates the name of the object, 
  referenced in the BboxOrGbox pragma, followed by a dot character.

  The code generated here must be coherent with the code generated for separated compiling.
 */
virtual boolean /*cGenerator::*/genExternalSignalNodeCallAsObjectReference( ptpragma BboxOrGbox ,ntrees vlanguage );

/** 
    It prints a reference to an external call called id.
    For C, it prints the identifier.( For Java, it will be specialized.)
 */
virtual void /*cGenerator::*/genIdentExternalCall( ptident id );

/**
   It generates a procedure (resp. function) call when asFunc is "false" (resp. "true")
   with input parameters (linputs) and output parameters (loutputs).

   The references to a Signal model takes into account Polychrony specific separated compiling informations 
   (BboxOrGbox: black boxes or Grey boxes mode, and the implementation language (vlanguage) of the referenced model).
   These informations are used in  genExternalSignalNodeCallAsObjectReference(), genExternalSignalNodeCallAsProcedureCall() methods.

 */
virtual void /*cGenerator::*/genExternalCall( ptident nom ,ptexpcal linputs ,ptexpcal loutputs ,boolean asFunc ,ptpragma BboxOrGbox ,ntrees vlanguage );

/**
   @return "true" if a node (node) denotes a communicating node.
   The node is generated taking account the context given by blackBox. When blackBox 
   - is pk_true, the operation is a reference to an external model assumed compiled in separated mode. It calls
   genReadEnvSeparate() for a reading and genWriteEnvSeparate() for a writing.

   - is pk_false, the operation is an acces to the environment. It calls genReadEnv() for a reading , genWriteEnv() for a writing.
 */
virtual boolean /*cGenerator::*/genIOCall( ptINode node ,boolean blackBox );

/**
   @return "true" if it exists a pragma associated with a node (ProcCallNode) used by the generator , "false" otherwise.
   For C generator, it looks at the PragmaGencodeLanguage pragma.
   It calls genPragmaCodeInt() when the pragma exists.
   @param ProcCallNode (in) assumed to be a procedure node.

   \code
   Example: the definition of the intrinsic function (read) defined in the library IO_INTRINSICS.LIB gives the following specification:

   process read =(?string message; ! x )
        spec (| message ^= x |)
        pragmas
           C_CODE "pK_PRINT(&i1); pK_READ&t&o1(&o1) "
           CPP_CODE "cout << &i1 ; cin >> &o1 "
           Java_CODE "System.out.println( &i1 ) ; &o1 = KR.read&t&o1(); if (KR.isEof()) return false "
        end pragmas;

	
   For a reference such that read("Give me a value: ", x) and x an integer, in a Signal program, 
   the C code will be
   -----------------------------------------------
              pK_PRINT("Give me a value: ");
              pK_READint(&x);
   -----------------------------------------------
   pK_PRINT,  pK_READint are predefined C function known by Polychrony.
   &i1 stands for the first inputs, &t&o1 stands for the type of the first output,...
\endcode
 */
virtual boolean /*cGenerator::*/genProcCallNodeWithCodePragma( ptINode ProcCallNode );

/**
   It generates (genPragmaCode()) the code associated with a pragma (valPragma) using interface of a node (ProcCallNode).
 */
virtual void /*cGenerator::*/genPragmaCodeInt( ptINode ProcCallNode ,ptpragma valPragma );

/**
   It generates (genParametrizedCode()) the statement of a pragma (statement) followed by 
   a end of C statement (;) if expg is not a sub term. It uses
   name, params as parameters, expg as outputs, expd as inputs as effectives values in the
   statement. 
   
   Example: see genProcCallNodeWithCodePragma().
 */
virtual void /*cGenerator::*/genPragmaCode( ptident name ,ntrees statement ,ptexpcal param ,ptexpcal expd ,ptexpcal expg );

/**
   It generates the code for the procedure call node inst taking into account the context/clock (genIncrIndexDelayTreeNodes(), genBlockOpeningOf()).
   It calls:
   - genIOCall() for I/O operations
   - genProcCallNodeWithCodePragma() for model with associated code using pragma
   - genNodeIntrinsicFunc() for some intrinsic model
   - genExternalCall() otherwise.
   
   followed by genAssignEquivalence() method.
 
   The node is generated taking account the context given by blackBox for I/O operations only.
   When blackBox is "true", the referenced model is assumed to be a model compiled in separated mode.
 */
virtual void /*cGenerator::*/genProcCallNode( ptINode inst ,boolean blackBox );

/**
   It generates the code for a node call node taking into account the context/clock ( genIncrIndexDelayTreeNodes(), genBlockOpeningOf()).
   It calls:
   - genPragmaCode() for model with associated code using pragma
   - genExternalCall() otherwise

   followed by genAssignEquivalence() method.
 */
virtual void /*cGenerator::*/genNodeCallNode( ptINode node );

/**
   It generates code for a delay node (node) taking into account the context/clock (genBlockOpeningOf()).
   It calls genIncrIndexDelayTreeNode(), genAssignEquivalence().
 */
virtual void /*cGenerator::*/genDelayNode( ptINode node );

/**
   It generates the declaration of the entry point assigned to a sub-graph cluster (aSubGraph). 
   The code is generated taking account the parameters declaration 
   and the context mode (SEPARATE).

   In SEPARATE mode, the cluster will be used for separated compiling, the inputs/outpus of 
   the sub graph are generated as parameters. Otherwise, the cluster is used only in the module, the entry 
   point is declared without formal parameters.
   
   The boolean declaration must be
   - "true" for only a declaration (generation of the header file) 
   - "false" for the definition of the entry point. 
 */
virtual void /*cGenerator::*/genEntryPointSubGraphHeader( ptINode aSubGraph ,boolean declaration );

/**
   It generates code for a reference to the node aSubGraph when it is a Cluster one.
   Such a reference is a procedure call with or without parameters according to the context 
   given by the parameters blackBox and schedulerTrain.
   When blackBox is "false" or schedulerTrain  is "true", the procedure is called without parameters.
 */
virtual void /*cGenerator::*/genRefSubGraphNode( ptINode aSubGraph ,boolean blackBox ,boolean schedulerTrain );

/**
   It generates the loop for a index (indexNode) characterized by a name, a lower bound, an upper bound.
   It calls printIterateIndex().
 */
virtual void /*cGenerator::*/genArrayLoopBegin( ptINode indexNode );

/**
   It applies genIncrIndexDelayTreeNodes() for the outputs of each node of ln.
   It recalls this method for the nodes of a array node of ln.
 */
virtual void /*cGenerator::*/genIncrIndexDelayTreeNodeList( ptlINode ln );

/**
   It generates the code of an array node (node) taking into account the following context informations:
   - blackBox is "true" when the graph is without clusters, "false" otherwise;
   - schedulerTrain is "true" when the node is an element of the scheduller. Otherwise it is internal to a cluster. 
   \note the arrays "processes" are partialy implemented in this version.

   It manages a attribute member (ARRAY_CONTEXT).
   
   It calls the following methods:
   - genIncrIndexDelayTreeNodeList(),
   - genBlockOpeningOf(), 
   - genOrderedNodes() for the initialisations of the array,
   - pushIndex(),
   - genArrayLoopBegin(),
   - genOrderedNodes() for the definition of the body of the array,
   - popIndex()
   - genAssignEquivalence()
 */
virtual void /*cGenerator::*/genArrayNode( ptINode node ,boolean blackBox ,boolean schedulerTrain );

/**
   It generates code for a node (node) taking into account somes contexts.
   It realizes a switch on the type of the node : 
   - genEquNode() for an equation (excluding delays)
   - genDelayNode() for delay/window,
   - genProcCallNode() for an external procedure call,
   - genNodeCallNode() for a node call,
   - genRefSubGraphNode() for a reference to a sub-graph,
   - genArrayNode() for an array process.

  Contexts:
  - blackBox must be "true" when the graph is without clusters, "false" otherwise;
  - schedulerTrain must be "true" when the nodes lOrderedNodes are the nodes of the scheduller.
 */
virtual void /*cGenerator::*/genNode( ptINode inst ,boolean blackBox ,boolean schedulerTrain );

/**
   Misc.
   @return the list of the unoptimized nodes of a list (lOrderedNodes).
 */
virtual ptlINode /*cGenerator::*/getNodesToBeGenerated( ptlINode lOrderedNodes );

/**
   Code generation for a list of nodes(lOrderedNodes) taking into account somes contexts (sgClock, blackBox, schedulerTrain).
  
   @param lOrderedNodes (in) list of nodes to be generate assumed ordered.
   @param sgClock (in) denotes the branching clock of the nodes of lOrderedNodes
   @param blackBox (in) "true" when the graph is without clusters, "false" otherwise
   @param schedulerTrain (in) at "true" when the nodes are the nodes of the scheduller.
 */
virtual void /*cGenerator::*/genOrderedNodes( ptlINode lOrderedNodes ,ptinsth sgClock ,boolean blackBox ,boolean schedulerTrain );

/**
   @return "true" if the operand expression is a reference to a state variable (stateVar?) and its node (node) must be generated, "false" otherwise (node is not set).
 */
boolean /*cGenerator::*/getNodePreStateVariable( ptexpcal exp ,ptexpcal* stateVar ,ptINode* node );

/**
   A state variable  S value of exp parameter (S? named S_previous) must be updated when its value as changed during a step.
   It is done for each partial definition S::= Ei when hi.
   If hi is an undersampling such that hi=X?, S must be updated before X (this test is valid because in the code gneration, the clocks are not substituabled).

   @param exp a state variable
   @param node definiton of exp  (::= or a bundle/struct)
   @param lexp  list of state variables of the program
   @param lres  list of the ordered state variables
   @return  list of the ordered state variables

  */
ptlinstances /*cGenerator::*/stateVariableOrdering( ptexpcal exp ,ptINode node ,ptlinstances lexpr ,ptlinstances* lres );

/**
   This method orders the state variables before the effective code generation.
   A state variable (S? named S_previous) must be updated when its value as changed during a step.
   It is done for each partial definition S::= Ei when hi.
   If hi is an undersampling such that hi=X?, S must be updated before X. This test is valid because in the code gneration, the clocks are not substituabled.
   
   It applies stateVariableOrderingFor() for state variable.
 */
ptlinstances /*cGenerator::*/stateVariablesOrdering( ptlinstances lexpr );

/**
   It generates the updating of the state variables of the graph.
   For a state variable, it computes the list of the "modification clocks" of the state. These 
   clocks are by definition exclusive.

   The generation takes into account the AttributeNameGencode attribute associated with a state variable in stateVariablesAttribute() method.
   
 */
virtual void /*cGenerator::*/genUpdateStateVariables( void );

/**
   @return lh + the modification clocks associated with a node (node).
   \note not implemented for array, structure.
 */
virtual ptlinsth /*cGenerator::*/getListOfModificationClocks( ptINode node ,ptlinsth lh );

/**
   It generates the assignment expg := expd for expd a concatenation (i.e || operator).
 */
virtual void /*cGenerator::*/genConcatenate( ptexpcal expg ,ptexpcal expd );

/**
   It generates the assignment expg := expd for a concatenate operator( || operator ).
   
   @param expg (in) left expression of the assignment.
   @param expd (in) right expression of the assignment to be subscripted using binf parameter.
   @param binf (inout) denotes the current index to use to generate the subscript on expg.
   
   @return the expression obtained by increasing binf by the size of the first dimension of the expression expd.
 */
virtual ptexpcal /*cGenerator::*/genConcatenateElement( ptexpcal expg ,ptexpcal expd ,ptexpcal binf );


