/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

typedef class Colouring * ptDCGColouring;

class Colouring
{

#include "Colouring_m.h"
#include "Colouring_g.h"
  
protected:
  ptDCG AGRAPH;    ///< the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager.
  ptNodeManager NM;   ///< operand graph info: node manager.

  integer aMark;       ///< local mark.
  boolean DCplusGraph, ///< "true" for a DC+ graph.
    bMarkLastContributionClockDefault,  ///< At true when the last contribution clock of default operators mus tbe marked.
    reqDepClocks; ///< At true when the clock of the dependences must be marked as useful.
  ptinsth currentClock; ///< current clock
  ptlINode lboundary;   ///< set of terminals (the operation is not applied for their operands).
};


