/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

#include <set>
#include <map>

typedef class DCG2dot * ptDCG2dot;
typedef std::set<ptdependence> DependenceSet;
typedef std::map< ptinsth, ptlinsth> TDependenceClocks;   

class DCG2dot
{
#include "DCG2dot_m.h"
#include "DCG2dot_g.h"
protected:
  ptDCG AGRAPH;    ///< the functionality is applied to this graph.
  ptExprManager EM;   ///< operand graph info: expression manager.
  ptClockManager CKM; ///< operand graph info: clock manager
  ptNodeManager NM;   ///< operand graph info: node manager.
  GraphLevelType graph_type; ///< graph info: Graph Level in {DC+, bDC+, STS, DC}
  ptlINode lnunused;         ///< graph info: Unused Nodes
  ptlinsth lhunused;         ///< graph info: Unused Clocks
  ptlinsth  lhroots,lhplaced;  ///< roots of the hierarchy, and the placed ones
  fstream fs;            ///< file descriptor.
  typeMark dotAttribute; ///< local attribute, cleaned at the end of the functionality.
  ptlinstances inputs, outputs; ///< Input flows/Output flows of the graph
  ptlINode selectedNodes;   ///< selected nodes for graph of cluster view.
  DependenceSet  printedDependences; ///< list of the visited dependences (already printed)
  boolean GraphOfClusters; ///< true for a graph of clusters, false otherwise.
  TDependenceClocks printedClockDependences; // for unicity. 
};

extern const ptDCG2dot pK_dotPrinter; // Predefined  object
