/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __SMTPrinter__
#define __SMTPrinter__

#include <iostream>
#include <fstream>
#include <string>  
using namespace std;
#include <vector>

typedef class SMTPrinter * ptSMTPrinter;

class SMTPrinter
{
 #include "SMTPrinter_m.h"
 #include "SMTPrinterCertification_i.h"
 #include "SMTPrinter_g.h"

 private:
  ptDCG CurrentDCG;
  ptClockManager CKM;
  ptExprManager EM;
  ptNodeManager NM;
  ptNameManager NAMES;
  ptTraceabilityManager tm;
  ptlinstances Constants,  ///< Graph infos: constants
    Parameters,            ///< Graph infos: parameters
    Indexes;               ///< Graph infos: indexes
  ptlinstances Types;      ///< Graph infos: user types.


 boolean _ERROR_;

  ptlINode unusedNodes;
  ptlinsth unusedClocks;
  GraphLevelType vformat;
  boolean isEventClockedFormat, forceGeneration, modeCert;
  ptlINode lnodestogenerate;

  ptlinstances lsig_CurrentDCG;
  ptlinsth Clocks_CurrentDCG, lhAlreadyGenerated;

  ofstream ofile;

  ptident idMem, idMemCste, idGraph;
  ptident id_true, id_false, formula1_id, formula2_id;
  typeMark vMarkGenerated, vMarkDeclared, vMarkSeen;
  ptident conditionId;
  boolean inComment, indent, restrictedToBooleans, addFuncForConstraints, prog_with_constraints;

  std::vector <ptident> generatedIdentifiers;
  
  ptlinsth lClocksPreviousSystem, lhWithNewNames;
  ptlPointer lPreviousNames;  // for each element of lhWithNewNames, and at the same rank, it exists it previous name in lPreviousNames.
  ptlinsth ClocksForTheNextLevel, ClocksToBeGenerated, lAddedClocks;// OptimizedClocks;
  ptlinstances SignalsForTheNextLevel, lSigAddedOptimized, lsig_PreviousDCG;
  ptlINode lMemoizedNodes_PreviousDCG;
  ptldependence lpreviousIODependences;
  boolean PRINTMEMORY;
  TypeType selectedType;
};

#endif
