

/* 
   Authors: LoÃÂ¯c Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_ DCG_Sigali::DCG_Sigali (ptDCG_poly gp):DCG_poly (gp)
{
}

/** 
    @return "true" if the DCG_Sigali graph (gs) is built from a DCG_poly (gp); "false" otherwise.
    For that it verifies that 
    - the original program does not reference delay $ n, n >1
    - ...
*/
_STATIC_ boolean
DCG_Sigali::mkDCGSigali (ptDCG_poly gp, ptDCG_Sigali * gs)
{
  ptDCG_Sigali g;

  g = new DCG_Sigali (gp);
  if (!g->isTranslatable ())
    {
      delete g;
      return pk_false;
    }
  g->modifyClockNames();
  *gs = g;
  return pk_true;
}

