/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   It solves the clock system using a triangularisation method:
      - (1) the sub-formula are placed: [c] and [not c] are children of ^c (elementary trees are build) (\ref buildExtractionTree ())
      - (2) when two clocks are placed in the same tree, formula build on them can be 
        placed using a hierarchical canonical form using BDD technique; (\ref NormalFormTreePlacing())
      - (3) when (2) cannot be applied, classical boolean reductions are applied to try to start again (2).
        This reductions are parametrized by \b vholophmax, called depth of solving  (\ref BooleanReducing()).

      Each step can induce the reduction of number root clock (merging tree by unification). 

      This technique:
         - tries to proved the constraints explained in the system (two formula in the same clock must be proved equivalent),
         - tries to synthetize, if it exists, the "master clock" of the system,
	 - structures the control of the application for code generation (trees give imbricated blocks of statements).

   Before calling this, you must call \ref systemSolving_init method.
   After calling this, you must call \ref systemSolving_postlude method.
   A typical example is : 

    \code
    Example: CKM is the clock manager and EM is the expression manager of the same graph.
      CKM->systemSolving_init();
      do
       {
           CKM->clockCalculus(ilevelmax);
           EM -> rewritingExprEH();      rewriting when/cell expression
       }
      while(CKM->updateHierarchy());
     CKM->systemSolving_postlude();
     \endcode

\see { buildExtractionTree(), NormalFormTreePlacing(), BooleanReducing(), 
       systemSolving_init(), systemSolving_postlude(), updateHierarchy()
       }
 */
void /*ClockManager::*/clockCalculus( int vholophmax );

/**
   systemSolving_init is initialized from DCG_basic and secondarily from exclusiveClocks
   It initializes clocktreefront and recursively the BDD package and its interfaces
   The null clock is assumed to be defined
   Must be called before \ref clockCalculus.
 */
void /*ClockManager::*/systemSolving_init( void );

/**
   Finalizing the system after solving.
   Must be call after \ref clockCalculus.
 */
void /*ClockManager::*/systemSolving_postlude( void );

/** 
    Updating the hierachy after clock calculus.
    @return true if some placed clocks become roots, "false" otherwise.
    Currently, returns false.
 */
boolean /*ClockManager::*/updateHierarchy( void );

/**
   Applying boolean reductions on the formula of the clock system using a value (holoph) as the max depth for rewritings.
 */
void /*ClockManager::*/booleanReducing( int holoph );

/** 
    It tries to remove the not formula (h*not(k)) using the placed formula but 
    not placed in the same trees. Useful to test if a program is polyendochronous.
 */
void /*ClockManager::*/ReduceMinusFormulae( int vholophmax );


