/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/**
   Constructor.
   It creates a empty clock system.
   The references to the node manager and expression manager are not initialized (use \ref initialize).
 */
  ClockManager::ClockManager ()
{
  DEBUG = /*true; */ pk_false;
  strongInclusionTest = pk_false;
  UsingPlacedConstrainstAlreadyApplied = pk_false;
  treeOperationAuthorized = pk_true;
  mark1 = getMark ();
  mark2 = getMark ();
  hundef = getUndefClock ();
  the_nullClock_CKM_copy = getNullClock ();
  hinit = getInitClock ();
}

ClockManager::~ClockManager ()
{
  // Freeing the unplaced clocks.
  free_clocks (getFormulaList (vari));
  free_clocks (getFormulaList (sub));
  free_clocks (getFormulaList (infer));
  free_clocks (getFormulaList (super));
  free_clocks (getFormulaList (hnot));
  // Freeing the placed clocks
  free_clocks (getlhplaced ());
}
