/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
  Getting the node of a signal. 
  @param  vsig (in) is a signal identifier or an access to an element of an array.
  @returns the node of the signal or the node associated with the element of an array (previously sets by setNodeAccessToArrayElement).
 */
ptINode /*ExprManager::*/getNode( ptexpcal vsig );

/**
  Getting the clock of a signal. 
  @param  vsig (in) is a "variable" expression (signal identifier). 
  @returns the clock of the signal (vsig).
 */
ptinsth /*ExprManager::*/getClock( ptexpcal vsig );

/** 
    Testing NIL expression. 
    @returns "true" if exp is the NIL expression, "false" otherwise.
 */
boolean /*ExprManager::*/isNILEXPCAL( ptexpcal exp );

/** 
    Testing global signal status. 
    @param vexp (in) any signal expression. 
    @returns "true" if vexp is a signal defined by a set of part definitions nodes (set of ::=), 
    "false" otherwise. 
 */
boolean /*ExprManager::*/isSharedSignal( ptexpcal vexp );

/**
   @return "true" if a signal (vsig) is marked as a shared signal by several graphs, "false" otherwise.
 */
boolean /*ExprManager::*/isSharedSignalBySeveralGraphs( ptexpcal vsig );

/** 
    Testing state variable status. 
    @param vexp (in) any signal expression. 
    @returns "true" if vexp is a state variable, "false" otherwise. 
 */
boolean /*ExprManager::*/isStateVar( ptexpcal vexp );

/** 
    Testing output signal. 
   @param exp (in) any signal expression. 
   @returns  "true" if the expression exp is a output signal, "false" otherwise. 
 */
boolean /*ExprManager::*/IsOutputFlow( ptexpcal exp );

/** 
    Testing Input signal. 
    @param exp (in) any signal expression. 
   @returns  "true" if the expression exp is a input signal, "false" otherwise. 
 */
boolean /*ExprManager::*/IsInputFlow( ptexpcal exp );

/** 
    Getting identifier class. 
    @param  exp (in) is a "variable" expression (signal identifier). 
    @returns the class type of a signal (index, signal, parameter,. . . )
 */
typinst /*ExprManager::*/getClassIdentifier( ptexpcal exp );

/** 
    @returns "true" if an expression (exp) is a parameter identifier, "false" otherwise. 
 */
boolean /*ExprManager::*/IsParameter( ptexpcal exp );

/** 
    @returns  "true" if an expression (exp) is a constant identifier, "false" otherwise.
 */
boolean /*ExprManager::*/IsConstant( ptexpcal exp );

/** 
    @returns  "true" if an expression (exp) is a signal identifier, "false" otherwise.  
 */
boolean /*ExprManager::*/IsSignal( ptexpcal exp );

/** 
    @returns  "true" if an expression (exp) is a field of a structure/bundle identifier, "false" otherwise.  
 */
boolean /*ExprManager::*/IsField( ptexpcal exp );

/** 
    @returns  "true" if an expression (exp) is a label identifier, "false" otherwise. 
 */
boolean /*ExprManager::*/IsLabel( ptexpcal exp );

/** 
    @returns "true" if an expression (exp) is an index identifier, "false" otherwise. 
  */
boolean /*ExprManager::*/IsIndex( ptexpcal exp );

/** 
   @returns "true" if an expression (exp) is an external constant, "false" otherwise.
 */
boolean /*ExprManager::*/IsExternalConstant( ptexpcal exp );

/** 
   @returns "true" if a signal (exp) is a signal added by the tool, "false" otherwise.
 */
boolean /*ExprManager::*/IsAuxiliarySignal( ptexpcal exp );

/**
   @param sig (in) assumed to be a "variable" expression (signal identifier). 
   @returns the name of the original signal on which the signal (sig) is built. 
 */
ptident /*ExprManager::*/getOriginalName( ptexpcal sig );

/** 
   @param sig (in) assumed to be a "variable" expression (signal identifier). 
   @returns  the name of the signal (sig). 
  */
ptident /*ExprManager::*/getName( ptexpcal sig );

/**
   @param exp (in) assumed to be a "variable" expression (signal identifier). 
   @returns the tree of the declaration of the signal. This information (abstract tree) is produced by the parser.
 */
ntrees /*ExprManager::*/getTreeOfSignalDeclaration( ptexpcal exp );

/**
   @param  exp (in) is a "variable" expression (signal identifier). 
   @returns  the initialization expression of the signal (exp). 
 */
ptexpcal /*ExprManager::*/getInitialValue( ptexpcal exp );

/** 
    @returns the declared signal of the expression (exp), defined by
    - for a identifier x: x.
    - for a field access (x.y): getDeclaredSignal(x).
    - for an array access (x[y]): getDeclaredSignal(x).
 */
ptexpcal /*ExprManager::*/getDeclaredSignal( ptexpcal exp );

/**
   Fields of structure/bundle management: for a signal of structured type, the compiler assigns a fictitious signal 
   to each field to have the same access (getting clock, getting node,...) than a standart signal. 
   @returns 
   - "true" if an signal instance s is assigned to exp, s is defined by 
      - exp if exp is a standart signal, 
      - getSignalAssignedTo(x,s), when exp is an array access (x[])
      - the value of the attribute FIELD_SIGNAL for a field access (\see setSignalAssignedTo()).

   - "false" otherwise, s is not modified.
 */
boolean /*ExprManager::*/getSignalAssignedTo( ptexpcal exp ,ptexpcal* s );

/** 
    @returns 
    - "true" if a list of signals (ls) is assigned to e. This information is available for a standart signal, or a structure (\see setFieldsOf()).
    - "false" otherwise.
 */
boolean /*ExprManager::*/getFieldsOf( ptexpcal e ,ptlinstances* ls );

/**
   @returns the SIGNAL operator of the expression (exp). 
   See opersignal.h file to have the set of signal operators (incl directory). 
   \see getOperatorClass()
 */
noperators /*ExprManager::*/getOperator( ptexpcal exp );

/** 
    @returns the operator class of the expression (exp).
    \see{cloper, getOperator}. 
 */
cloper /*ExprManager::*/getOperatorClass( ptexpcal exp );

/**
   @param  exp (in) is a "constant" expression (assumed).
   @returns the value of the entry point in the string table of the constant expression (exp).  
   \see{getOperatorClass, getOperator}
 */
ptrepstr /*ExprManager::*/getConstant( ptexpcal exp );

/**
   @param  exp (in) is a "oper1" (unary expression) expression (assumed)
   @returns  the operand of the expression (exp). 
   \see{getOperatorClass, getOperator}
 */
ptexpcal /*ExprManager::*/getUnaryArg( ptexpcal exp );

/** 
    Getting operands of a binary expression. 
   @param exp (in) a binary expression (class operator is equal to "oper2"). 
   @param op1 (out) first child of exp
   @param op2 (out) second operand of exp. 
   \see{getOperatorClass, getOperator}
 */
void /*ExprManager::*/getBinaryArgs( ptexpcal exp ,ptexpcal* op1 ,ptexpcal* op2 );

/** 
    Getting an operand of a binary expression. 
    @param exp (in) a binary expression (class operator is  equal to "oper2"). 
    @param pos  (in) int in [1,2]. 
    @returns the pos-th operand of a binary expression exp. 
    \see{getOperatorClass, getOperator}   */
ptexpcal /*ExprManager::*/getBinaryArgstAt( ptexpcal exp ,int pos );

/** 
    Getting operands of a ternary expression. 
    @param exp (in) a ternary expression (class operator is  equal to "oper3"). 
    @param op1 (out) first child of exp. 
    @param op2 (out) second child of exp. 
    @param op3 (out) third child of exp. 
    \see{getOperatorClass, getOperator}
 */
void /*ExprManager::*/getTernaryArgs( ptexpcal exp ,ptexpcal* op1 ,ptexpcal* op2 ,ptexpcal* op3 );

/** 
    Getting an operand of a ternary expression. 
    @param exp (in) a ternary expression.  (class operator is  equal to "oper3"). 
    @param pos  (in) int in [1,3]. 
    @returns the pos-th operand of a ternary expression. 
    \see{getOperatorClass, getOperator}
 */
ptexpcal /*ExprManager::*/getTernaryArgstAt( ptexpcal exp ,int pos );

/**
   Getting operands of a temporal binary expression (default operator). 
    @param exp (in) is a "oper2tp" expression. 
    @param op1 (out) first operand of exp. 
    @param op2 (out) second operand of exp. 
    \see{getOperatorClass, getOperator}
 */
void /*ExprManager::*/getDefaultArgs( ptexpcal exp ,ptexpcal* op1 ,ptexpcal* op2 );

/** 
    Getting an operand of a temporal binary expression (default operator). 
    @param exp (in) is a "oper2tp" expression. 
    @param pos  (in) int in [1,2]. 
    @returns the pos-th operand of exp. 
    \see{getOperatorClass, getOperator}
 */
ptexpcal /*ExprManager::*/getDefaultArgstAt( ptexpcal exp ,int pos );

/**
   Getting left operand of a when/cell expression. 
   @param exp (in) is a "opereh" expression. 
   @returns the left operand of a when expression. 
   \see{getOperatorClass, getOperator}
 */
ptexpcal /*ExprManager::*/getWhenOrCellArg( ptexpcal exp );

/**
   @return true if the operand expression (vexpcal) is true, "false" otherwise.
 */
boolean /*ExprManager::*/eq_trueExpcal( ptexpcal vexpcal );

/**
   @return true if the operand expression (vexpcal) is false, "false" otherwise.
 */
boolean /*ExprManager::*/eq_falseExpcal( ptexpcal vexpcal );

/**
   Getting right operand of a when/cell expression. 
   @param vexp (in) is a "when/cell" expression (OperatorClass(exp) = opereh).
   @returns the right operand of a when expression.  
   The test on class operator must be done before this call. 
   \see{getOperatorClass, getOperator}
 */
ptinsth /*ExprManager::*/getContributionClock( ptexpcal vexp );

/**
   @returns "true" if an expression (exp) is a list of expressions, "false" otherwise.
   \see{getOperatorClass, getOperator}
  */
boolean /*ExprManager::*/satisfiesList( ptexpcal exp );

/** 
    Getting operands of a list of expressions. 
    @param list (in/out) a list expression represented as a combed binary expression 
    (class operator is equal to "oper2").  
    @param list (in/out) tail of the input list. 
    @param arg (out) the head element of list (in), if input list is not empty. 
    @returns "true" if input list is not empty, "false" otherwise.
    \see{getNaryArgs, getSize}
 */
boolean /*ExprManager::*/getNaryArgs( ptexpcal* list ,ptexpcal* arg );

/** 
    Getting operands of a list of expressions. 
    @param list (in/out) a list expression represented as a combed binary expression 
    (class operator of list is equal to "oper2"). 
    @param list (in/out) tail of the input list. 
    @returns the head element of the input list, NILEXPCAL for an empty list. 
    \see{getNaryArgs, getSize}
 */
ptexpcal /*ExprManager::*/getNaryArgs( ptexpcal* list );

/**
   Getting size of a list. 
   @param list (in) a list expression represented as a combed binary expression. 
   @returns the size of the list operand
 */
int /*ExprManager::*/getSize( ptexpcal list );

/**
   Getting operands of an external function expression (e), i.e. its class operator is equal to "appel". 
   @param e (in) an expression
   @param id (out) : the name of the function. 
   @param lp (out) : the list of parameters. 
   @param inputs (out) : the list of input expressions. 
   @returns 
   - "true" if e is a function call, the output parameters are set,
   - "false" otherwise, the output parameters are not modified.
 */
boolean /*ExprManager::*/getFunctionCall( ptexpcal e ,ptident* id ,ptexpcal* lp ,ptexpcal* inputs );

/** Testing expression class to when/cell expression. 
  @param vexp (in) an any expression
  @returns "true" if vexp denotes an "opereh" expression (E when h, E cell h), "false" otherwise. 
 */
boolean /*ExprManager::*/IsWhenOrCellExpr( ptexpcal vexp );

/** Testing expression to cell expression. 
   @param exp (in) any signal expression. 
   @returns  "true" if the expression is a cell one (E cell h), "false" otherwise. 
 */
boolean /*ExprManager::*/IsCellExpr( ptexpcal exp );

/** Getting operand of a type expression. 
    @param exp (in) an expression assumed to be a reference to a type (i.e. its class operator must be equal to "opertyp").
    @returns the referenced type T of the expression. 
    \see{getOperatorClass}
 */
TypeType /*ExprManager::*/getExpType( ptexpcal exp );

/** 
    Getting the type of an expression. 
    @param exp (in) any signal expression. 
    @returns  the type of the expression exp. 
 */
TypeType /*ExprManager::*/getType( ptexpcal exp );

/**
   Getting the array type information of an expression. 
   @param exp (in) any signal expression. 
   @param baseType (out) the elementary type of the expression exp if it is a array 
   or the type of the expression.
   @param dimLst (out) the list of Dimensions if it is a array, NILEXPCAL otherwise.
   @returns "true" if the type of the operand expression is an array, "false" otherwise.
 */
boolean /*ExprManager::*/getTypeAndDim( ptexpcal exp ,TypeType* baseType ,ptexpcal* dimLst );

/** Getting the unamed type of an expression (misc). 
  @param exp (in) any signal expression. 
  @returns the unamed type of the expression exp. 
 */
TypeType /*ExprManager::*/getUnamedType( ptexpcal exp );

/** Testing type of an expression to event type. 
   @returns "true" if the type of the expression  exp is event, "false" otherwise. 
 */
boolean /*ExprManager::*/IsEvent( ptexpcal exp );

/** Testing type of an expression to boolean type. 
   @returns "true" if the type of the expression exp is boolean, "false" otherwise. 
 */
boolean /*ExprManager::*/IsBoolean( ptexpcal exp );

/** Testing type of an expression to free type (misc). 
   @returns "true" if the expression is not typed, "false" otherwise.
 */
boolean /*ExprManager::*/IsFreeType( ptexpcal exp );

/** Testing type of an expression to int type. 
   @returns "true" if the type of exp is int (predefined int, short,...), "false" otherwise.
 */
boolean /*ExprManager::*/IsInteger( ptexpcal exp );

/**
  Testing type of an expression to predefined type. 
  @returns "true" if the type of the operand expression is a predefined one, "false" otherwise. 
 */
boolean /*ExprManager::*/IsTypeExprPredefinedType( ptexpcal exp );

/** Getting number of a dimensions of a type of an expression. 
   @param exp (in) any signal expression. 
   @returns the number of dimensions of the type of the expression exp. 
 */
int /*ExprManager::*/getNumberOfDimensions( ptexpcal exp );

/**
   @returns 
   - "true" if the i-th dimension (ithDim) of a signal (vsig) exists, ithDimExpr is then its expression
   - "false" otherwise, ithDimExpr is not modified.
 */
boolean /*ExprManager::*/getIthDimension( ptexpcal vsig ,long int ithDim ,ptexpcal* ithDimExpr );

/** 
    Getting back information to clock system. 
    @param vexp (in) any signal expression. 
    @param vhsub (out) the extraction (clock) built on vexp. 
    @returns "true" if the extraction vhsub exists in the clock system, "false" otherwise. 
 */
boolean /*ExprManager::*/getExtractionLink( ptexpcal vexp ,ptinsth* vhsub );

/** Misc. It should be internal of the manager.\n
    @param vexp (in) any signal expression. 
    @param nexp (out) the current equivalent expression of vexp (rewritting result)
    @returns "true" is such expression exists, "false" otherwise. 
 */
boolean /*ExprManager::*/getIndirection( ptexpcal vexp ,ptexpcal* nexp );

/** 
    Getting the set of nodes connected to an expression. 
    For example, for the node n defined by x:=E, x and E have n in such a set. 
    @param vexp (in) any signal expression. 
    @returns the list of the nodes connected to the expression. 
 */
ptlINode /*ExprManager::*/getNodesFeedBy( ptexpcal vexp );

/**
   Getting all the identifiers referenced in an expression.
   @param vexp (in) any signal expression.
   @returns the list of identifiers (signal, constants, labels . . . ) referenced in the operand expression (vexp). 
 */
ptlinstances /*ExprManager::*/getIdsReferencedIn( ptexpcal vexp );

/**
   Getting all the constants referenced in an expression.
   @param vexp (in) any signal expression.
   @returns the list of identifiers (signal, constants, labels . . . ) referenced in the operand expression (vexp). 
 */
ptlinstances /*ExprManager::*/getConstantsReferencedIn( ptexpcal vexp );

/**
   Getting signals and fields identifiers referenced in an expression. 
   @param vexp (in) any signal expression. 
   @returns the list of identifiers (signal) referenced in the operand expression.
 */
ptlinstances /*ExprManager::*/getFieldsAndSignalsReferencedIn( ptexpcal vexp );

/** Getting signals referenced in an expression. 
   @param vexp (in) any signal expression. 
   @returns the list of identifiers (signal) referenced in the operand expression. 
 */
ptlinstances /*ExprManager::*/getSignalsReferencedIn( ptexpcal vexp );

/** Getting indexes referenced in an expression. 
   @param vexp (in) any signal expression. 
   @returns the list of identifiers (indexes) referenced in the operand expression. 
 */
ptlinstances /*ExprManager::*/getIndexesReferencedIn( ptexpcal vexp );

/** 
    Getting signals annotated as possibly used as indexes referenced in an expression. 
    @param vexp (in) any signal expression. 
    @returns the list of identifiers (indexes) referenced in the operand expression. 
 */
ptlinstances /*ExprManager::*/getPossiblyIndexesReferencedIn( ptexpcal vexp );

/**
   @returns the list of the signals referenced in an expression (e) taking into account the associations:
   for a field reference (x.f) if a signal (y) is associated with it, y is considered not x.f.
   (\see setSignalAssignedTo())
 */
ptlinstances /*ExprManager::*/getSignalsDefinedIn( ptexpcal e );

/** 
    Getting inner expression filtering when/cell operators. 
    @param vexp (in) an any expression
    @returns the left operand of the operand expression until such operand is not a cell/when expression.
    \note no effect for a default expression: vexp is returned.
 */
ptexpcal /*ExprManager::*/getBasicExpr( ptexpcal vexp );

/** 
    Testing an expression: is it an expression on constants ?.
    @param exp (in) an any expression
    @returns "true" if an expression (exp) is an expression on constants, "false" otherwise
 */
boolean /*ExprManager::*/IsConstantExpr( ptexpcal exp );

/** 
    @returns "true" if all elements of an expression (exp) are defined by the same expression (vce), "false" otherwise.
    @param vce (out) the expression that defines exp expression.
    @param exp (in) exp expression sur signal.
    \note \DocNotComplete (spacial processing).
 */
boolean /*ExprManager::*/IsSameExpressionForEachElement( ptexpcal exp ,ptexpcal* vce );

/**
   Getting the root (representative signal) of aggregations from a signal (optimization). 
   @param exp (in) any signal expression. 
   @returns the representative signal of the signal ?exp.  
   It uses the attribute AGGREGATTRIBUTE (predefined attribute, declared in CompilerAttributes.h file).

   Example:
   For the following SIGNAL example (| x := y when c | z := x cell d |),
   the signals x, y and z can be represented by the same variable. It is used for optimisations.
 */
ptexpcal /*ExprManager::*/getAggregation( ptexpcal exp );

/**
   Testing aggregation informations for a signal (optimizations).  
   @param exp (in) any signal expression. 
   @returns "true" if the signal ?exp is not a representative signal for the code generation, "false" otherwise.
   \note 
   It uses the attribute AGGREGATTRIBUTE (predefined attribute, declared in CompilerAttributes.h file).
 */
boolean /*ExprManager::*/isAggregatedSignal( ptexpcal exp );

/**
  Getting int value of an expression. 
  @param vexp (in) any signal expression. 
  @param val (out) value assigned if it exists to the exp expression. 
  @returns "true" if val (out) is defined, "false" otherwise.
 */
boolean /*ExprManager::*/getIntegerValue( ptexpcal vexp ,compilerInteger* val );

/**  Testing "bounded" property. 
     @returns "true" if the exp expression is bounded, "false" otherwise.
  */
boolean /*ExprManager::*/IsBounded( ptexpcal exp );

/**
   @return "true" if the expression lb is bounded and the values are available (bi: lower bound, bs: upper bounbd), "false" otherwise.
   bi = bs for a valued signal.
 */
boolean /*ExprManager::*/getBounds( ptexpcal exp ,compilerInteger* bi ,compilerInteger* bs );

/**  Testing "defined" property. 
    @returns "true" if the exp expression is defined but not valued, "false" otherwise.
 */
boolean /*ExprManager::*/IsDefinedSignal( ptexpcal exp );

/**  
     Testing  if a signal is free (not defined, not assigned, ...). 
     @returns "true" if the exp expression is defined but not valued, "false" otherwise.
 */
boolean /*ExprManager::*/IsFreeSignal( ptexpcal exp );

/**  Testing value of an expression. 
     @returns "true" if the value of exp expression is known: int greater/equal to 0, "false" otherwise.
 */
boolean /*ExprManager::*/hasIntegerValue( ptexpcal exp );

/** Testing "assigned" property.
   @returns  "true" if the expression exp is an valued int expression, "false" otherwise.
 */
boolean /*ExprManager::*/IsAssigned( ptexpcal exp );

/** Getting int value of an expression. 
    Assumed : exp is supposed to be an "assigned" expression.
    @returns  the value assigned to the expression (exp).  
   \see{IsAssigned}. 
 */
long int /*ExprManager::*/getValue( ptexpcal exp );

/** Getting the list of referenced signals in an expression without state variable reference.
   @param exp  (in) an Synchronous expression. 
   @returns a list of signals such that x[], x[?], x, x. y , without state variables. 
 */
ptlinstances /*ExprManager::*/getPredecessors( ptexpcal exp );

/** Testing the existence of a opIndex-nth child for the expression e. 
   @param e (in) an signal expression. 
   @param opIndex  (in) an int. 
   @returns "true" if the opIndex-nth child exists, "false" otherwise. 
 */
boolean /*ExprManager::*/existChild( ptexpcal e ,int opIndex );

/** Getting clock of some expression. 
   @param pt (in) a expression of { variabl, oper1, oper2,opereh} class. 
   @param vh (out) the clock of the expression (if found)
   @returns "true" if the clock (vh) of the expression is set, "false" otherwise. 
 */
boolean /*ExprManager::*/getSynchronousExprHorl( ptexpcal pt ,ptinsth* vh );

/** Getting clock of an expression. 
   @param exp (in) a signal expression. 
   @param h  (out) clock of the expression. 
   @returns "true" if the clock (h) has been found, "false" otherwise (constant expression for example). 
 */
boolean /*ExprManager::*/getExprClock( ptexpcal exp ,ptinsth* h );

/**
   Indexed signals (array process).
   @returns  the exception expression assigned to the signal (exp).

   \note \DocNotComplete.
   It is managed for "with part" of array processes.  
 */
ptexpcal /*ExprManager::*/getException( ptexpcal exp );

/**
   Indexed signals (array process). 
   @returns the signal (exp) without array indexes. 
 */
ptexpcal /*ExprManager::*/getUnindexedSignal( ptexpcal vexp );

/**
   @returns the abstract tree assigned, previously set by a call to the method setBackAnnotation(), with an expression (n).
 */
BackAnnotationType /*ExprManager::*/getBackAnnotation( ptexpcal n );

/**
   @returns "true" if for the expression (vexp) is  x, x[], x?, x.y ans x a state variable, "false" otherwise.
 */
boolean /*ExprManager::*/isReferenceToStateVar( ptexpcal vexp );

/**
   Getting travel indexes assigned to an expression.
   @param exp (in) a signal expression.
   @param l (out) the list of the travel indexes assigned to the operand expression.
   @returns "true" if (*l) is not empty, "false" otherwise.
   \note \DocNotComplete (what is a "travel index"?)
 */
boolean /*ExprManager::*/getTravelIndexes( ptexpcal exp ,ptlinstances* l );

/**
   Array processes management:
   @returns "true" if it exists a clone (vClone) of v, "false" otherwise (vClone is not modified).
   A clone is a copy of an identifier used in array of processes (x[I] is a clone of x, x[I][J] is a clone of x[I],...)
   Note that the clones are managed by a circular list with a header element.
   See isCloneClassHead(), setClone().
 */
boolean /*ExprManager::*/getClone( ptexpcal v ,ptexpcal* vClone );

/** Array processes management:
    @returns "true" if a signal (v) is the "clone class head" element, "false" otherwise.
    \see {setClone(), setCloneClassHead()}
 */
boolean /*ExprManager::*/isCloneClassHead( ptexpcal v );

/**
   @returns the clone class head for a signal (v). It is v when there is no associated clone.
 */
ptexpcal /*ExprManager::*/getCloneClassHead( ptexpcal v );

/**
   @returns "true" the utility clock (hu) of a signal (exp) is defined, "false" otherwise.
 */
boolean /*ExprManager::*/getUtilityClock( ptexpcal exp ,ptinsth* hu );

/**
   @returns "true" the utility clock (hu) of a signal (exp) in a subgraph (sg) is defined, "false" otherwise.
 */
boolean /*ExprManager::*/getUtilityClockInSubGraph( ptexpcal exp ,ptINode sg ,ptinsth* hu );

/**
   @returns pk_true the assignment clock (hu) of a signal (exp) is defined, false otherwise.
 */
boolean /*ExprManager::*/getAssignmentClock( ptexpcal exp ,ptinsth* vassclk );

/**
   @returns pk_true the assignment clock (hu) of a signal (exp) is defined, false otherwise.
 */
boolean /*ExprManager::*/getDefaultConstantValueInfos( ptexpcal exp ,ptinsth* vh ,ptexpcal* vExpr );

/** 
   @param vexp (in) any expression.
   @returns the list of contribution clock referenced in the expression.
 */
ptlinsth /*ExprManager::*/getClocksReferencedIn( ptexpcal vexp );

/**
   @return "true" if exp is a default, "false" otherwise.
 */
boolean /*ExprManager::*/isDefaultExpression( ptexpcal exp );

/**
   @returns 
     "true" if an expression (exp) is a logical expression (i.e. identifier | not(E) | E1 or E2 | E1 and E2), 
     "false" otherwise.
 */
virtual boolean /*ExprManager::*/isLogicalBooleanExpression( ptexpcal exp );

/**
   Specific to array processes.
   @returns "true" if the expression e does not depend on "current" indexes of array processes, "false" otherwise.   
   \note \DocNotComplete.
 */
boolean /*ExprManager::*/isIndexDependent( ptexpcal e );

/**
   Syntactic expression equivalence.
   @param exp1, exp2 (in) signal expressions.
   @param lookvalue (in) a boolean used to 
   @returns 
   - "true" if the operand expressions are syntacticly identical (lookvalue is "false") or have the same value (lookvalue is "true")
   - "false" otherwise.
 */
boolean /*ExprManager::*/isEquivalent( ptexpcal exp1 ,ptexpcal exp2 ,boolean lookvalue );

/**
   Getting references to a signal. 
   @returns the list of the references to the expression exp.
 */
ptlexpcal /*ExprManager::*/getLuse( ptexpcal exp );

/**
   Getting the number assigned to an expression. 
   @returns the number (unicity is guaranteed) assigned to exp.
   */
int /*ExprManager::*/getNum( ptexpcal exp );

/** 
    Optimized travel indexes.
    @param exp (in) a signal expression.
    @returns the list of optimized travel indexes assigned to an expression.
    \note \DocNotComplete (what is a "travel index"?, what is an optimized "travel index"?)
 */
ptlinstances /*ExprManager::*/getOptimizedTravelIndexes( ptexpcal exp );

/** 
    It tests the initial value compatibility: 
    two expressions exp1, exp2 are compatibles if they are constant expressions with the same value.
    A constant expression is a constant, a parameter identifier, a constant identifier, or an op(e1,..,en) and each ei are constant expressions.
    
    @returns "true" if such property is satisfied, "false" otherwise.
    \note incomplete test.
 */
boolean /*ExprManager::*/IsCompatibleWith( ptexpcal exp1 ,ptexpcal exp2 );

/**
   @param vexp  (in) any expression.
   @param nexp (out) equivalent expression of vexp obtained using valuations.
   @param brestrict (in) with the value "true" only the int synchronous expressions are tested.
   When it is pk_false, the expression must be the definition of a signal (ie X:= vexp), to have no problem with the clocks.
   @returns "true" if nexp is set, "false" otherwise.
 */
boolean /*ExprManager::*/getEquivConstant( ptexpcal vexp ,ptexpcal* nexp ,boolean brestrict );

/**
   @return "true" if the operation succeeds, "false" otherwise (vexp is not a constant expression).
   For an evaluated expression (vexp), nexp is the expression of the associated constant.
 */
boolean /*ExprManager::*/getExprOfConstant( ptexpcal vexp ,ptexpcal* nexp );

/**
   @return "true" if vsig is defined by (expr when ^expr), with expr ^= vsig, expr is a synchronous expression, 
   "false" otherwise.
 */
boolean /*ExprManager::*/getSyncExprDefSig( ptexpcal vsig ,ptexpcal* expr );

/**
   It returns the expression to be exported (boolean clocks) for the clock "when vsig" where vsig is a signal (X).
   For X := (E when h), ^E = h, E not a default, not a left_tt, if
     - E is an expression built on I/O signals, E is returned, bpos = pk_true
     - not E  and E is an expression built on I/O signals, E is returned, bpos = false
     - not Y, and Y is a signal, it returns the result of the method applied to Y, bpos = 
     - otherwise, it returns X

   The second parameter bpos is set to "true" when the result is the expression, "false" when it is the not of the result.
 */
ptexpcal /*ExprManager::*/getExprExportBooleanAbtraction( ptexpcal vsig ,ptlinstances laddedSignals ,boolean* bpos );

/**
   @return "true" if a signal is unified with a clock (clk), "false" otherwise.
 */
boolean /*ExprManager::*/isSignalUnifiedWithClock( ptexpcal aSig ,ptinsth* clk );

/**
   @return the identifier associated with a boolean expression (exp) according the "naming in boolean expressions" rules.
 */
ptident /*ExprManager::*/getNameBooleanExpression( ptexpcal exp );

/**
   @return "true" if vExpr is the expression "vsig $1 ", "false" otherwise.
 */
boolean /*ExprManager::*/isDelayOneOf( ptexpcal vExpr ,ptexpcal vsig ,ptexpcal* vinit );

/**
   @return the list composed of the elements of ls, declared as input/output.
 */
ptlinstances /*ExprManager::*/getIOflows( ptlinstances ls );

/**
   @return "true" if v1 and v2 are not equal integer constant value, or not equal enumetared value, "false" otherwise.
  */
boolean /*ExprManager::*/TestExclusiveConstants( ptexpcal v1 ,ptexpcal v2 );

/**
   @return "true" if cond1 and cond2 are exclusives when cond1 is used in a sub  (bpos1 true) or nosub (bpos1 false) 
   and  when cond2 is used in a sub  (bpos2 true) or nosub (bpos2 false), "false" otherwise.
  */
boolean /*ExprManager::*/TestExclusiveConditions( ptexpcal cond1 ,boolean bpos1 ,ptexpcal cond2 ,boolean bpos2 );

/**
   @return the declared type of a signal(vsig), or undefined type if vsig is not an identifier.
  */
TypeType /*ExprManager::*/getDeclaredType( ptexpcal vsig );

/**
   Code Generation.
   @return the expression to generate associated with exp.
   The returned expression can be different from exp when some compiler attributes are associated 
   with the expression (OPTIMIZED_ATTRIBUTE, OPTIMIZED_MEMORY_ATTRIBUTE). It also looks at 
   the clone (getCloneClassHead()) and the aggregation getAggregation()).
 */
ptexpcal /*ExprManager::*/getExpressionToGenerate( ptexpcal exp );


