/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   It substitutes (see expReplace()) an expression (e1) by an another one (e2), given a context clock (h).
   The clock is used only when e2 is a constant and h is not the undefined clock, in this case 'e1' is replaced by 'e2 when h'.
 */
void /*ExprManager::*/substitute( ptexpcal e1 ,ptexpcal e2 ,ptinsth h );

/**
   Updating the nodes that reference the expression e1.
   The reference to e1 is replaced by e2 and the node is added to the list of the modified nodes (lModifiedNodes).
 */
void /*ExprManager::*/updateNodes( ptexpcal e1 ,ptexpcal e2 );

/**
   It replaces an expression (e1) by an another one (e2), given a context clock (h). 
   If the two expressions are signal identifiers, there is a possible change of the name.

   The clock is used only when e2 is a constant and h is not the undefined clock, 
   in this case 'e1' is replaced by 'e2 when h'.

 */
void /*ExprManager::*/expReplace( ptexpcal e1 ,ptexpcal e2 ,ptinsth h );

/** 
    It updates the clocks of all the expressions (when, cell) that reference clocks.
    It calls rewritingWhenExpr(), rewritingCellExpr().
 */
void /*ExprManager::*/rewritingExprEH( void );

/**
   It substitutes all the evaluated expressions of the manager by their values excepted the output signals
   and some specific cases.
   @return "true" if a substitution is applied, "false" otherwise.
 */
boolean /*ExprManager::*/substituteEvaluatedExpression( void );

/**
   It replaces TT#velem expression by TT#newelem in the expression manager.
   @return "true" is such an expression exists in the manager, "false" otherwise.
 */
boolean /*ExprManager::*/refTypeSubstitute( TypeType TT ,ptrepstr velem ,ptrepstr newvelem );

/**
   It replaces all references to field structures by signals.
   An acces x.t is replaced by the internal signal assigned to it in the manager.
   \see getSignalAssignedTo(), setSignalAssignedTo()
 */
void /*ExprManager::*/replaceFieldBySignal( void );

/** 
    It substitutes an expression (vexp), where vexp is a state variable, by an another one (nexp).
    It can be used when a state variable may be replaced by a signal.
 */
void /*ExprManager::*/substituteStateVariablePreviousBy( ptexpcal vStateVariable ,ptexpcal vSignal );

/**
   @return "true" if the operand (vexp) is a left_tt expression, "false" otherwise.
   A vexp=left_tt(e1, e2) expression is rewritten in nvexp = (e1 when ^e1) default pk_false, and the
   contribution clock of nvexp is set to vContribClock.
 */
boolean /*ExprManager::*/lefttts2defaults( ptexpcal vexp ,ptinsth vContribClock ,ptexpcal* nvexp );

/**
   It substitutes some intrinsic expressions (dim(T), size(T,i)) by their values.
 */
void /*ExprManager::*/intrinsicEvaluation( void );

/**
   It replaces an expression (vexp) by an another one (nexp) in the manager.
   It applied substitute(), rewriting() methods and set an indirection from vexp to nexp.
 */
void /*ExprManager::*/replace( ptexpcal vexp ,ptexpcal nexp );

/**
   @param vexp (in) any expression.
   @param nexp (out) a equivalent expression of vexp using the following rules:
   -  E >= E, E<=E, E=E ---> 'true' expression
   -  E > E, E < E, E <> E ---> 'false' expression
   -  E = F and F << E ---> F=E   (<< Order on expressions)
   -  E < F ---> (E <= F) and not(E=F) 
   -  E > F ---> (F <= E) and not(E=F)
   -  E >= F --->  F <= E
   -  E <= F and F << E --->  (E=F) or not (F <= E)
   -  E != F --> not (E=F)
   -  Warning : Signal substitution is NOT applied.

   @return "true" if no rule have been applied (nexp = vexp), "false" otherwise.
 */
boolean /*ExprManager::*/normFormRelationalExpr( ptexpcal vexp ,ptexpcal* nexp );

/** 
    Event signals becomes booleans (always "true").
    After this method, the pure type is not referenced in the expression manager, only for the "true" expression.
 */
virtual void /*ExprManager::*/events2booleans( void );

/**
   It adds in an expression (exp) the explicit conversions to a type (vtype)  of the sub-expressions of exp.
   Assmed : vtype is a predefined type.
 */
ptexpcal /*ExprManager::*/explicitConversions( TypeType vtype ,ptexpcal exp );

/**
   aWhen is assumed to be an expression such that (E when h).
   @return the definition of the signal S (E is a signal) and
   - S is defined by an equation (not a dynamical expression), 
   - S does not have a direct recursive definition.
 */
ptexpcal /*ExprManager::*/rewriteWhen( ptexpcal aWhen ,ptexpcal s );

/**
   The operand expression (exp) is assumed to be a default expression (i.e.  (E1 when h1) default ...default (En when hn), Ei are synchronous expressions).
   The expression (exp) is assumed to be a sub expression of the definition of a signal s.
   
   When an expression Ei is reduced to a signal (X) and the signal is also defined by an equation (i.e.  X:=  F1 when k1 default ...Fm when km),
   then (Ei when hi) is replaced by ( F1 when k1 default ...Fm when km) when hi. The resulting expression is then normalized.
   @return the expression produced by such substitutions, or the operand expression (exp) when it it not rewritten.

 */
ptexpcal /*ExprManager::*/rewriteDefault( ptexpcal exp ,ptexpcal s );

/**
   @return "true" if the operand expresseion (e) may be removed from the graph, "false" otherwise.
   - An output signal cannot be removed.
   - A signal used in a placed clock cannot be removed.
   - A signal marked "DontOptimize" cannot be removed
 */
boolean /*ExprManager::*/mayBeRemoved( ptexpcal e );

/**
   Assumed: exp is a when expression (E when H) and lexp is a list of when expressions.
   @return "false" if it exists an expression (E when K) is lexp, it is replaced by (E when H ^+ K), "true" otherwise and exp is added to lexp.
 */
boolean /*ExprManager::*/addExpToDefaultList( ptlinstances* lexp ,ptexpcal exp );

/**
   @return 
   - "true" if the rule, (E when H) default (E when K) --> E when (H ^+ K), is applied on the operand expression (exp). lnexp contains the resulting elements (a set of "Ei when Hi"),
   - "false"otherwise and lnexp is set to NILLINSTANCES.
 */
boolean /*ExprManager::*/normalDefaults( ptexpcal exp ,ptlinstances* lnexp );

/**
   @return a new expression in which the expression e1 is replaced by e2 in an expression (use).
   The references are not rewritten.
 */
ptexpcal /*ExprManager::*/replace( ptexpcal e1 ,ptexpcal e2 ,ptexpcal use );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ExprManager::*/replaceDefault_xx( ptinsth vh1 ,ptinsth vh2 ,ptexpcal exp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ExprManager::*/replaceWhen_xx( ptinsth vh1 ,ptinsth vh2 ,ptexpcal exp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*ExprManager::*/replace__( ptinsth vh1 ,ptinsth vh2 ,ptexpcal exp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptexpcal /*ExprManager::*/replaceWhen( ptinsth vh1 ,ptinsth vh2 ,ptexpcal exp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptexpcal /*ExprManager::*/replaceDefault( ptinsth vh1 ,ptinsth vh2 ,ptexpcal exp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptexpcal /*ExprManager::*/replace( ptinsth vh1 ,ptinsth vh2 ,ptexpcal exp );


