/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/**
   @return  the type of the node (node).
   (\see sort-of-nodes )
 */
noperators /*NodeManager::*/get_oper( ptINode node );

/** @return  the number associated with a node (aNode).  */
int /*NodeManager::*/get_num( ptINode aNode );

/** @return "true" if the type of a node (aNode) is not set, "false" otherwise.  */
boolean /*NodeManager::*/is_undefined( ptINode aNode );

/** @return  "true" if the node (aNode) is a node call node, "false" otherwise.
    \see{get_nodeCall_arg, is_outputNodeCall, get_nodeCall_graph}
 */
boolean /*NodeManager::*/isNodeCall( ptINode aNode );

/** @return  "true" if the node (aNode) is a delay node, "false" otherwise.
    \see{get_rightOperand, get_leftOperand, get_delay_arg}
 */
boolean /*NodeManager::*/is_delay( ptINode aNode );

/** @return  "true" if the node (aNode) is a composed node (with fields), "false" otherwise.
    \see{get_lfields}
 */
boolean /*NodeManager::*/is_lfields( ptINode aNode );

/** @return  "true" if the node (aNode) is a subgraph node node, "false" otherwise.  */
boolean /*NodeManager::*/is_subgraph( ptINode aNode );

/** Getting the  operands of an equation (for delays, see get_delay_arg()) node (aNode).
    - op1 : expression of the left operand;
    - op2 : expression of the rigth operand;
    \see{get_rightOperand, get_leftOperand}
 */
void /*NodeManager::*/get_equation_arg( ptINode aNode ,ptexpcal* op1 ,ptexpcal* op2 );

/** Getting the operands of a delay (aNode):  # resret := sigret $ vret window vfen init vinit #
    - resret : expression of the left operand;
    - sigret : expression of the delayed signal;
    - vret : expression of the delay;
    - vfen : expression of the window;
    - vinit : expression of the initialisation.

    \see{get_rightOperand, get_leftOperand}
 */
void /*NodeManager::*/get_delay_arg( ptINode aNode ,ptexpcal* resret ,ptexpcal* sigret ,ptexpcal* vret ,ptexpcal* vfen ,ptexpcal* vinit );

/**
   @return the signals (or fields) defined in a composed node (aNode) associated with a strutured type.
 */
ptlinstances /*NodeManager::*/get_lfields_arg( ptINode aNode );

/** @return  for a read/write node the referenced signal, "nil" expression otherwise.  */
ptexpcal /*NodeManager::*/get_io_arg( ptINode node );

/** Getting the operands of a procedure call node (aNode).
    - idCall: the name of the procedure call;
    - OrderedInputs: the set of the input signal expression (left combed expression);
    - OrderedOutputs: the set of the output signals (left combed expression);
 */
void /*NodeManager::*/get_procCall_arg( ptINode aNode ,ptident* idCall ,ptexpcal* params ,ptexpcal* OrderedInputs ,ptexpcal* OrderedOutputs );

/**  Getting the operands of a node call node (aNode).
     - vg : the referenced graph;
     - OrderedParams : the set of the parameters (left combed expression);
     - OrderedInputs : the set of the input signals expressions (left combed expression);
     - OrderedOutputs : the set of the output signals (left combed expression);
 */
void /*NodeManager::*/get_nodeCall_arg( ptINode aNode ,ptDCG* vg ,ptexpcal* OrderedParams ,ptexpcal* OrderedInputs ,ptexpcal* OrderedOutputs );

/**
   @return  "true" if the node (aNode) is an equation (for a delay \see is_delay), "false" otherwise.
   \see{get_rightOperand, get_leftOperand, get_equation_arg}.
 */
boolean /*NodeManager::*/is_equation( ptINode aNode );

/**
   @return 
   - "true" if the node (aNode) is a procedure call, id is its name.
   - "false" otherwise, id is not modified.
 */
boolean /*NodeManager::*/get_nameCall( ptINode aNode ,ptident* id );

/** 
    @return  "true" if the node (aNode) is a call to a intrinsic function, "false" otherwise.
    These functions are defined in the SIGNAL module SIGNAL_PREDEF.LIB of the exe.dir directory.
 */
boolean /*NodeManager::*/is_intrinsicfunc( ptINode aNode );

/** @return 
    - "true" if a node (aNode) is an input produced by the node call returned in nodecall, 
    - "false" otherwise, nodecall is not modified. 
 */
boolean /*NodeManager::*/is_outputNodeCall( ptINode aNode ,ptINode* nodecall );

/**
   @return the graph referenced in a node, assumed to be a node call (aNode).
 */
ptDCG /*NodeManager::*/get_nodeCall_graph( ptINode aNode );

/**
   @return "true" if a node (aNode) is a procedure node (i.e. a node call without reference to a graph).
 */
boolean /*NodeManager::*/isProcessCall( ptINode aNode );

/** @return 
    - "true" if the name of a node assumed to be a node of a sub-graph (aSubGraph), is defined; returned in id,
    - "false" otherwise, id is not modified.
 */
boolean /*NodeManager::*/get_clusterName( ptINode aSubGraph ,ptident* id );

/**
   @return true if a label (vlabel) is associated with a node (aNode), false otherwise.
 */
boolean /*NodeManager::*/get_label( ptINode aNode ,ptexpcal* vlabel );

/**
   @return "true" if a node (aNode) denotes a train cluster, "false" otherwise.
 */
boolean /*NodeManager::*/is_trainCluster( ptINode aNode );

/** 
    @return 
    - "true" if a node (aNode) denotes a sub-graph; then, le (resp. ls) is the inputs (resp. outputs) of the sub-graph.
    (le and ls are left combed expressions).
    -"false" otherwise, le and ls are not modified.
 */
boolean /*NodeManager::*/get_inOutGraphRef( ptINode aNode ,ptexpcal* le ,ptexpcal* ls );

/** ---Dependences managing-----.
    @return the list of clocks depending on a node (aNode), previously set by set_clocksSuccessors.
 */
ptlinsth /*NodeManager::*/get_clockSuccessors( ptINode aNode );

/** ---Dependences managing-----
    @return the list of successors of a node (aNode), previously set by set_successors.
 */
ptldependence /*NodeManager::*/get_successors( ptINode aNode );

/** ---Dependences managing----- 
    @return the list of predecessors (nodes) of a node (aNode), previously set by set_predecessors.
 */
ptldependence /*NodeManager::*/get_predecessors( ptINode aNode );

/** ---Dependences managing----- 
    @return the list of predecessors (clocks) of a node (aNode), previously set by set_clockPredecessors.
 */
ptlinsth /*NodeManager::*/get_clockPredecessors( ptINode aNode );

/** ---Dependences managing-----
    @return the list of iteration precedence associated with a node (aNode) previously set by set_iterationPrecedence.
    (a node n that reference x[?] induces the iteration dependence node(x) -> n)
 */
ptldependence /*NodeManager::*/get_iterationPrecedence( ptINode aNode );

/**
   @return 
   - "true" if a node (aSubGraph) is a node of a sub-graph, the !inputNode is the "fictitious" input node of a subgraph (all the nodes of the sub-graph depend on it).
   - "false" otherwise, inputNode is not modified.
 */
boolean /*NodeManager::*/get_subGraphInputNode( ptINode aSubGraph ,ptINode* inputNode );

/** 
    @return  "true" if the node (aNode) denotes a write access to the environment, "false" otherwise.
    Such a node is assigned to each output signal of the graph. It depends on the definition of the output signal.
    \see{get_io_arg}
 */
boolean /*NodeManager::*/is_writeNode( ptINode aNode );

/** @return  "true" if the node (aNode) denotes a read access to the environment, "false" otherwise.
    Such a node is assigned to each input signal of the graph.
    \see{get_io_arg}
 */
boolean /*NodeManager::*/is_readNode( ptINode aNode );

/** 
    @return  "true" if the node (aNode) denotes a read or a write access to the environment, "false" otherwise.
    \see{is_readNode, is_writeNode}
 */
boolean /*NodeManager::*/is_ioNode( ptINode aNode );

/**
   @return  "true" if the node ?node is a cell (i.e X:= E cell c), "false" otherwise.
   It should be generalized for X:= (E when c) default ZX  definition.
 */
boolean /*NodeManager::*/is_cellNode( ptINode node );

/**
   @return the contribution clock of a node. It is available for equation node (node) (i.e. X:= E when H, x:=(E when H) cell K).
   It is (H) the clock at which the expression E contributes to the definition of the signal X.
   It is always included in the clock of the signal X.
 */
ptinsth /*NodeManager::*/get_contributionClockEquation( ptINode node );

/** @return the clock of a node (node).  */
ptinsth /*NodeManager::*/get_nodeClock( ptINode node );

/** @return
    - "true" if a node (node) is an equation or a delay (X:=E), then vexp is the expression of definition (E) of the node
    - "false" otherwise, vexp is not modified.
 */
boolean /*NodeManager::*/get_rightOperand( ptINode node ,ptexpcal* vexp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ptexpcal /*NodeManager::*/get_rightOperand( ptINode node );

/** @return  the left expression (outputs) of a node (node). */
ptexpcal /*NodeManager::*/get_leftOperand( ptINode node );

/**
   @return  "true" if a node (aNode) denotes a set of partial definition node (set of ::= ), "false" otehrwise.
   \see{get_setOfPartialDefinitions_arg, becomes_setOfPartialDefinitions}
 */
boolean /*NodeManager::*/is_setOfPartialDefinitions( ptINode aNode );

/**
   @return  the list of the nodes associated with a node (aNode), assumed to denote a set of partial definition node.
   \see{is_setOfPartialDefinitions, becomes_setOfPartialDefinitions}
 */
ptlINode /*NodeManager::*/get_setOfPartialDefinitions_arg( ptINode aNode );

/** @return  "true" if a node (aNode) is a partial definition node (::= operator), "false" otherwise.
    \see{get_rightOperand, get_leftOperand}
 */
boolean /*NodeManager::*/is_partialDefinition( ptINode aNode );

/** @return  "true" if a node (aNode) is a "default value" partial definition node (::= defaultvalue operator), "false" otherwise.
    \see{get_rightOperand, get_leftOperand}
 */
boolean /*NodeManager::*/is_partialDefinitionDefaultValue( ptINode aNode );

/**
   @return the safety property associated with a node (safetyPropertyType) (opsafe by default).
 */
safetyPropertyType /*NodeManager::*/get_safetyProperty( ptINode n );

/**
   @return "true" if a node (node) is a delay or a node of a delay cluster, "false" oterhwise.
 */
boolean /*NodeManager::*/is_delayNodeOrDelayClusterNode( ptINode node );

/**
   @return "true" if is exists a back annotation (vt) to the abstract tree produced by the parser associated with a node (n), "false" otherwise (vt is not 
   modified).
 */
BackAnnotationType /*NodeManager::*/getBackAnnotation( ptINode n );

/**
   @return the index of an index-node (left part of I := [ lower bound, upper bound, step ])
 */
ptexpcal /*NodeManager::*/get_index( ptINode node );

/**
   @return the definition part of an index-node (right part of I := [ lower bound, upper bound, step])
 */
ptexpcal /*NodeManager::*/get_index_def( ptINode node );

/** @return  "true" if the node (aNode) is a array process node, "false" otherwise..
    \see{get_es_array, get_args_array}
 */
boolean /*NodeManager::*/is_array( ptINode aNode );

/**
   @return 
   - "true" if a node (aNode) is an array node, intNode is then its "internal" node associated with (all nodes of the array depend on it),
   - "false" otherwise,intNode is not modified.
 */
boolean /*NodeManager::*/get_array_inputNode( ptINode aNode ,ptINode* intNode );

/**
   @return the index node of an assumed array node (node). \see { get_index, get_index_def}.
 */
ptINode /*NodeManager::*/get_indexNode( ptINode aNode );

/**
   Getting the arguments of an assumed array node (aNode).
   - indexNode : its index,
   - vWith : the \b with part of the array
   - vBody : the \b body part of the array
 */
void /*NodeManager::*/get_array_arg( ptINode aNode ,ptINode* indexNode ,ptgfd* vWith ,ptgfd* vBody );

/**
   Getting the input signals (inputs) and outputs signals (outputs) of an assumed array node (aNode).
   inputs, outputs are comber expressions.
 */
void /*NodeManager::*/get_array_io( ptINode aNode ,ptexpcal* inputs ,ptexpcal* outputs );

/**
   @return the body part of an assumed array node (aNode).
 */
ptgfd /*NodeManager::*/get_array_bodyGraph( ptINode aNode );

/**
   @return the initial part (with part) of an assumed array node (aNode).
 */
ptgfd /*NodeManager::*/get_array_initGraph( ptINode aNode );

/**
   @return 
   - "true" is a node (n) is an array node, then 
   - ln is the set of nodes of its body part
   - lh is the set of clocks of its body part
   - "false" otherwise, ln and lh are not modified.
 */
boolean /*NodeManager::*/get_array_bodyDefinitions( ptINode n ,ptlINode* ln ,ptlinsth* lh );

/**
   @return 
   - "true" is a node (n) is an array node, then 
   - ln is the set of nodes of its initial part
   - lh is the set of clocks of its initial part
   - "false" otherwise, ln and lh are not modified.
 */
boolean /*NodeManager::*/get_array_initDefinitions( ptINode n ,ptlINode* ln ,ptlinsth* lh );

/**
   @return "true" if a node (aNode) is in a composed node (array, subgraph), "false" otherwise.
 */
boolean /*NodeManager::*/is_inComposedNode( ptINode aNode );

/**
   @return true if the node is in an array (cn), "false" otherwise (cn is assigned to the composed node, or NILINODE).
 */
boolean /*NodeManager::*/getInArrayNode( ptINode node ,ptINode* cn );

/**
   @return 
   - "true" if a node (aNode) is in a composed node (cNode) (ie array, subgraph),
   - "false" otherwise, cNode is NILINODE.

   \see { getInArrayNode()}
 */
boolean /*NodeManager::*/get_inComposedNode( ptINode aNode ,ptINode* cNode );

/** @return true if the operand node(vnode)  is defined by the intrinsic with "name" as identifier.  */
boolean /*NodeManager::*/is_intrinsicNode( ptINode vnode ,ptident name );

/**
   @return 
   - "true" is a node (node) is a node associated with a sub-graph, then 
   - ln is the set of nodes of the sub-graph
   - lh is the set of clocks of the sub-graph
   - "false" otherwise, ln and lh are not modified.
 */
boolean /*NodeManager::*/get_subGraphDefinitions( ptINode node ,ptlINode* ln ,ptlinsth* lh );

/**
   @return 
   - "true" is a node (n) is a node associated with a sub-graph, 
   then, it returns the projection information(set previously by set_subGraphProjectedSystemInfos)
   - vhemb: the branching clocks of the nodes/clocks of the sub-graph
   - projectedSystemClocks: the list of the clocks used to have an endochronous hierarchy for 
   the sub-graph (parametrization until vhemb, for each node/clock of the sub-graph).
   - "false" otherwise, ln and lh are not modified.
 */
boolean /*NodeManager::*/get_subGraphProjectedSystemInfos( ptINode node ,ptinsth* vhemb ,ptlinsth* projectedSystemClocks );

/**
   @returns the utility clock associated with a node (n).
 */
boolean /*NodeManager::*/getUtilityClock( ptINode n ,ptinsth* h );

/**
   @return "true" if the utility clock (h) of a signal (vsig) in a subgraph (sg) is computed, "false" otherwise.
 */
boolean /*NodeManager::*/getUtilityClockInSubGraph( ptINode sg ,ptexpcal vsig ,ptinsth* h );

/**
   @returns the Assignment clock associated with a node (n).
 */
boolean /*NodeManager::*/getAssignmentClock( ptINode n ,ptinsth* h );

/**
   @return "true" is the operand node is a default value node (x::=defaultvalue E), "false" otherwise.
 */
boolean /*NodeManager::*/isDefaultValueNode( ptINode node );

/**
   @return "true" is the operand node is a default value node such that X::=defaultvalue X$1 init vinit, "false" otherwise.
 */
boolean /*NodeManager::*/isDefaultValueNodeDelay( ptINode node ,ptexpcal* vinit );

/** 
    Code generation.

    @return "true" if the node node must be generated, "false" otherwise.
    @param node (in) can be annotated by one of the attribute  : GencodeMark, substituteGenCodeMark
 */
boolean /*NodeManager::*/mustBeGenerated( ptINode node );

/**
   @return true if a node (node) is internal to another one (nodeup), false otherwise.
   Remark: it returns true if node is nodeup.
  */
boolean /*NodeManager::*/isInternalNodeOf( ptINode node ,ptINode nodeup );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*NodeManager::*/isSendNode( ptINode node );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*NodeManager::*/isReceiveNode( ptINode node );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*NodeManager::*/getMemorizedSignal( ptINode aNode ,ptexpcal* vsig );


