/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/**
   It adds an iteration-precedence vinstrFrom->vinstrTo.
 */
void /*NodeManager::*/addIterationPrecedence( ptINode vinstrFrom ,ptINode vinstrTo );

/**
   It adds a dependence aNode -> vto, for (x, vto) an element of lDep.
 */
void /*NodeManager::*/addDependenceFromTo( ptINode aNode ,ptldependence lDep );

/**
   It adds a dependence n1 -> aNode, for (n1, x) an element of lDep.
 */
void /*NodeManager::*/addDependenceFromTo( ptldependence lDep ,ptINode aNode );

/**
   It adds a dependence h -> aNode, for h an element of lh.
 */
void /*NodeManager::*/addDependenceFromTo( ptlinsth lh ,ptINode aNode );

/**
   @return "true" if a dependence n -> vinstr when vh, with n the node of a signal (aSig), is added, "false" otherwise.
   It is NOT added when:
   - the signal is a state variable,
   - the expresion (aSig) is a reference to a previous iteration (x[?]): in this case, an iteration-precedence (addIterationPrecedence()) from vinstr to x is added.
   - when the node of  the signal is an element of a "delay cluster"
   - the expresion (aSig) is a reference to an element of an array (x[E]) and E is index independant.
 */
boolean /*NodeManager::*/addDependenceSig2Node( ptexpcal aSig ,ptINode vinstr ,ptinsth vh );

/**
   It applies addDependenceSig2Node() for each signal of a list (l).
 */
void /*NodeManager::*/addDependenceSigList2NodeAt( ptlinstances l ,ptINode n ,ptinsth h );

/** 
    @return "true" if it exists a dependence from a node of the subGraph (sg1) to a node of another sub-graph (sg2),
    "false" otherwise.
 */
boolean /*NodeManager::*/existDependenceFromToOneNodeOf( ptINode sg1 ,ptINode sg2 );

/** 
    @return "true" if it exists a dependence from a node (node) to a node of lnodes,
    "false" otherwise. 
 */
boolean /*NodeManager::*/existDependenceFromNodeToOneNode( ptINode node ,ptlINode lnodes );

/**
   It may add a dependence from the node of signal (aSig) to a clock (vclk).
   aSig can be:
   - x[?], the dependence is not added
   - when the node of  the signal is an element of a "delay cluster"
   - the expresion (aSig) is a reference to an element of an array (x[E]) and E is index independant.
 */
void /*NodeManager::*/addDependenceSignalToClock( ptexpcal aSig ,ptinsth vclk );

/**
   It adds a dependence n -> vinsth, for n the node of a signal of linst.
   It applies addDependenceSignalToClock() for each element.
 */
void /*NodeManager::*/addDependenceSignalsToClock( ptlinstances linst ,ptinsth vinsth );

/**
   For a node (anode) not a sub-graph and a sub-graph (aSubGraph),
   it adds a dependence from each clock successor of anode to aSubGraph, if the clock in not in the 
   sub-graph.
 */
void /*NodeManager::*/addDependenceBooleanClockTo( ptINode anode ,ptINode aSubGraph );

/**
   @return the fusion of two lists of dependences (ldepref, ldepapp) with side effect on ldepref.
   For (x->y when h1) and (x->y when h2) is the lists, it produces: x->y when (h1 ^+ h2).
 */
ptldependence /*NodeManager::*/fusionDependences( ptldependence ldepref ,ptldependence ldepapp );

/**
   For a undersampling (h), it adds depedences from x -> h, for x a signal referenced in the expression associated with the undersampling.
   It calls addDependenceSignalsToClock() for the positive/negative extractions.
 */
boolean /*NodeManager::*/setDependencesDownSampling( ptinsth h );

/**
   @return
   - "true" if a node (node) is not a node of nodes (ln), taking into account the fields of the structured types, 
   - "false" otherwise.
   If one of the internal nodes of a bundle/structure is the list (ln), node is assumed to be in ln.
 */
boolean /*NodeManager::*/testArrayDependence( ptINode node ,ptlINode ln );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*NodeManager::*/isNodeInComposedNode( ptINode aNode ,ptINode composedNode );

/**
   Internal to addComposedNodesDependences().
   For an array node (arrayNode), the node of its index (IndexNode), and ln, assumed to be the internal nodes of arrayNode, it adds
   a dependence from aNode to arrayNode when it is not IndexNode, arrayNode, and not in ln. Moreover, if arrayNode is in a block, a dependence 
   from  aNode to this block is also added.
 */
void /*NodeManager::*/addComposedNodesDependence( ptINode aNode ,ptINode arrayNode ,ptINode IndexNode ,ptINode internalArrayNode ,ptlINode ln );

/**
   For an array node (arrayNode), the node of its index (IndexNode), ln the nodes of its body, lh the clocks of its body, it adds
   dependences from the predecessors (nodes and clocks) of a node of ln, to the arrayNode (addArrayDependence()) for not internal nodes of the array.

   lh is currently unused.
 */
void /*NodeManager::*/addComposedNodesDependences( ptINode arrayNode ,ptINode IndexNode ,ptINode internalArrayNode ,ptlINode ln ,ptlinsth lh );

/**
   (arrays, subgraphs).
   It adds a dependence from IndexNode
   - to each node of ln
   - to each clock of lh
   
   vhemb is currently unused.
 */
void /*NodeManager::*/addInternalDependences( ptINode IndexNode ,ptlINode ln ,ptlinsth lh ,ptinsth vhemb );

/**
   It removes the dependences, from nodes, reaching a node (node).
 */
void /*NodeManager::*/removeNodeDependencesReaching( ptINode node );

/**
   It removes the dependences, from clocks, reaching node.
 */
void /*NodeManager::*/removeClockDependencesReaching( ptINode node );

/** It removes the dependences with vh as weight.  */
void /*NodeManager::*/removeDependenceWithLabel( ptinsth vh );

/**
   It adds dependences from signals referenced in the selectors used in an access to element of an array.
   For example, for a node n defined by  x[y] and y a signal, a dependence is added from the node of y to the node n, with h as the clock of the 
   dependence.
 */
void /*NodeManager::*/addDependencesForOutputs( ptexpcal s ,ptINode n ,ptinsth h );

/**
   It adds dependences from signals referenced in the selectors used in an access to element of an array for output signal of a node n.
   For example, for a node n defined by  x[y] := E and y a signal, a dependence is added from the node of y to the node n, with h as the clock of the 
   dependence.
 */
void /*NodeManager::*/addDependencesForOutputs( ptINode n ,ptinsth h );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*NodeManager::*/addDependencesPolyEndo( ptINode node ,ptlINode lnodes ,ptinsth vh );


