/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** 
    Modifying a definition.

    It replaces the definition of the signal vexp by "vexp := nexp at vhcal", 
    the new definition is inserted at the vhnode clock.
    If the new expression (nexp) is
    - a delay expression, the node of vexp becomes a memorization node,
    - a function call, it is replaced by a procCall node
    - otherwise, it is an equation.
  */
void /*NodeManager::*/modifiedDefinition( ptexpcal vexp ,ptexpcal nexp ,ptinsth vhcal ,ptinsth vhnode );

/** 
    Switching dÃ©finitions. 

    For two equations/delays n1, x1 := E1 and n2, x2:= E2, it produces the nodes x1 := E2 and x2:= E1.
    It may be used for preparing the renaming: x1 is an output defined by x1:= x2, x2 := E (x2 is not an output).
    It is rewriten in x1:=E and x2:=x1, then x2 may be replaced by x1 and deleted.
    
    It is assumed that there is no action on clocks.    
    @return "true" if the operation succeeds, "false" otherwise.
  */
boolean /*NodeManager::*/switchingNodes( ptINode n1 ,ptINode n2 );

/**
   It transforms a read node (node) into a intrinsic unsafe procedure call name "readS".
 */
void /*NodeManager::*/makeInputByInstrinsicRead( ptINode node );

/**
   It transforms a write-node (node) into a intrinsic unsafe procedure call name "writeS".
 */
void /*NodeManager::*/makeOutputByInstrinsicWrite( ptINode node );

/**
   @return "true" if node denotes a set of partial definition associated with a signal, "false" otherwise.
   When the signal is a state variable, it applies PartialDefinitionsMergingStateVar() method,
   otherwise it merges the partial definitions in an equation. The contribution clocks are computed.
 */
boolean /*NodeManager::*/PartialDefinitionsMerging( ptINode node );

/**
   It transforms a node (aSubGraph) assumed to be a node associated with a sub-graph, with vh as clock,
   into a node call that references a model (g).
 */
void /*NodeManager::*/subGraphNodeBecomesNodeCall( ptINode aSubGraph ,ptDCG g ,ptinsth vh );

/**
   It evaluates the intrinsic functions: Bounds, Dim, Size.
 */
void /*NodeManager::*/spatialProcessingIntrinsicEvaluation( ptINode node );

/**
   It updates the definition of a node (node). The operator of the node is not modify.
   It replaces the expression e1 by  the expression e2 in the node.
   This operation is not implemented for sub-graph and array nodes.
 */
void /*NodeManager::*/update( ptINode node ,ptexpcal e1 ,ptexpcal e2 );

/**
   @return "true" if the operation has been applied to some nodes, "false" otherwise.
   It merges the partial definitions associated with a signal to one node (PartialDefinitionsMerging(ptINode)).
 */
boolean /*NodeManager::*/PartialDefinitionsMerging( void );

/**
   For each node of the graph, x:=E1 default ...default EN, 
   it produces (DefaultSpliting(ptINode)) a set of partial definition (x::=E1,..., x::=EN).
 */
boolean /*NodeManager::*/DefaultSpliting( void );

/**
   It expands the left_tt operator into its kernel definition:
   c := left_tt(c1, c2), ^c = ^c1 ^+ ^c2  is rewritten in c:= (true when c1) default (pk_false)
 */
boolean /*NodeManager::*/lefttts2defaults( void );

/**
   Evaluating of the intrinsic functions: Bounds, Dim, Size of the node manager.
   (It calls spatialProcessingIntrinsicEvaluation(ptINode))
  */
void /*NodeManager::*/spatialProcessingIntrinsicEvaluation( void );

/**
   It rewrites the definition of the operande node (node), assumed to be an equation (not a delay).
   The node is such that: x := (E1 when h1) default ...default (En when hn)

   When an expression Ei is reduced to a signal (S) and the signal is also defined by an equation (i.e.  S:=  F1 when k1 default ...Fm when km),
   then (Ei when hi) is replaced by ( F1 when k1 default ...Fm when km) when hi. The resulting expression is then normalized.
   The dependencies are updated.
   
   @return "true" if the node has been modified, "false" otherwise.
 */
boolean /*NodeManager::*/rewDefinition( ptINode node );

/**
   The operand node is assumed to be a set of partial definitions (| x::= E1 when h1 | ... | x ::= En when hn |), 
   and the constraints for deterministic assigments are assumed to be already in the graph.

   It applies the rewDefinition() for each partial definition.
   @return "true" if one of the partial definition is modified, "false" otherwise.
 */
boolean /*NodeManager::*/rewDefinitionPartialDef( ptINode node );

/**
   aNode is an equation (not a delay) or a partial definition.
   If the utility clock is computed (denoted UC(x) for a signal x)
   - if UC(x) is the null clock, the node is not modified (it is unused, it will be removed later).
   - otherwise,
      - an equation X:= E is replaced by (| X::= E when UC(x) | x ::= defaultvalue x$1 |)
      - a list of partial definition:X::= E1 .... X::=En is replaced by  X::= E1 when UC(c) .... X::=En when UC(c) and completed with the default value.
   
 */
boolean /*NodeManager::*/rewUsingProductiveClock( ptINode aNode );

/**
   If the definition of the operand node (aNode) contains the expression (E when h) default ... default (E when k), it is aggregated in (E when h ^+ k).
   By construction  the default expressions are normalized in (F1 when k1) default ...(Fm when km) and the clocks ki, kj are exclusive.
   For a partial definition, the clocks are also exclusive by construction.
   @return "true" is the operand node is modified, "false" otherwise.
 */
boolean /*NodeManager::*/normalDefaults( ptINode aNode );

/**
   Substitute vsig1 by vsig2 in the operand node (node).
 */
void /*NodeManager::*/replace( ptexpcal vsig1 ,ptexpcal vsig2 ,ptINode node );

/**
   @return "true" if the operation has been applied to some nodes, "false" otherwise.
   It merges the partial definitions associated with a signal to one node (PartialDefinitionsMerging(ptINode)).
 */
boolean /*NodeManager::*/SharedVariableRemoving( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
boolean /*NodeManager::*/cell2kernel( ptINode n );

/**
  It replaces the references to vh1 by vh2 in the operand node.
  */
void /*NodeManager::*/replace( ptINode node ,ptinsth vh1 ,ptinsth vh2 );


