/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

public:

/** Constructor. The travelling is applied to a graph (g).
    It must be 
       - initialized ( initialize()  method)
       - finalized ( finalize() method)

       The constant signals are available after the call to the method initTravelForInitialClock(), the
       other one after the call toi he method initTravelForClock().
 */
/*TravelDepManager::*/TravelDepManager( ptDCG g );

/**
   It initializes the selected graph (constructor) for a travelling.
   The attributes are initialized (attributesInitialize()). In particular, 
   the number of waited predecessors of each node/clock is computed.
 */
void /*TravelDepManager::*/initialize( void );

/**
   It finalizes the travelling: the graph is reinitialized for a next travelling.
  */
void /*TravelDepManager::*/finalize( void );

/**
   It Initializes a travelling with the initial clock as entry point (for constant signals). 
  */
void /*TravelDepManager::*/initTravelForInitialClock( void );

/**
   It initializes a travelling with the clock (htop) as entry point. 
   @return "true" if exists a clock without predecessors, this clock is a child of the htop clock.
   (A classical call is when htop is the fictitious root of the clock hierarchy)
 */
boolean /*TravelDepManager::*/initTravelForClock( ptinsth htop );

/**
   It specifies that the node (inst) is reached by one of its predecessors.
   If it belongs reached by all of its predecessors, it becomes a candidate for the selection for 
   the greedy algorithm.
 */
void /*TravelDepManager::*/NodeReachedByAPredecessor( ptINode inst );

/**
  Search for a clock or a node without predecessors (all its predecessors have been visited).
  @return "true" if such object exists in the graph, "false" otherwise.
  @param bType (out) : "true" if node parameter is defined, "false" if vclock is defined.
  @param node (out) : the selected node.
  @param vclock (out) : the selected clock.
 */
boolean /*TravelDepManager::*/getNextNode( boolean* bType ,ptINode* node ,ptinsth* vclock );

/**
   It signals that the clock (h) has been selected by the greedy algorithm to its successors
   (ClocksReachedByAPredecessor(), NodesReachedByAPredecessor() methods are applied).
 */
void /*TravelDepManager::*/signalSelectedClock( ptinsth h );

/** @return "true" if a node (vi) has been already selected by the algorithm, "false" otherwise.
  */
boolean /*TravelDepManager::*/isNodeAlreadySelected( ptINode vi );

/** @return "true" if a clock (vh) has been already selected by the algorithm, "false" otherwise.
  */
boolean /*TravelDepManager::*/isClockAlreadySelected( ptinsth vh );

/** @return the current context array-block.  */
ptINode /*TravelDepManager::*/getCurrentBlock( void );

/**
   It saves the current array-block before setting a node (bcl) as a new one. 
   It will be closed using the closeBlock() method.
 */
void /*TravelDepManager::*/openBlock( ptINode bcl );

/**
   It closes the current array context. It restitutes the previous one saved in openBlock() method.
 */
void /*TravelDepManager::*/closeBlock( void );

/**
   It signals that a node (node) has been selected by the greedy algorithm to its successors
   (ClocksReachedByAPredecessor(), NodesReachedByAPredecessor() methods are applied).
 */
void /*TravelDepManager::*/signalSelectedNode( ptINode node );

/**
   It specifies that a clock (vi) is reached (resp. unreached) when b (resp. not b).
 */
void /*TravelDepManager::*/setReached( ptinsth vi ,boolean b );

/**
   @return "true" if a clock (vi) is reached, "false" otherwise.
   A clock is reached if it has been reached by all its predecessors.
 */
boolean /*TravelDepManager::*/isReached( ptinsth vi );

/**
   It specifies that a node (vi) is reached (resp. unreached) when b (resp. not b).
   A node is reached if it has been reached by all its predecessors.
 */
void /*TravelDepManager::*/setReached( ptINode vi ,boolean b );

/**
   @return "true" if a node (vi) is reached, "false" otherwise.
 */
boolean /*TravelDepManager::*/isReached( ptINode vi );

/**
   @return "true" if a clock (vh) is reachable (it is a useful clock with some predecessors), "false" otherwise.
   
 */
boolean /*TravelDepManager::*/isClockReachable( ptinsth vh );

/** 
    @return "true" if a node (vi) is reachable (it is a useful clock with some predecessors) , "false" otherwise.
 */
boolean /*TravelDepManager::*/isNodeReachable( ptINode vi );

/**
   It signals that an array node (node) has been selected by the greedy algorithm.
   Specific actions are applied for the index and the internal array node: it signals (signalSelectedNode()) that
   these nodes have been selected.
 */
void /*TravelDepManager::*/signalArraySelectedNode( ptINode node );

/**
   It signals that a subgraph node (node) has been selected by the greedy algorithm: the successors of the 
   internal node associated with a subgraph are visited.
   Assumed: node is a subgraph node.
 */
void /*TravelDepManager::*/signalSubGraphSelectedNode( ptINode node );

/**
   Debugging:
 */
void /*TravelDepManager::*/DEBUG_TRACE_NODE( ptINode node );

/**
   Debugging:
 */
virtual void /*TravelDepManager::*/DEBUG_PRINT_NODEINFOS( ptINode node ,ptlINode lnreached ,ptlinsth lhreached );

/**
   Debugging:
 */
void /*TravelDepManager::*/DEBUG_TRACE_NODE( ptINode node ,ptlINode ln ,ptlinsth lh );

/**
   Debugging:
 */
void /*TravelDepManager::*/DEBUG_TRACE_CLOCK( ptinsth h ,ptlINode ln ,ptlinsth lh );

/**
   Debugging:
 */
void /*TravelDepManager::*/DEBUG_TRACE_CLOCK( ptinsth h );

/**
   Debugging:
 */
void /*TravelDepManager::*/PRINTDEBUG( ptlINode ln ,ptlinsth lh );

/**
   Set the DEBUG MODE to b.
 */
void /*TravelDepManager::*/setDebugMode( boolean b );


