/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __AbstractHomomorphism_h__
#define __AbstractHomomorphism_h__

typedef class AbstractHomomorphism *ptAbstractHomomorphism;

class AbstractHomomorphism
{
#include "AbstractHomomorphism_m.h"
#include "AbstractHomomorphism_g.h"
protected:

  ptDCG fGraph; ///<  First graph.
  ptExprManager fEM; ///<  First graph: Expression manager
  ptClockManager fCKM; ///<  First graph: Clock manager
  ptNodeManager fNM;///<  First graph: Node manager
  ptNameManager fNameManager; ///<  First graph: Name manager
  GraphLevelType fgraph_type; ///< First graph: Sub-format of the graph.
  ptlINode unNodes;  ///< First graph: List of the unused nodes.
  ptlinsth unClocks; ///< First graph: List of the unused clocks.

  ptDCG sGraph; ///<  Other graph.
  ptExprManager sEM;///<  Other graph: Expression manager
  ptClockManager sCKM; ///< Other graph: Clock manager
  ptNodeManager sNM; ///<  Other graph: Node manager
  ptNameManager sNameManager;  ///< Other graph: Name manager

  ptinsth hundef; ///< undefined clock.
  ptintemkIGraph igc; ///< graph constructor interface.

  typeMark attributeNumber; ///< internal mark: used to link objects of "first" graph with ojects of the "other" one.

  boolean error; ///< Set to "true" when an error occurs, false by default.
  boolean BDEBUG; ///< misc: Used by developpers for tracing.

  ptlinsth lConstraintsNullClock, lAssertionsNullClock; ///< Null clock constraints and assertions for the origin graph.
 };
		 
#endif
