/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifndef __Duplicator_h__
#define __Duplicator_h__

typedef class Duplicator *ptDuplicator;

class Duplicator:public AbstractHomomorphism
{
#include "Duplicator_m.h"
#include "Duplicator_g.h"

protected:
#define DUPLICATEALL -999999999
  ptlinstances lparameters, ///< set of parameters (new graph)
    lconstants; ///< set of constants (new graph)
  typeMark aMark,  ///< internal mark. The objects of the original graph, copied in the new one are marked with it.
    selectMark;  ///< internal mark. It specifies a complete copy when it is equal to DUPLICATEALL, otherwise the objects are tagged by this mark.
  ptinsth rootClock; ///< undefined for a graph, set for a subgraph;
  boolean bEventClockedFormat; ///< Graph level type information: set to true for a graph is a graph with events (DCG_BASIC, DCG_POLY,DCG_ENDO)
  ptlinsth ClocksNotCloned; ///< Forward references management.
    boolean bExportHierarchy;

};

#endif
