/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_
/** Constructor. */
  SubGraphExtract::SubGraphExtract ()
{
}


/**
   Destructor.*/
_VIRTUAL_ SubGraphExtract::~SubGraphExtract ()
{
}


/**
   @return a graph associated with a sub-graph (sg) of a graph (g). A sub-graph can, for example, 
   with this method be replaced in the original graph by a reference to a graph (the generated one).
*/
ptDCG
SubGraphExtract::SubGraph2Graph (ptDCG g, ptINode sg, boolean bExportClocksOfSubGraph, boolean exportClockSystem, boolean breduce)
{
  ptlinsth lh;
  ptlINode ln;
  int *i;

  lnodesSubGraph = NILLINODE;
  lclocksSubGraph = NILLINSTH;
  eGraph = new DCG ();
  initialize (g, eGraph, pk_false);
  sCKM->setSimplifyMode(breduce);
  subGraph = sg;		// internal member.
  selectMark = DUPLICATEALL;	// inherit from duplicator. Must be set to DUPLICATEALL (why ?)
  selectingObjects (&ln, &lh, bExportClocksOfSubGraph, exportClockSystem);
  lSelectedNodes = ln;
  lSelectedClocks = lh;
  setInputNodes();
  extracting (ln, lh, exportClockSystem);
  sCKM->setSimplifyMode(pk_true);
  set_io (lh);
  setDependencesSubGraph ();
  finalize ();
  // Adding the attribute used for selecting. to the subgraph.
  i = new int ();
  *i = getUsedMark ();
  fNM->addAttribute (sg, USED_MARK_EXTRACTION, (attributeValue) i);
  return eGraph;
}
