/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

protected:

/**
   In "flat mode", it adds the declarations of the signals (G_LocSig) and the clocks (G_Clocks) 
   in the global model (G_TreeGraph).
   The signals, clocks are stored in the list during the graph travel.
 */
virtual void /*DCG2SignalTree::*/insertDeclarationsFlatMode( void );

/**
   @return "true" if a graph (aGraph) is an \em external graph with a back annotation (SIGNALTreeDecl) to its SIGNAL abstract tree,
   "false" otherwise.
 */
virtual boolean /*DCG2SignalTree::*/isKnown_SIGNAL_tree( ptDCG aGraph ,ntrees* SIGNALTreeDecl );

/**
   @return SIGNAL abstract tree representation of a new identifier built on identPrefix (attribute member of the class) and a counter
   of such identifiers (cpt_names: attribute member of the class).
 */
virtual ntrees /*DCG2SignalTree::*/mkNewIdent( void );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*DCG2SignalTree::*/mktreeinterface( ptinterface vinterface ,ntrees vtl );

/** 
    @return the SIGNAL abstract tree representation of an interface (vinterface)
    It is composed of the input signals, outputs signals of vinterface.
  */
virtual ntrees /*DCG2SignalTree::*/mktreeinterface( ptinterface vinterface );

/**
   @return the Signal abstract tree representation of a definition of a constant (aConst).
 */
virtual ntrees /*DCG2SignalTree::*/mkConstantDefinition( ptexpcal aConst );

/**
   For each element of a list of assumed constants (lsig),
   it adds, to a model (aModelTree), the declaration (STree_addLocalDeclaration()) of the definition of the constant (mkConstantDefinition()).
 */
virtual void /*DCG2SignalTree::*/mktreeconstants( ntrees aModelTree ,ptlinstances lsig );

/**
   @return the Signal abstract tree representation of a declaration of a signal (vexp) that can be initialized (withInit).
   \see mkIdentWithInit().
  */
virtual ntrees /*DCG2SignalTree::*/mkdecsig( ptexpcal vexp ,boolean withInit );

/**
   @return 
   - a new identifier (mkNewIdent()) when mkNewIdentTag (attribute member of the class); it is used when the context 
   operation is a declaration of a external model (mkDeclarationExternProc()) from a reference to the model.
   - the Signal abstract tree representation of the expression (ptexpcal2ntrees()).
 */
virtual ntrees /*DCG2SignalTree::*/mkIdentTree( ptexpcal vexp );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual boolean /*DCG2SignalTree::*/getInfoValue( ptexpcal vexp ,ntrees* t );

/**
   @return the SIGNAL abstract tree representation of the identifier of a signal (vexp) + its initialization (if available)
   when vexp is a state variable or when \em withInit.
 */
virtual ntrees /*DCG2SignalTree::*/mkIdentWithInit( ptexpcal vexp ,boolean withInit );

/**
   In "flat mode", the signals (ls) are added to G_LocSig (all the locals of all the nodes of the hierarchy will be declared at the tick clock),
   otherwise  the signals of ls are added to the locals of a model (aModelTree).
 */
virtual void /*DCG2SignalTree::*/localStoreOrDeclare( ptlinstances ls ,ntrees aModelTree );

/**
   In "flat mode", the clocks (lh) are added to G_Clocks (all the locals of all the nodes of the hierarchy will be declared at the tick clock),
   otherwise  the signals of ls are added to the locals of a model (aModelTree).
 */
virtual void /*DCG2SignalTree::*/localStoreOrDeclare( ptlinsth lh ,ntrees aModelTree );

/**
   It adds the declaration of the local of an interface (vinter) 
   to a SIGNAL abstract tree representation of a model (process).

   It calls localStoreOrDeclare(ptlinstances) for the signals and localStoreOrDeclare(ptlinsth) for the clocks.
 */
virtual void /*DCG2SignalTree::*/appendLoc( ptinterface vinter ,ntrees process );

/** 
    @return vtdecl in which a declaration (aDecl) of a signal/type (vexp) is added.
    @param loc (in): must be "true" for a list of local declaration, "false" otherwise.
 */
virtual ntrees /*DCG2SignalTree::*/addSignalDeclaration( ntrees vldecl ,ntrees aDecl ,boolean loc );

/** 
    @return vldecsig + the declaration of a signal/type (vexp).
    @param vexp (in) : a signal or a reference to a type.
    @param vldecsig (in) : a list of declarations (niltree is accepted)
    @param locaux (in) : must be "true" for a list of local declaration, "false" otherwise.
    @param withInit (in) : must be "true" when the initial value (for a signal) must be generated in the declaration, "false" otherwise.
 */
virtual ntrees /*DCG2SignalTree::*/insertdecsig( ptexpcal vexp ,ntrees vldecsig ,boolean locaux ,boolean withInit );

/**
   @return vt + the declarations of the element of lexp.
   For each element of a list of declarations (lsig), it calls insertdecsig().

   @param lexp (in) : list of expressions. An element is assumed to be a signal or a reference to a type.
   @param vt (in) : a list of declarations (niltree is accepted)
   @param locaux (in) : must be "true" for a list of local declaration "false" otherwise. When it is pk_true, the io signals are filtered.
   @param withInit (in) : must be "true" when the initial value (for a signal) must be generated in the declaration, "false" otherwise.
 */
virtual ntrees /*DCG2SignalTree::*/addSignalsDeclaration( ntrees vt ,ptlinstances lexp ,boolean locaux ,boolean withInit ,boolean bExcludeSharedSignal );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual ntrees /*DCG2SignalTree::*/addClocksDeclaration( ntrees vt ,ptlinsth lh ,boolean locaux ,boolean withInit ,ntrees* vtlclocks );

/**
  It adds the declarations of the signals/types of lexp to a SIGNAL abstract tree representation of a model (aModelTree).
  The inserting area is given by where: 
  - 0: locals 
  - 1: parameters
  - 2: inputs 
  - 3: outputs.
 */
virtual void /*DCG2SignalTree::*/appdeclsig( ntrees aModelTree ,ptlinstances lsig ,int where ,boolean bExcludeSharedSignal );

/**
   It adds to a SIGNAL abstract tree representation of a model (aModelTree) the 
   declaration of the external models referenced by the model.
   It explores the list of the visited graphs (stored in lIGraph, an attribute memeber of the class).
 */
void /*DCG2SignalTree::*/appDeclExternNodeCall( ntrees aModelTree );

/**
   XXXXXXXXXXXXXXXXXXXxxxx   
 */
virtual ntrees /*DCG2SignalTree::*/mkDeclarationExternProc( ptINode vnode ,noperators op ,boolean bmkNewIdentTag );

/** 
    It adds to a SIGNAL abstract tree representation of a model (aModelTree) the 
    declaration of the external models referenced in lProcCalls (procedure calls) and lfuncs (functions).
    The objects marked by INTRINSIC and DONTDECLARE (compiler attributes) are filtered.
    - For a procedure call, the declaration is produced by mkDeclarationExternProc()
    - For a function call, the declaration is assumed available by a back annotation to the SIGNAL abstract tree representation produced
    by the parser (getBackAnnotation()).
 */
virtual void /*DCG2SignalTree::*/appDeclExternProcedures( ntrees aModelTree ,ptlINode lProcCalls ,ptlinstances lfuncs );

/**  
     It adds the declarations of the constants/types (ltc) to a SIGNAL abstract tree representation of a model (aModelTree).
     A constant/type is added (testCanBeGenerated()) when all its references are already declared in aModelTree.
  */
virtual void /*DCG2SignalTree::*/mkDeclCstTypes( ptlinstances ltc ,ntrees aModelTree );

/**
   @return the SIGNAL abstract tree representation of a declaration of a list of clock identifiers (vtl).
   When the graph is a DC+ graph, the "event" type is used, "boolean" otherwise.   
 */
virtual ntrees /*DCG2SignalTree::*/mkClockDeclarationFinalize( ntrees vtl );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
ntrees /*DCG2SignalTree::*/insertClockIdentifierToList( ntrees vtl ,ptinsth vh );

/** 
    @return the Signal abstract tree representation of a list of identifiers of clocks (lClocks).
 */
virtual ntrees /*DCG2SignalTree::*/mkClockIdentifierList( ptlinsth lClocks );

/** 
    @return the Signal abstract tree representation of a declaration of a list of clocks (lClocks).
    It calls mkClockDeclarationFinalize(), mkClockIdentifierList().
 */
virtual ntrees /*DCG2SignalTree::*/mkDeclarationOfClocks( ptlinsth lClocks );

/**
   Adds the parameters of an inteface (vinterface) to the Signal model (aModelTree).
 */
virtual void /*DCG2SignalTree::*/mktreeparameters( ptinterface vinterface ,ntrees aModelTree );

/** 
    Adds the parameters of the inteface of a clock (vh) to the Signal model (aModelTree).
 */
virtual void /*DCG2SignalTree::*/mktreeparameters( ptinsth vh ,ntrees aModelTree );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*DCG2SignalTree::*/mktreeinput( ptinterface vinterface ,ntrees aModelTree );

/** It adds to the Signal abstract tree representation of the model (aModelTree) associated with a clock (vh)
    the declaration of the inputs of the model.
 */
virtual void /*DCG2SignalTree::*/mktreeinput( ptinsth vh ,ntrees aModelTree );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
virtual void /*DCG2SignalTree::*/mktreeoutput( ptinterface vinterface ,ntrees aModelTree );

/** It adds to the Signal abstract tree representation of the model (aModelTree) associated with a clock (vh)
    the declaration of the outputs of the model.
 */
virtual void /*DCG2SignalTree::*/mktreeoutput( ptinsth vh ,ntrees aModelTree );

/** 
    It adds to the Signal abstract tree representation of the model (aModelTree) associated with a clock (vh)
    the declaration of the locals of the model. It takes into account the "flat mode" (appendLoc()).
 */
virtual void /*DCG2SignalTree::*/mktreeloc( ptinsth vh ,ntrees aModelTree );

/**
   It adds to the Signal abstract tree representation of the model (aModelTree) associated with a clock (vh)
   the declaration of the interface (parameters, inputs, outputs) of the model.    
   It calls:
   - mktreeparameters() for the parameters,
   - mktreeinput() for the inputs,
   - mktreeoutput() for the outputs.
 */
virtual void /*DCG2SignalTree::*/mtInterfaceTree( ptinsth aClock ,ntrees aModelTree );

/**
   @return the Signal Abstract tree representation of the declaration of a type or constant (elem).
   - for a constant, it calls mkConstantDefinition().
   - for a type, it calls  TypeTypeUser2ntrees() with the type referenced in elem.
 */
virtual ntrees /*DCG2SignalTree::*/mkDeclCstType( ptexpcal elem );

/**
   @return "true" if it exists at least one undeclared model referenced in some external references, "false" otherwise.
   @param lProcCalls (in) a list of procedure calls
   @param lfuncs (in) a list of function calls (currently ignored)
   @param ldecl (out) a Signal Abstract tree representation of a list of model declarations. 

   For each element of lProcCalls, it calls mkDeclarationExternProc(), if the back annotation to a model is not available.
   The objects marked by DONTDECLARE (compiler attributes) are filtered.
 */
virtual boolean /*DCG2SignalTree::*/mkUndeclaredDeclarationExternProcedures( ptlINode lProcCalls ,ptlinstances lfuncs ,ntrees* ldecl );

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG2SignalTree::*/addClockScheduledGraph( ptexpcal vsig );


