/*
 *   This file was automatically generated by version 1.0 of pKPrototypeExtract.
 *   Manual editing not recommended.
 */

private:

/** \todo{ MISSING FUNCTION API DOCUMENTATION } */
void /*DCG_poly::*/init( ptDCG g );

protected:

/**
   Specialisation.
   @copydoc DCG_basic::copySelected()
 */
ptDCG_poly /*DCG_poly::*/copySelected( boolean exportHierarchy ,typeMark vMark ,ptident id ,typeMark* usedMark );

/**
   Recursively write each elementary process "PP" that has a subexpression "Ei" as "(| PP' | xi:=Ei|) where xi"
   such that xi is a new identifier and PP' is PP in which all occurences of "Ei" are replaced by "xi"
   \ref Graph2Kernel "For more details..."
 */
void /*DCG_poly::*/expressionExpandOneLevel( void );

/** 
    This methods adds boolean inputs for a list of signals (list). 
    All added signals are synchronized to vhtick.
    For a signal (SIG)
    - whose the clock is a root of a tree in the clock system 
    - and this clock is a free variable in the system

    a boolean signal (BHSIG) is added in the graph as an input. 
    Then, the following synchronizations are added in the system :
    - vhtick ^= BHSIG, 
    - when BHSIG ^= ^SIG. 
    After each insertion, the clock calculus is applied.

    \note The order of the list is important. The parametrized system depends on this order.
 */
void /*DCG_poly::*/extendedSpecification( ptinsth vhtick ,ptlinstances list ,boolean bAddInput );

/**
   For each undersampling clock ([C]) of lhtodeclare, 
   if C is not an input of the graph, C is added in the outputs of the graph; it is also added to lappSignals
   - otherwise, C is added to lappSignals

   It can be used for exporting some booleans in an abstration of a model.
   @return "true" if the list lappSignals is modified, "false" otherwise.
 */
virtual boolean /*DCG_poly::*/buildClockExportation( ptlinsth lhtodeclare ,ptlinstances* lappSignals );

/** 
    It creates the tree of delayed signals for the current graph.
    \ref States "For more details..."
 */
boolean /*DCG_poly::*/delayTreeBuildOneLevel( void );

/**
   This method calculates the "profile" (inputs,outputs, parameters)
   for each node of the clock hierarchy. Each node of the hierarchy is seen as a Signal process.
   \ref ProfileBuilder "For more details..."
 */
void /*DCG_poly::*/buildClockProcessInterfaceOneLevel( void );

/**
   It builts the clock environment of a program (tick, iostep, step, Idle).
   During this, constraint informations are stored in the current graph structure.

   It completes the hierarchy (forest of clock trees) to obtain a tree. A fictitious root
   is appended for an exochronous process (DCGPoly format level). 

   iostep, step, Idle not implemented

   \warning (\e restriction) Currently, only "tick" clock is built.
 */
void /*DCG_poly::*/setIntrinsicClocksOneLevel( void );

/**
   Computes the exclusive relation over clocks in the current clock hierarchy
 
   The result is assigned to each clock: a predefined attribute, called EXCLUSIVE_CLOCKS defined in the
   file $GraphVM_export/CompilerAttributes.h, is associated with each clock, the value of the attribute gives the list 
   of its exclusive clocks.

   \ref ClockCalculusMatrix "For more details..." 
 */
void /*DCG_poly::*/computeClockExclusionsOneLevel( int ecLevel );

/** 
    It computes the projection of the clock system 
    - on the clocks of the inputs/outputs signals of the graph 
    - and, if bclkdep, the clocks of the input/output data dependencies. In this case, this operation supposes that the transitive 
    closure functionality has been applied.
    \see{computeIOTransitiveClosure, buildClockExportation(), }
 */
ptinsth /*DCG_poly::*/buildIOClockSubHierarchyLoc( boolean bclkdep ,ptlinsth* lhtodeclare ,ptlinstances* appendSigs );

/** 
    It computes the projection of the clock system on the clocks of the inputs/outputs 
    signals of the graph and (if bclkdep) the clocks of the input/output data dependencies. In this case, 
    this operation supposes that the transitive closure functionality has been applied.
    \see{computeIOTransitiveClosure, buildClockExportation(), }
 */
void /*DCG_poly::*/buildIOClockSubHierarchyOneLevel( boolean bclkdep );

/** 
    Assumed : the method delayTreeBuild() must be applied before.
    The graph is reinforced (so, it must be applied before code generation partitionning).
    For a one-delay node ZX := X $1 , it tries to aggregate the delay (ZX) with the delayed signal (X).
    It looks at the successors of ZX : S1,...,Sn and it adds a dependence from Si to X.
    If such reinforcing does not introduce a circuit in the current graph, the signals X and ZX can
    be merge in the same memory (the references to the previous value of X are generqted before the update of the memory).
    In this case, the signal ZX is annotated with this predefined attribute called MEMORY_OPTIMIZED. 
    This attribute is analyzed by code generators. 

    \see{delayTreeBuild}

    \ref Optimisations "For more details..."
 */
void /*DCG_poly::*/setDelayMemoryOverloadingOneLevel( boolean bclu );

/** 
    Applying aggregation of when/cell definitions and multiplexing of variables (delays).

    Its realizes optimizations related to the memory size for code generation using
    - the "when/cell" aggregations : two signals that can be represented in 
    the same area are annotated using the predefined attribute AGGREGATTRIBUTE. 
    This attribute is analyzed by code generators. 
    //PLG: WHY not Signal transformation with x::= E and x  when h1, x when h2,...

    - the multiplexings of variables : signals built on the same signal using the "window"
    and "delay" operators are represented in the same area if the initial values are compatible. 

    Array and circular management of indexes are used
    for the optimization. The method delayTreeBuild() must be applied before.
 
    @param mutliplexDelays (in) with the value "true" a signal and the delays built on it are multiplexed, 
    "false" they are managed by two variables if there is only one delay on the signal
    In other words, for zx := x $1, and it is the only delay on x, if the signals are scalars, they are never
    multiplexed in the same area even if mutliplexDelays is pk_true; otherwise they are managed by two variables.

    \see{delayTreeBuild}

    \ref Optimisations "For more details..."
   Deprecated
 */
void /*DCG_poly::*/memoryOptimizationsOneLevel( boolean mutliplexDelays );

/** 
    It calculates the transitive closure reduced to input/output signals of the graph.
    The results is annotations assigned to i/o signals 
    using the CLOSUREATTRIBUTE attribute defined in the file incl.dir/CompilerAttributes.h
    @return the value "true" if the translation is executed, "false" otherwise 
    (internal problems in this case).

    \ref Closure "For more details..."
 */
boolean /*DCG_poly::*/computeIOTransitiveClosureOneLevel( void );

/**
   Building the tick of the program by parameterizing the clock system.
   When the current graph is not endochronous, this transformation induces modifications on the interface 
   of the graph by adding input booleans.\n
   Order : 
   - the clock of an free input is fixed before the clock of an output. 
   - in a subset (inputs or outputs), the syntactic declaration order is used.

   When a signal is added, the clock calculus is applied to obtain an endochonous system.
   Last, when the graph is not endochronous input signals are created for each root of the clock hierarchy (arbitrary order).
   @return "true" if the resulting graph is endochonous, "false" otherwise.
 */
boolean /*DCG_poly::*/parameterizeMasterClocksOneLevel( boolean bAddinputs );

/**
   It rewrites the definitions (not the dynamical ones) of the graph, by substiting a reference to a signal by the expression of definition of this signal.
   It is useful to remove cycles in the graph. For example \n
   (| x := a when c default y  \n
    | y := x when c default b  \n
    |) \n
    is rewritten in \n
   (| x := a when c default b  \n
    | y := x when c default b  \n
    |) \n
    by this method (the substitution of y by its definition in the definition of x, removes the cycle).
    \see { DCG::rewDefinitions()  }
 */
void /*DCG_poly::*/rewDefinitionsOneLevel( void );

/**
   Rewrite the boolean cells to the kernel language.
 */
void /*DCG_poly::*/booleanCells2kernel( void );

/**
   It generates the graph of the abstraction of the current DCG.
   Not fully implemented (in development).
 */
ptDCG_poly /*DCG_poly::*/buildAbstractionOneLevel( void );

/**
   @return "true" if a node (vnode) is referenced only in the hierarchy with vhroot as root, "false" otherwise.
  */
boolean /*DCG_poly::*/isFromOtherHierarchy( ptINode vnode ,ptinsth vhroot ,ptinsth vh );

/**
   @return the nodes assigned to a clock (vh) that are referenced only in the hierarchy dominated by vhroot.
   Assumed: vh is assumed not to be in the hierarchy with vhroot as root.
 */
void /*DCG_poly::*/moveNodes( ptinsth vhFrom ,ptinsth vhFromRoot ,ptinsth vhTo ,ptinsth vhrootTo );

/**
   It moves the nodes of the list lnToMove1 from a clock (vh1) to another one (vh2).
   Assumed: the nodes of lnToMove1 are assumed to be assigned to vh1.
   The clocks of the signals are also updated.
  */
void /*DCG_poly::*/moveNode( ptINode n ,ptinsth vh1 ,ptinsth vh2 );

/**
   Assumed : 
   - vh1, clock of a hierachy with vhrac1 as root
   - vh2, clock of a hierachy with vhrac2 as root
   It moves:
   - the nodes assigned to vh1 to vh2 if such a node is only referenced in the hierarchy with vhrac2 as root.
   - the nodes assigned to vh2 to vh1 if such a node is only referenced in the hierarchy with vhrac1 as root.
   It changes:
   - the references to the clock vh1 by vh2 in the hierarchy with vhrac2 as root
   - the references to the clock vh2 by vh1 in the hierarchy with vhrac1 as root
 */
void /*DCG_poly::*/reorganizeNodesForRendezVous( ptinsth vh1 ,ptinsth vhrac1 ,ptinsth vh2 ,ptinsth vhrac2 );

/**
   It replaces the references to vh1 by vh2 in the hierarchy with vhroot as root.
  */
void /*DCG_poly::*/changeClockReferences( ptinsth vhroot ,ptinsth vh1 ,ptinsth vh2 );


