
/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PUBLIC_ GraphLevelType DCG_basic::getFormatLevel ()
{
  return vDCG->getFormatLevel ();
}

void
DCG_basic::setFormatLevel (GraphLevelType currentlevel)
{
  vDCG->setFormatLevel (currentlevel);
}

boolean DCG_basic::isGraphOfExternalProcess ()
{
  return vDCG->isGraphOfExternalProcess ();
}

boolean DCG_basic::isEmptyGraph ()
{
  return vDCG->isEmptyGraph ();
}


ptlPointer DCG_basic::getCycles ()
{
  return vDCG->getCycles ();
}

void
DCG_basic::setCycles (ptlPointer lc)
{
  vDCG->setCycles (lc);
}

ptlPointer DCG_basic::getPseudoCycles ()
{
  return vDCG->getPseudoCycles ();
}

void
DCG_basic::setPseudoCycles (ptlPointer lfc)
{
  vDCG->setPseudoCycles (lfc);
}

void
DCG_basic::setGraphOfExternalProcess (ntrees SIGNALDeclaration, ntrees vlang)
{
  vDCG->setGraphOfExternalProcess (SIGNALDeclaration, vlang);
}

ntrees DCG_basic::getSIGNALTreeDeclaration ()
{
  return vDCG->getSIGNALTreeDeclaration ();
}


void
DCG_basic::setImplementationLanguage (ntrees codeLanguage)
{
  vDCG->setImplementationLanguage (codeLanguage);
}

ntrees DCG_basic::getImplementationLanguage ()
{
  return vDCG->getImplementationLanguage ();
}

ptinsth DCG_basic::getRootClock ()
{
  return vDCG->getRootClock ();
}

ptClockManager DCG_basic::getClockManager ()
{
  return vDCG->getClockManager ();
}

ptNodeManager DCG_basic::getNodeManager ()
{
  return vDCG->getNodeManager ();
}


ptExprManager DCG_basic::getExpressionManager ()
{
  return vDCG->getExpressionManager ();
}

ptNameManager DCG_basic::getNameManager ()
{
  return vDCG->getNameManager ();
}


ptTraceabilityManager DCG_basic::getTraceabilityManager ()
{
  return vDCG->getTraceabilityManager ();
}

void
DCG_basic::setLocalSignals (ptlinstances lsigloc)
{
  vDCG->setLocalSignals (lsigloc);
}

ptlinstances DCG_basic::getLocalSignals ()
{
  return vDCG->getLocalSignals ();
}


void
DCG_basic::setConstants (ptlinstances lc)
{
  vDCG->setConstants (lc);
}

ptlinstances DCG_basic::getConstants ()
{
  return vDCG->getConstants ();
}

void
DCG_basic::addConstant (ptexpcal e)
{
  vDCG->addConstant (e);
}

void
DCG_basic::removeConstant (ptexpcal e)
{
  vDCG->removeConstant (e);
}


ptlINode DCG_basic::getListExternalProcedure (ptlinstances * lfuncs)
{
  return vDCG->getListExternalProcedure (lfuncs);
}

void
DCG_basic::setListExternalProc (ptlINode lprocs, ptlinstances lfuncs)
{
  vDCG->setListExternalProc (lprocs, lfuncs);
}

ptlmemnode DCG_basic::getDelaysTree ()
{
  return vDCG->getDelaysTree ();
}

void
DCG_basic::setDelaysTree (ptlmemnode dt)
{
  vDCG->setDelaysTree (dt);
}


ptlinstances DCG_basic::getListIndexes ()
{
  return vDCG->getListIndexes ();
}


void
DCG_basic::insertIndex (ptexpcal vexp)
{
  vDCG->insertIndex (vexp);
}


void
DCG_basic::setUnused (ptlINode unNodes, ptlinsth unClocks)
{
  vDCG->setUnused (unNodes, unClocks);
}

ptlINode DCG_basic::getUnused (ptlinsth * lh)
{
  return vDCG->getUnused (lh);
}


void
DCG_basic::setName (ptident id)
{
  vDCG->setName (id);
}

ptident DCG_basic::getName ()
{
  return vDCG->getName ();
}

ptident DCG_basic::getLabelStateName ()
{
  return vDCG->getLabelStateName ();
}


ptident DCG_basic::getName (ptINode vnode)
{
  return vDCG->getName (vnode);
}



ptident DCG_basic::getLevelName ()
{
  return vDCG->getLevelName ();
}

ptlinstances DCG_basic::getStatesVar ()
{
  return vDCG->getStatesVar ();
}

void
DCG_basic::setStatesVar (ptlinstances l)
{
  vDCG->setStatesVar (l);
}

void
DCG_basic::addStatesVar (ptexpcal vsig)
{
  vDCG->addStatesVar (vsig);
}

void
DCG_basic::addLocalGraph (ptDCG vgraph)
{
  vDCG->addLocalGraph (vgraph);
}

boolean
DCG_basic::getModuleGraphs (ptlDCG * lg)
{
  return vDCG->getModuleGraphs (lg);
}

boolean DCG_basic::getNullClockSignal (ptlinstances * lsig)
{
  return vDCG->getNullClockSignal (lsig);
}


boolean DCG_basic::getNullClockConstraints (ptlinsth * lh)
{
  return vDCG->getNullClockConstraints (lh);
}

void
DCG_basic::setKind (noperators op)
{
  vDCG->setKind (op);
}

noperators DCG_basic::getKind ()
{
  return vDCG->getKind ();
}


void
DCG_basic::setInputs (ptlinstances l)
{
  vDCG->setInputs (l);
}


void
DCG_basic::setOutputs (ptlinstances l)
{
  vDCG->setOutputs (l);
}

void
DCG_basic::setParameters (ptlinstances l)
{
  vDCG->setParameters (l);
}



ptlinstances DCG_basic::getInputs ()
{
  return vDCG->getInputs ();
}

ptlinstances DCG_basic::getOutputs ()
{
  return vDCG->getOutputs ();
}

ptlinstances DCG_basic::getInputsOutputs ()
{
  return vDCG->getInputsOutputs ();
}


ptlinsth DCG_basic::getImportedClocks ()
{
  return vDCG->getImportedClocks ();
}

ptlinsth DCG_basic::getExportedClocks ()
{
  return vDCG->getExportedClocks ();
}


ptlinstances DCG_basic::getParameters ()
{
  return vDCG->getParameters ();
}

void
DCG_basic::addInput (ptexpcal e)
{
  vDCG->addInput (e);
}

void
DCG_basic::addOutput (ptexpcal e)
{
  vDCG->addOutput (e);
}


void
DCG_basic::addParameter (ptexpcal e)
{
  vDCG->addParameter (e);
}

boolean DCG_basic::isEndochronous ()
{
  return vDCG->isEndochronous ();
}

void
DCG_basic::unmarkObjects (typeMark m)
{
  vDCG->unmarkObjects (m);
}

boolean DCG_basic::getNodesAtInitClock (ptlINode * ln)
{
  return vDCG->getNodesAtInitClock (ln);
}

ptldependence
DCG_basic::getExplicitDependences ()
{
  return vDCG->getExplicitDependences ();
}


ptldependence
DCG_basic::getReinforcedDependences ()
{
  return vDCG->getReinforcedDependences ();
}

ptlinsth DCG_basic::getDependencesClocks (ptlclosure lclos, ptlinsth lh)
{
  return vDCG->getDependencesClocks (lclos, lh);
}

ptlinsth
DCG_basic::getIODependencesClocks ()
{
  return vDCG->getIODependencesClocks ();
}


boolean DCG_basic::getReferencedGraphs (ptlDCG * lg)
{
  return vDCG->getReferencedGraphs (lg);
}


safetyPropertyType DCG_basic::getSafetyProperty ()
{
  return vDCG->getSafetyProperty ();
}

boolean DCG_basic::iterationPrecedences ()
{
  return vDCG->iterationPrecedences ();
}


void
DCG_basic::spatialIndicesSynthesis ()
{
  vDCG->spatialIndicesSynthesis ();
}


void
DCG_basic::spatialIndicesSynthesis (ptlINode ln)
{
  vDCG->spatialIndicesSynthesis (ln);
}


boolean DCG_basic::spatialSubstitutions ()
{
  return vDCG->spatialSubstitutions ();
}


boolean DCG_basic::spatialOptimisations ()
{
  return vDCG->spatialOptimisations ();
}

void
DCG_basic::indexDefinitionsOptimizing ()
{
  vDCG->indexDefinitionsOptimizing ();
}


boolean DCG_basic::sameDefinitionExpressionOptimizing ()
{
  return vDCG->sameDefinitionExpressionOptimizing ();
}



boolean DCG_basic::arithmeticalProgressionOptimizing ()
{
  return vDCG->arithmeticalProgressionOptimizing ();
}



void
DCG_basic::setInitialValues ()
{
  vDCG->setInitialValues ();
}

boolean DCG_basic::ConstantsUnifying ()
{
  return vDCG->ConstantsUnifying ();
}

boolean DCG_basic::eliminateWhenEvent ()
{
  return vDCG->eliminateWhenEvent ();
}


void
DCG_basic::removeUndefinedSignals ()
{
  vDCG->removeUndefinedSignals ();
}


void
DCG_basic::NodesInterfaceCalculus ()
{
  vDCG->NodesInterfaceCalculus ();
}

void
DCG_basic::delaysRewriting ()
{
  vDCG->delaysRewriting ();
}


void
DCG_basic::substituteEvaluatedExpression ()
{
  vDCG->substituteEvaluatedExpression ();
}


void
DCG_basic::interfaceReset ()
{
  vDCG->interfaceReset ();
}



void
DCG_basic::setClocksName ()
{
  vDCG->setClocksName (true);
}

void
DCG_basic::setSubstituableClocks ()
{
  vDCG->setSubstituableClocks ();
}


void
DCG_basic::setExternalReferences ()
{
  vDCG->setExternalReferences ();
}

ptINode DCG_basic::encapsulatingClockSystem ()
{
  return vDCG->encapsulatingClockSystem ();
}

void
DCG_basic::storeNullClockInfo ()
{
  vDCG->storeNullClockInfo ();
}

void
DCG_basic::storeInitClockInfo ()
{
  vDCG->storeInitClockInfo ();
}

void
DCG_basic::resetMark (int m)
{
  vDCG->resetMark (m);
}

// ptexpcal DCG_basic::addPresentNode (ptinsth vh, ptinsth clk, ptident idSig, ptident idClk)
ptexpcal DCG_basic::addPresentNode (ptinsth vh, ptinsth clk, ptexpcal vsig)
{
  return vDCG->addPresentNode (vh, clk, vsig);
}


ptexpcal DCG_basic::addBooleanInput (ptinsth vh, ptinsth clk, ptident idClk)
{
  return vDCG->addBooleanInput (vh, clk, idClk);
}

void
DCG_basic::updatePragmas ()
{
  vDCG->updatePragmas ();
}

void
DCG_basic::removeNodes (ptlINode ln, ptlinsth lh)
{
  vDCG->removeNodes (ln, lh);
}


void
DCG_basic::removeNode (ptINode node)
{
  vDCG->removeNode (node);
}

void
DCG_basic::explicitConversions ()
{
  vDCG->explicitConversions ();
}


void
DCG_basic::garbageTypes ()
{
  vDCG->garbageTypes ();
}

void
DCG_basic::maskOutputs ()
{
  vDCG->maskOutputs ();
}

boolean
DCG_basic::getUserTypesOneLevel (ptlinstances * lTypes)
{
  return vDCG->getUserTypesOneLevel (lTypes);
}


boolean DCG_basic::checkExplicitTyping ()
{
  return vDCG->checkExplicitTyping ();
}

boolean DCG_basic::setArrayClocks ()
{
  return vDCG->setArrayClocks ();
}

boolean DCG_basic::splitDataStructure ()
{
  return vDCG->splitDataStructure ();
}


boolean DCG_basic::setClockDependences ()
{
  return vDCG->setClockDependences ();
}


void
DCG_basic::setComposedNodesDependences ()
{
  vDCG->setComposedNodesDependences ();
}

boolean DCG_basic::isStaticCycleFree (boolean bmess, boolean bKeepCycles)
{
  return vDCG->isStaticCycleFree (bmess, bKeepCycles);
}


ptlINode DCG_basic::getTaggedNodes (int pragmaName)
{
  return vDCG->getTaggedNodes (pragmaName);
}

void
DCG_basic::finalyzeBinPart (ptlINode lSubGraphs, ptINode * part1, ptINode * part2)
{
  vDCG->finalyzeBinPart (lSubGraphs, part1, part2);
}

void
DCG_basic::DontOptimizeSignals (ptlinstances ls)
{
  vDCG->DontOptimizeSignals (ls);
}


// ============

ptlpragmas DCG_basic::getPragmas (void)
{
  return vDCG->getPragmas ();
}

void
DCG_basic::setPragmas (ptlpragmas l)
{
  vDCG->setPragmas (l);
}

boolean DCG_basic::addPragma (ptpragma aPragma)
{
  return vDCG->addPragma (aPragma);
}

boolean DCG_basic::removePragma (ptrepstr name)
{
  return vDCG->removePragma (name);
}

void
DCG_basic::addPragmas (ptlpragmas pragmas)
{
  vDCG->addPragmas (pragmas);
}

void
DCG_basic::addMark (typeMark val)
{
  return vDCG->addMark (val);
}

boolean DCG_basic::satisfiesMarked (typeMark val)
{
  return vDCG->satisfiesMarked (val);
}

void
DCG_basic::removeMark (typeMark val)
{
  vDCG->removeMark (val);
}

boolean DCG_basic::getAttribute (int num, attributeValue * valAttribute)
{
  return vDCG->getAttribute (num, valAttribute);
}

void
DCG_basic::addAttribute (int num, attributeValue vattr)
{
  vDCG->addAttribute (num, vattr);
}

void
DCG_basic::removeAttribute (int num)
{
  vDCG->removeAttribute (num);
}

boolean DCG_basic::undersamplingOnSignal (boolean bkeepCondIO, boolean keepLogicalOperators)
{
  return vDCG->undersamplingOnSignal (bkeepCondIO, keepLogicalOperators);
}


void
DCG_basic::lefttts2defaults ()
{
  vDCG->lefttts2defaults ();
}


void
DCG_basic::rewDefinitions ()
{
  vDCG->rewDefinitions ();
}


boolean DCG_basic::isVerboseMode ()
{
  return vDCG->isVerboseMode ();
}


boolean DCG_basic::setVerboseMode (boolean b)
{
  return vDCG->setVerboseMode (b);
}



/**
   It partitions the nodes of a subgraph by clocks.
*/
void
DCG_basic::nodeGroupingByClocks (ptINode aSubGraph)
{
  vDCG->nodeGroupingByClocks (aSubGraph);
}

/**
   @returns "true" if the graph is a graph of a module.
*/
boolean
DCG_basic::isModule ()
{
  return vDCG->isModule ();
}

/**
   @return "true" if the graph is an endochronous with internal root clock one, "false" otherwise.
*/
boolean
DCG_basic::isEndochronousWithInternalClockRoot (ptinsth *vhComplete)
{
  return vDCG->isEndochronousWithInternalClockRoot (vhComplete);
}


/**
   It sets the IO step clock of the program to h.
*/
void
DCG_basic::setIOstep (ptinsth h)
{
  vDCG->setIOstep (h);
}


/**
   @return the IO step clock of the program computed in computeIOstep().
 */
ptinsth DCG_basic::getIOstep ()
{
  return vDCG->getIOstep ();
}


/**
   It sets the step clock of the program to h.
*/
void
DCG_basic::setStep (ptinsth h)
{
  vDCG->setStep (h);
}


/**
   @return the step clock of the program computed in computeStep().
 */
ptinsth DCG_basic::getStep ()
{
  return vDCG->getStep ();
}


/** 
    It assigns an automaton (vauto) to the graph.
*/
void
DCG_basic::setAutomaton (ptAutomaton vauto)
{
  vDCG->setAutomaton (vauto);
}

/**
   @return true if an automaton (vautomat) is assigned to the graph, false otherwise.
 */
boolean DCG_basic::getAutomaton (ptAutomaton * vauto)
{
  return vDCG->getAutomaton (vauto);
}

ptinterface
DCG_basic::getInterface ()
{
  return vDCG->getInterface ();
}

void
DCG_basic::mkListOfStatesVariables (ptinsth vclk, boolean b_inner, ptlinstances * lStatesVar)
{
  vDCG->mkListOfStatesVariables (vclk, b_inner, lStatesVar);
}

/**
   It adds at the begining/at the end (depending on the value of the b_inner) of lStatesVar the boolean state variables assigned to a clock (vclk).
*/
void
DCG_basic::getDelayedSignalsAt (ptinsth vclk, boolean b_inner, ptlinstances * lStatesVar)
{
  vDCG->getDelayedSignalsAt (vclk, b_inner, lStatesVar);
}

/**
   @return the number assigned to the graph.
*/
int
DCG_basic::getGraphNumber ()
{
  return vDCG->getGraphNumber ();
}


boolean DCG_basic::getIthRoot(integer n, ptinsth *vr)
{
  return  vDCG->getIthRoot (n, vr);
}


boolean DCG_basic::getNextFreeRoot(ptinsth vh, ptinsth *vr)
{
  return  vDCG->getNextFreeRoot (vh, vr);
}


/**
   It sets the Complete clock of the program to h.
*/
void
DCG_basic::setCompleteClock (ptinsth h)
{
  vDCG->setCompleteClock (h);
}


/**
   @return the Complete clock of the program.
 */
ptinsth DCG_basic::getCompleteClock ()
{
  return vDCG->getCompleteClock ();
}
