/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

// Treated pragmas by Signal environment.
// -------------------------------------

// no comment!
#define PRAGMA_COMMENT 0 

// Compiling directive : it specifies the entry points to compile in a module.
#define PRAGMA_MAIN  1

// Difference UNEXPANDED/SEPARATE ?
#define PRAGMA_UNEXPANDED 2
// #define PRAGMA_SEPARATE 3

// Separated Compilation
#define PRAGMA_CLUSTER  4
#define PRAGMA_BLACK_BOX  5
#define PRAGMA_GREY_BOX  6
#define PRAGMA_DELAYCLUSTER  7

// Code Generator directive
// The user can specify its own code for external model
#define PRAGMA_CODEGEN_C  8
#define PRAGMA_CODEGEN_CPP  9
#define PRAGMA_CODEGEN_JAVA  10
#define PRAGMA_CODEGEN_C_IMPORT 11
#define PRAGMA_CODEGEN_CPP_IMPORT 12
#define PRAGMA_CODEGEN_JAVA_IMPORT 13

#define PRAGMA_CODEGEN_C_DECLARE 14
#define PRAGMA_CODEGEN_CPP_DECLARE 15
#define PRAGMA_CODEGEN_JAVA_DECLARE 16

// Added by the translators to Signal (AADL, P,...) to SIGNAL
#define PRAGMA_GENERATED_FROM 17

// Link with Sigali tool.
#define PRAGMA_SIGALI  18

// Profiling
#define PRAGMA_PROCESSOR_TYPE 19

// Added by the compiler to specify that the clock system has been solved 
#define PRAGMA_DEFINED_CLOCK_HIERARCHY  20

// Partitionning information RunOn <string>
#define PRAGMA_RUN_ON  21

// Distributed code generation.
#define PRAGMA_COMM_ENV      22
#define PRAGMA_COMM_RECEIVE  23
#define PRAGMA_COMM_SEND     24

#define PRAGMA_TOPOLOGY      25
#define PRAGMA_TARGET        26

#define PRAGMA_SELECTED_OTHERS_PARTITION  27
#define PRAGMA_MORPHISM     28

// PRAGMA_BINDING alias of PRAGMA_RUN_ON
#define PRAGMA_BINDING   29
#define PRAGMA_BINDINGIO 30

#define PRAGMA_PROCESSOR_NAME 31
#define PRAGMA_BUS            32
#define PRAGMA_CONNECTION     33

// Added to a model to specify that this model is a Thread Signal 
// The first input of the model is the Dispatch signal, and it is compiled in seperated mode.
#define PRAGMA_SIGNAL_THREAD 34

// Added by the compiler to specify that the model is Poly-Endochronous.
#define PRAGMA_POLYCHRONOUS_PROCESS 35

// Misc. 
#define PRAGMA_RESTRICTED_MODES 36
// Assigned to a node specifying a conversion. The C code for integer(x) will be (int) x
#define PRAGMA_CONVERSION  37

#define LAST_PRAGMA_NUMBER PRAGMA_CONVERSION
#define NB_PREDEFINED_PRAGMAS LAST_PRAGMA_NUMBER

// Removed Feb 2020 LBesnard
// #define PRAGMA_NOTE  1
// #define PRAGMA_CODEGEN_THREADSJAVA  13
// #define PRAGMA_CODEGEN_VHDL  14
// #define PRAGMA_MASTER        22
// #define PRAGMA_SLAVES        23
