/* 
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/

_PRIVATE_
/** Initializing the default values for all the options. */
  void
OptionManager::setopt_init ()
{
  /* ====> input file options */
  in_isf = pk_false;
  setCommandFile ((char *) 0);
  srcFileDefined = pk_false;
  readParamFile = pk_false;
  paramFileDefined = pk_false;

  /* ====> output file options */
  out_isf = pk_false;
  outputDirDefined = pk_false;
  targetDirDefined = pk_false;
  opt_warn = pk_false;
  opt_verbose = pk_false;
  opt_cosimulation = pk_false;
  opt_keeprew = pk_false;
  opt_trace_samplingAsWhen = pk_false;	///< printing the unary when as "when" when it is pk_true, [: ] otherwise.
  opt_trace_unstructuredProcess = pk_false;	///< printing structured process

/* ====> graph class transformation options */
  opt_basicGraph = pk_false;
  opt_tracebasic = pk_false;
  opt_polyGraph = pk_false;
  opt_tracepoly = pk_false;
  opt_endoGraph = pk_false;
  opt_traceendo = pk_false;
  opt_boolGraph = pk_false;
  opt_tracebool = pk_false;
  opt_sbdcGraph = pk_false;
  opt_tracesbdc = pk_false;
  opt_flatGraph = pk_false;
  opt_traceflat = pk_false;
  opt_monoGraph = pk_false;
  opt_tracemono = pk_false;

  /* ====> kind of output */
  opt_traceAllowed = pk_true;
  opt_genFile = pk_false;
  opt_list = pk_false;
  opt_traceNone = pk_true;
  opt_traceALL = pk_false;
  opt_sme = pk_false;
  opt_ssme = pk_false;
  opt_geneauto = pk_false;  // also called P.
  opt_abstraction = pk_false;
  opt_header = pk_false;     /* Loic *////< to build the header from a Signal module.
  opt_Exclusive_Clock = pk_false;
  ecLevel = -1; 

  /* ====> graph options */
  setstd_solvingDepth_opt ();

  opt_retiming = pk_false;
  opt_crew_bool_ctrl = pk_false;
  opt_crew_bool_all = pk_false;
  opt_crew_definitions = pk_false;
  opt_crew_statics = pk_false;
  opt_us = pk_false;
  opt_default_splitting = pk_false;
  opt_partialdef_merging = pk_false;
  opt_default_normal = pk_false;
  set_run_signalSubstitution_opt (0);
  opt_delayMultiplexing = pk_true;
  opt_delayOptimizing = pk_true;
  opt_kernel = pk_false;
  opt_splitDataStructure = pk_false;
  opt_enum2Integer = pk_false;


  opt_utility_clock = pk_false;	///< Optimisations using the utility clock.
  opt_check = pk_false;		/* dynamically check clock constraints of the Poly; sub option of -force ??  */
  opt_distrib = pk_false;		///< distributed code option.
  opt_polyendo = pk_false;    /* polyendochronous hierarchy */

  /* ====> partition options */
  opt_states_others = pk_false;
  opt_bool_others = pk_false;
  opt_finiteTypes_others = pk_false;
  opt_clustering = pk_false;
  opt_tagBased_partition = pk_false;

  /* ====> kind of exported file */
  opt_filedot = pk_false;
  opt_alwaysCode = pk_false;

  opt_exportFile = pk_false;
  opt_filez3z = pk_false;
  opt_tracez3z = pk_false;
  opt_filesmt = pk_false;
  opt_tracesmt = pk_false;

  opt_filelustre = pk_false;
  opt_tracelustre = pk_false;
  opt_c_modubody = pk_false;
  opt_c_modumain = pk_false;
  opt_c_moduio = pk_false;
  opt_tracec = pk_false;
  opt_cpp_modubody = pk_false;
  opt_cpp_modumain = pk_false;
  opt_cpp_moduio = pk_false;
  opt_tracecpp = pk_false;
  opt_java_modubody = pk_false;
  opt_java_modumain = pk_false;
  opt_java_moduio = pk_false;
  opt_java = pk_false;
  opt_tracejava = pk_false;
  opt_threads = pk_false;
  opt_filesyndex = pk_false;
  opt_tracesyndex = pk_false;
  opt_export_profiling = pk_false;
  opt_vhdl = pk_false;
  opt_verilog = pk_false;

/* ====> listing options */
  opt_stat = pk_false;
  opt_debug = pk_false;		/* (as WAR) detailed debug information in TRA */

/* ====> wizzard option */
  opt_test_function = pk_false;	/* Loic */
  setTestName ("");		/* Loic *//// -test=string
  opt_synoptic = pk_false; ///< synoptic representation of the signal program.

}
