
(setq CST1 "public final static int ")

(defun :replaceString(str1 str2)

    (goto-char (point-min))
    (replace-string str1 str2)
)

(defun :addJavaSyntacticForConstants()
  
  (goto-char (point-min))
  (while (search-forward "public final static int " nil t)
    (search-forward " " nil t)
    (insert "=")
    (forward-word 1)
    (insert ";")
    )
  )

(defun :killLinesAfter (TheString)
  (goto-char (point-min))
  (if (not (search-forward TheString nil t))
      ()
    (end-of-line)
    (setq point1 (point))
    (kill-region (point) (point-max))
    (goto-char (point-min))
    (goto-char (point-max))
    (insert "\n\n}")
    )
)

(defun :killLicense()
 (let (point1  point2)
   (goto-char (point-min))
   (if (not (search-forward "/*" nil t))
     ()
   (setq point1 ( - (point) 2))
   (if (not (search-forward "*/" nil t))
       ()
     (setq point2 (point))
     (kill-region point1 point2)
     )
   )
   )
)

(defun :AddEclipsePackage ()
 (goto-char (point-min))
 (insert  "/*******************************************************************************
 * Copyright (c) 2010, 2014 INRIA-CNRS (Espresso/TEA team).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Loic Besnard, Francois Fabre, Thierry Gautier: Initial API and implementation and/or initial documentation
 */")
 (insert  "\n")
 (insert  "package org.eclipse.pop.ssme.polychrony;")
 (insert  "\n")
 ;; 
 (insert "/*\n")
 (insert "  This file was automatically generated from (opersignal.h) C version")
 (insert "   Manual editing not recommended.\n") 
 (insert "*/\n\n")
 )


(defun :apply()
  ; cleaning
  (:killLicense)
  (:killLinesAfter "SIG_NB_OPERATORS")
  ; translating
  (:replaceString "#ifndef __OPERSIG__" "public class SignalOperators")
  (:replaceString "#define __OPERSIG__" "{")
  (:replaceString "#define " "     public final static int ")
  (:addJavaSyntacticForConstants)
  (:AddEclipsePackage)

  (if (buffer-modified-p) (write-file (concat "SignalOperators.java") ())
  (kill-buffer (current-buffer))
  )
)


(defun :applyOn (filename)
  (find-file  (concat "./" filename))
  (:apply)
)




(:applyOn "opersignal.h")

