; call by the command : gnu-emacs -batch -l clean_doc_file.el



(defun :SelectAndDocify (aString)
  (let (pt1 pt2)
    (goto-char (point-min))

    (while (search-forward aString nil t)
      (setq pt2 (point))
      (search-forward "}" nil t)
      (setq pt1 (point))
      (kill-region pt1 pt2)
      (switch-to-buffer "_tmpBuffer")
      (yank)
      (goto-char (point-min))
      (:replaceString "," ( concat (concat "}, " aString) "{"))
      (goto-char (point-min))
      (:replaceString "{ " "{")
      (kill-region (point-min) (point-max))
;      (switch-to-other-buffer)
      (kill-buffer (current-buffer))
      (yank)
      )
    )
)



(defun :DOCIFY_SEEALSO ()
;  (goto-char (point-min))
  (:replaceString "_SEE_ALSO_" "@see")
;  (goto-char (point-min))
  (:replaceString "_SEEALSO_" "@see")
)

(defun :DOCIFY_SEETEXT ()

)

(defun :DOCIFY_ACCESS ()
  (:SelectAndDocify "_ACCESS")
;  (goto-char (point-min))
  (:replaceString "_ACCESS" "Access to the structure by : \\Ref")
)

(defun :DOCIFY_REF ()
  (:SelectAndDocify "_REF_")
;  (goto-char (point-min))
  (:replaceString "_REF_" " \\Ref")
)

(defun :DOCIFY_REFERENCEDONLY ()
  (:SelectAndDocify "_REFERENCEDONLY_")
;  (goto-char (point-min))
  (:replaceString "_REFERENCEDONLY_" "Referenced only in \\Ref")
)

(defun :DOCIFY_LINK ()
  (:replaceString "_LINK_" "\\URL")
)

(defun :DOCIFY_KW ()
  (let (pt1 pt2)
    (goto-char (point-min))

    (while (search-forward "_KW_" nil t)
      (setq pt2 (- (point) 4))
      (search-forward "}" nil t)
      (setq pt1 (point))
      (kill-region pt1 pt2)
      (yank)
      (:addLine)
      (switch-to-buffer "_tmpBuffer")
      (yank)
      (:replaceString "_KW_" "@memo ")
      (:replaceString "{" "")
      (:replaceString "}" "")
      (kill-region (point-min) (point-max))
      (kill-buffer (current-buffer))
      (search-forward "*/" nil t)
      (goto-char (- (point) 2))
      (:addLine)
      (yank)
      )
    (:replaceString "_KW_" "")
    )
)

; _DOC{ <texte> } becomes {\em <texte>}
(defun :DOCIFY_DOC ()
  (goto-char (point-min))
  
  (while (search-forward "_DOC_" nil t)
    (search-forward "{" nil t)
    (insert "\\em ")
    )
  (:replaceString "_DOC_" "")
)

(defun :DOCIFY_KEYWORDS ()
;  (:replaceString "_ADRDOC_" "/udd/lbesnard/signal.dir/V4.13.7_Oct00.dir/doc_CC/other_doc.dir")
  (:DOCIFY_SEEALSO)
  (:DOCIFY_SEETEXT)
  (:DOCIFY_ACCESS)
  (:DOCIFY_REF)
  (:DOCIFY_REFERENCEDONLY)
  (:DOCIFY_KW) ; --> memo
  (:DOCIFY_DOC)
  (:DOCIFY_LINK)
)


(defun :clean_doc_file_old ()
  (let (pt1 pt2)
    (goto-char (point-min))
    (setq pt1 (point))
    (while (search-forward "/*" nil t)
      (setq pt2 (- (point) 2 ))
      (kill-region pt1 pt2)
      (search-forward "*/" nil t)
      (search-forward ";" nil t)
      (setq pt1 (+ (point) 2))
      )
    )
)


(defun :clean_doc_file ()
  (goto-char (point-min))
  (while (search-forward-regexp "^Function:" (point-max) t 1 )
    (beginning-of-line)
    (kill-line 1)
    )
  (goto-char (point-min))
  (while (search-forward-regexp "^File:" (point-max) t 1 )
    (beginning-of-line)
    (kill-line 1)
    )
)


(defun :replaceString(str1 str2)
;--------------------------------------------------------------------------------
; Replacing str1 string by str2 string
;--------------------------------------------------------------------------------
  (goto-char (point-min))
  (replace-string str1 str2)
  )


(defun :mkCppSyntax ()
  (:replaceString "_INIT_" "/*")
  (:replaceString "_ENDINIT_" "*/")
  
  (:replaceString "_VIRTUAL_" "virtual")
  (:replaceString "_PROTECTED_" "protected:")
  (:replaceString "_PUBLIC_" "public:")
  (:replaceString "_PRIVATE_" "private:")
  )

(defun :apply1 ()
  (:mkCppSyntax )
;  (:clean_doc_file)
;  (save-buffer)
  (if (buffer-modified-p) (save-buffer))
  (kill-buffer (current-buffer))
)

(defun :apply2 ()
; (:mkCppSyntax )
  (:clean_doc_file)
  (:DOCIFY_KEYWORDS)
;  (save-buffer)
  (if (buffer-modified-p) (save-buffer))
  (kill-buffer (current-buffer))
)



; Exemple d'applications 

(defun :apply (filename)
  (find-file  (concat "./" filename) )
  (:clean_doc_file)
  (write-file filename)
  (kill-buffer (current-buffer))
)


;(:apply "tabtools_m.c")
;(:apply "intebddpackage_g.doc")
;(:apply "list_g.doc")
