(defun scroll-up-in-place ()
 (interactive)
  (next-line 1)
  (scroll-up 1)
)
(defun scroll-down-in-place ()
 (interactive)
  (previous-line 1)
  (scroll-down 1)
)
(global-unset-key "\e[")
(global-set-key "\e[211z" 'scroll-down-in-place) ;; R4
(global-set-key "\e[212z" 'split-window-vertically) ;; R5
(global-set-key "\e[213z" 'scroll-up-in-place) ;; R6
(global-set-key "\e[214z" 'beginning-of-line) ;; R7
(global-set-key "\e[216z" 'end-of-line) ;; R9
(global-set-key "\e[218z" 'describe-bindings) ;; R11
(global-set-key "\e[220z" 'backward-word) ;; R13
(global-set-key "\e[222z" 'forward-word) ;; R15
(global-set-key "\e[-1z" 'goto-line) ;; Ins
(global-set-key "\e[195z" 'undo) ;; Undo

(defun c-set-holo-cur-ind ()
  "Rend invisible toute ligne dont l'indentation est superieure a celle de la
ligne courante."
  (interactive)
  (set-selective-display (+ (current-indentation) c-indent-level))
  )

(global-set-key  "\[227z" 'c-set-holo-cur-ind) ;; F4

(defun c-incr-holo ()
  "Augmente d'une unite' la valeur d'indentation courante invisible."
  (interactive)
  (set-selective-display (- selective-display c-indent-level))
  )

(global-set-key "\[228z" 'c-incr-holo) ;; F5

(defun c-decr-holo ()
  "Diminue d'une unite' la valeur d'indentation courante invisible."
  (interactive)
  (set-selective-display (+ selective-display c-indent-level))
  )

(global-set-key  "\[229z" 'c-decr-holo) ;; F6

(defun c-unset-holo ()
  "Rend toutes les lignes visibles"
  (interactive)
  (set-selective-display 0)
  )

(global-set-key "\[230z" 'c-unset-holo) ;; F7


(defun show-def-keys ()
  (interactive)
;  (debug)
  (if (not (get-buffer-window "pave_num_gnux.help"))
      (progn
	(if (not (get-buffer "pave_num_gnux.help"))
	    (if(file-exists-p "/tmp_mnt/home/prompto/d02/epatr/cheron/utl/pave_num_gnux.help")
		(find-file-read-only "/tmp_mnt/home/prompto/d02/epatr/cheron/utl/pave_num_gnux.help")
	      (error "Fichier pave_num_gnux.help inaccessible : verifiez dans le fichier de config")
	      )
	  )
	(display-buffer "pave_num_gnux.help")
	)
    (delete-window (get-buffer-window "pave_num_gnux.help"))
    )
  )

(global-set-key "\[-1z" 'show-def-keys) ;; Help

(defun recup-pred-word ()
"Complete le mot commence par le premier mot rencontre avant dans le
texte commencant par les memes caracteres."
  (interactive)
;  (debug)
  (save-excursion
    (let (dw (cp (point)) (save-syntax (char-to-string 
					(char-syntax (string-to-char "_")))))
      (modify-syntax-entry ?_ "w")
      (setq dw (concat "\\b" 
		       (regexp-quote
			(buffer-substring
			 (save-excursion
			   (backward-word 1)
			   (point)
			   )
			 (point)
			 )
			)
		       )
	    )
      (backward-word 1)
      (if (re-search-backward dw nil t)
	  (progn
	    (let ((rw (buffer-substring
		       (point)
		       (save-excursion
			 (forward-word 1)
			 (point)
			 )
		       )
		      )
		  )
	      (goto-char cp)
	      (backward-kill-word 1)
	      (insert rw)
	      )
	    )
	  (modify-syntax-entry ?_ save-syntax)
	  (error "Pas vu, pas pris!!")
	  )
      (modify-syntax-entry ?_ save-syntax)
      )
    )
  (forward-word 1)
  )

(global-set-key "\[231z" 'recup-pred-word) ;; F8


(load-file "/home/prompto/d02/epatr/editgraph/sigtra.el")
(message "Help --> Description des touches fonctions")
